      ******************************************************************
      **                                                              **
      **                      IBM MQ for Windows                      **
      **                                                              **
      **  FILE NAME:      CMQGMOV                                     **
      **                                                              **
      **  DESCRIPTION:    MQGMO Structure -- Get Message Options      **
      **                                                              **
      ******************************************************************
      **  <copyright                                                  **
      **  notice="lm-source-program"                                  **
      **  pids="5724-H72,5655-R36,5724-L26"                           **
      **  years="1993,2024"                                           **
      **  crc="1616507131" >                                          **
      **  Licensed Materials - Property of IBM                        **
      **                                                              **
      **  5724-H72                                                    **
      **                                                              **
      **  (C) Copyright IBM Corp. 1993, 2024 All Rights Reserved.     **
      **                                                              **
      **  US Government Users Restricted Rights - Use, duplication or **
      **  disclosure restricted by GSA ADP Schedule Contract with     **
      **  IBM Corp.                                                   **
      **  </copyright>                                                **
      ******************************************************************
      **                                                              **
      **  FUNCTION:       This file declares the structure MQGMO,     **
      **                  which is used by the main MQI.              **
      **                                                              **
      **  PROCESSOR:      COBOL                                       **
      **                                                              **
      ******************************************************************

      ******************************************************************
      ** <BEGIN_BUILDINFO>                                            **
      ** Generated on:  04/04/24 17:22                                **
      ** Build Level:   p930-017-240404                               **
      ** Build Type:    Production                                    **
      ** Pointer Size:  32 Bit                                        **
      ** Source File:                                                 **
      ** CMQGMOV                                                      **
      ** <END_BUILDINFO>                                              **
      ******************************************************************

      ** MQGMO structure
       10  MQGMO.
      ** Structure identifier
       15  MQGMO-STRUCID PIC X(4) VALUE 'GMO '.
      ** Structure version number
       15  MQGMO-VERSION PIC S9(9) BINARY VALUE 1.
      ** Options that control the action of MQGET
       15  MQGMO-OPTIONS PIC S9(9) BINARY VALUE 0.
      ** Wait interval
       15  MQGMO-WAITINTERVAL PIC S9(9) BINARY VALUE 0.
      ** Signal
       15  MQGMO-SIGNAL1 PIC S9(9) BINARY VALUE 0.
      ** Signal identifier
       15  MQGMO-SIGNAL2 PIC S9(9) BINARY VALUE 0.
      ** Resolved name of destination queue
       15  MQGMO-RESOLVEDQNAME PIC X(48) VALUE SPACES.
      ** Ver:1 **
      ** Options controlling selection criteria used for MQGET
       15  MQGMO-MATCHOPTIONS PIC S9(9) BINARY VALUE 3.
      ** Flag indicating whether message retrieved is in a group
       15  MQGMO-GROUPSTATUS PIC X VALUE ' '.
      ** Flag indicating whether message retrieved is a segment of a
      ** logical message
       15  MQGMO-SEGMENTSTATUS PIC X VALUE ' '.
      ** Flag indicating whether further segmentation is allowed for
      ** the message retrieved
       15  MQGMO-SEGMENTATION PIC X VALUE ' '.
      ** Reserved
       15  MQGMO-RESERVED1 PIC X VALUE ' '.
      ** Ver:2 **
      ** Message token
       15  MQGMO-MSGTOKEN PIC X(16) VALUE LOW-VALUES.
      ** Length of message data returned (bytes)
       15  MQGMO-RETURNEDLENGTH PIC S9(9) BINARY VALUE -1.
      ** Ver:3 **
      ** Reserved
       15  MQGMO-RESERVED2 PIC S9(9) BINARY VALUE 0.
      ** Message handle
       15  MQGMO-MSGHANDLE PIC S9(18) BINARY VALUE 0.
      ** Ver:4 **


      ******************************************************************
      **  End of CMQGMOV                                              **
      ******************************************************************
