      ******************************************************************
      **                                                              **
      **                      IBM MQ for Windows                      **
      **                                                              **
      **  FILE NAME:      CMQCFV                                      **
      **                                                              **
      **  DESCRIPTION:    Declarations for PCF and Events             **
      **                                                              **
      ******************************************************************
      **  <copyright                                                  **
      **  notice="lm-source-program"                                  **
      **  pids="5724-H72,5655-R36,5724-L26"                           **
      **  years="1993,2024"                                           **
      **  crc="1616507131" >                                          **
      **  Licensed Materials - Property of IBM                        **
      **                                                              **
      **  5724-H72                                                    **
      **                                                              **
      **  (C) Copyright IBM Corp. 1993, 2024 All Rights Reserved.     **
      **                                                              **
      **  US Government Users Restricted Rights - Use, duplication or **
      **  disclosure restricted by GSA ADP Schedule Contract with     **
      **  IBM Corp.                                                   **
      **  </copyright>                                                **
      ******************************************************************
      **                                                              **
      **  FUNCTION:       This file declares the functions,           **
      **                  structures and named constants for PCF      **
      **                  and event messages.                         **
      **                                                              **
      **  PROCESSOR:      COBOL                                       **
      **                                                              **
      ******************************************************************

      ******************************************************************
      ** <BEGIN_BUILDINFO>                                            **
      ** Generated on:  04/04/24 17:22                                **
      ** Build Level:   p930-017-240404                               **
      ** Build Type:    Production                                    **
      ** Pointer Size:  64 Bit                                        **
      ** Source File:                                                 **
      ** CMQCFV                                                       **
      ** <END_BUILDINFO>                                              **
      ******************************************************************

      ******************************************************************
      **  Values Related to MQCFH Structure                        
      ******************************************************************
      ** Structure Length
       10  MQCFH-STRUC-LENGTH   PIC S9(9) BINARY VALUE 36.

      ** Structure Version Number
       10  MQCFH-VERSION-1   PIC S9(9) BINARY VALUE 1.
       10  MQCFH-VERSION-2   PIC S9(9) BINARY VALUE 2.
       10  MQCFH-VERSION-3   PIC S9(9) BINARY VALUE 3.
       10  MQCFH-CURRENT-VERSION   PIC S9(9) BINARY VALUE 3.

      ** Command Codes
       10  MQCMD-NONE   PIC S9(9) BINARY VALUE 0.
       10  MQCMD-CHANGE-Q-MGR   PIC S9(9) BINARY VALUE 1.
       10  MQCMD-INQUIRE-Q-MGR   PIC S9(9) BINARY VALUE 2.
       10  MQCMD-CHANGE-PROCESS   PIC S9(9) BINARY VALUE 3.
       10  MQCMD-COPY-PROCESS   PIC S9(9) BINARY VALUE 4.
       10  MQCMD-CREATE-PROCESS   PIC S9(9) BINARY VALUE 5.
       10  MQCMD-DELETE-PROCESS   PIC S9(9) BINARY VALUE 6.
       10  MQCMD-INQUIRE-PROCESS   PIC S9(9) BINARY VALUE 7.
       10  MQCMD-CHANGE-Q   PIC S9(9) BINARY VALUE 8.
       10  MQCMD-CLEAR-Q   PIC S9(9) BINARY VALUE 9.
       10  MQCMD-COPY-Q   PIC S9(9) BINARY VALUE 10.
       10  MQCMD-CREATE-Q   PIC S9(9) BINARY VALUE 11.
       10  MQCMD-DELETE-Q   PIC S9(9) BINARY VALUE 12.
       10  MQCMD-INQUIRE-Q   PIC S9(9) BINARY VALUE 13.
       10  MQCMD-REFRESH-Q-MGR   PIC S9(9) BINARY VALUE 16.
       10  MQCMD-RESET-Q-STATS   PIC S9(9) BINARY VALUE 17.
       10  MQCMD-INQUIRE-Q-NAMES   PIC S9(9) BINARY VALUE 18.
       10  MQCMD-INQUIRE-PROCESS-NAMES   PIC S9(9) BINARY VALUE 19.
       10  MQCMD-INQUIRE-CHANNEL-NAMES   PIC S9(9) BINARY VALUE 20.
       10  MQCMD-CHANGE-CHANNEL   PIC S9(9) BINARY VALUE 21.
       10  MQCMD-COPY-CHANNEL   PIC S9(9) BINARY VALUE 22.
       10  MQCMD-CREATE-CHANNEL   PIC S9(9) BINARY VALUE 23.
       10  MQCMD-DELETE-CHANNEL   PIC S9(9) BINARY VALUE 24.
       10  MQCMD-INQUIRE-CHANNEL   PIC S9(9) BINARY VALUE 25.
       10  MQCMD-PING-CHANNEL   PIC S9(9) BINARY VALUE 26.
       10  MQCMD-RESET-CHANNEL   PIC S9(9) BINARY VALUE 27.
       10  MQCMD-START-CHANNEL   PIC S9(9) BINARY VALUE 28.
       10  MQCMD-STOP-CHANNEL   PIC S9(9) BINARY VALUE 29.
       10  MQCMD-START-CHANNEL-INIT   PIC S9(9) BINARY VALUE 30.
       10  MQCMD-START-CHANNEL-LISTENER   PIC S9(9) BINARY VALUE 31.
       10  MQCMD-CHANGE-NAMELIST   PIC S9(9) BINARY VALUE 32.
       10  MQCMD-COPY-NAMELIST   PIC S9(9) BINARY VALUE 33.
       10  MQCMD-CREATE-NAMELIST   PIC S9(9) BINARY VALUE 34.
       10  MQCMD-DELETE-NAMELIST   PIC S9(9) BINARY VALUE 35.
       10  MQCMD-INQUIRE-NAMELIST   PIC S9(9) BINARY VALUE 36.
       10  MQCMD-INQUIRE-NAMELIST-NAMES   PIC S9(9) BINARY VALUE 37.
       10  MQCMD-ESCAPE   PIC S9(9) BINARY VALUE 38.
       10  MQCMD-RESOLVE-CHANNEL   PIC S9(9) BINARY VALUE 39.
       10  MQCMD-PING-Q-MGR   PIC S9(9) BINARY VALUE 40.
       10  MQCMD-INQUIRE-Q-STATUS   PIC S9(9) BINARY VALUE 41.
       10  MQCMD-INQUIRE-CHANNEL-STATUS   PIC S9(9) BINARY VALUE 42.
       10  MQCMD-CONFIG-EVENT   PIC S9(9) BINARY VALUE 43.
       10  MQCMD-Q-MGR-EVENT   PIC S9(9) BINARY VALUE 44.
       10  MQCMD-PERFM-EVENT   PIC S9(9) BINARY VALUE 45.
       10  MQCMD-CHANNEL-EVENT   PIC S9(9) BINARY VALUE 46.
       10  MQCMD-DELETE-PUBLICATION   PIC S9(9) BINARY VALUE 60.
       10  MQCMD-DEREGISTER-PUBLISHER   PIC S9(9) BINARY VALUE 61.
       10  MQCMD-DEREGISTER-SUBSCRIBER   PIC S9(9) BINARY VALUE 62.
       10  MQCMD-PUBLISH   PIC S9(9) BINARY VALUE 63.
       10  MQCMD-REGISTER-PUBLISHER   PIC S9(9) BINARY VALUE 64.
       10  MQCMD-REGISTER-SUBSCRIBER   PIC S9(9) BINARY VALUE 65.
       10  MQCMD-REQUEST-UPDATE   PIC S9(9) BINARY VALUE 66.
       10  MQCMD-BROKER-INTERNAL   PIC S9(9) BINARY VALUE 67.
       10  MQCMD-ACTIVITY-MSG   PIC S9(9) BINARY VALUE 69.
       10  MQCMD-INQUIRE-CLUSTER-Q-MGR   PIC S9(9) BINARY VALUE 70.
       10  MQCMD-RESUME-Q-MGR-CLUSTER   PIC S9(9) BINARY VALUE 71.
       10  MQCMD-SUSPEND-Q-MGR-CLUSTER   PIC S9(9) BINARY VALUE 72.
       10  MQCMD-REFRESH-CLUSTER   PIC S9(9) BINARY VALUE 73.
       10  MQCMD-RESET-CLUSTER   PIC S9(9) BINARY VALUE 74.
       10  MQCMD-TRACE-ROUTE   PIC S9(9) BINARY VALUE 75.
       10  MQCMD-REFRESH-SECURITY   PIC S9(9) BINARY VALUE 78.
       10  MQCMD-CHANGE-AUTH-INFO   PIC S9(9) BINARY VALUE 79.
       10  MQCMD-COPY-AUTH-INFO   PIC S9(9) BINARY VALUE 80.
       10  MQCMD-CREATE-AUTH-INFO   PIC S9(9) BINARY VALUE 81.
       10  MQCMD-DELETE-AUTH-INFO   PIC S9(9) BINARY VALUE 82.
       10  MQCMD-INQUIRE-AUTH-INFO   PIC S9(9) BINARY VALUE 83.
       10  MQCMD-INQUIRE-AUTH-INFO-NAMES   PIC S9(9) BINARY VALUE 84.
       10  MQCMD-INQUIRE-CONNECTION   PIC S9(9) BINARY VALUE 85.
       10  MQCMD-STOP-CONNECTION   PIC S9(9) BINARY VALUE 86.
       10  MQCMD-INQUIRE-AUTH-RECS   PIC S9(9) BINARY VALUE 87.
       10  MQCMD-INQUIRE-ENTITY-AUTH   PIC S9(9) BINARY VALUE 88.
       10  MQCMD-DELETE-AUTH-REC   PIC S9(9) BINARY VALUE 89.
       10  MQCMD-SET-AUTH-REC   PIC S9(9) BINARY VALUE 90.
       10  MQCMD-LOGGER-EVENT   PIC S9(9) BINARY VALUE 91.
       10  MQCMD-RESET-Q-MGR   PIC S9(9) BINARY VALUE 92.
       10  MQCMD-CHANGE-LISTENER   PIC S9(9) BINARY VALUE 93.
       10  MQCMD-COPY-LISTENER   PIC S9(9) BINARY VALUE 94.
       10  MQCMD-CREATE-LISTENER   PIC S9(9) BINARY VALUE 95.
       10  MQCMD-DELETE-LISTENER   PIC S9(9) BINARY VALUE 96.
       10  MQCMD-INQUIRE-LISTENER   PIC S9(9) BINARY VALUE 97.
       10  MQCMD-INQUIRE-LISTENER-STATUS   PIC S9(9) BINARY VALUE 98.
       10  MQCMD-COMMAND-EVENT   PIC S9(9) BINARY VALUE 99.
       10  MQCMD-CHANGE-SECURITY   PIC S9(9) BINARY VALUE 100.
       10  MQCMD-CHANGE-CF-STRUC   PIC S9(9) BINARY VALUE 101.
       10  MQCMD-CHANGE-STG-CLASS   PIC S9(9) BINARY VALUE 102.
       10  MQCMD-CHANGE-TRACE   PIC S9(9) BINARY VALUE 103.
       10  MQCMD-ARCHIVE-LOG   PIC S9(9) BINARY VALUE 104.
       10  MQCMD-BACKUP-CF-STRUC   PIC S9(9) BINARY VALUE 105.
       10  MQCMD-CREATE-BUFFER-POOL   PIC S9(9) BINARY VALUE 106.
       10  MQCMD-CREATE-PAGE-SET   PIC S9(9) BINARY VALUE 107.
       10  MQCMD-CREATE-CF-STRUC   PIC S9(9) BINARY VALUE 108.
       10  MQCMD-CREATE-STG-CLASS   PIC S9(9) BINARY VALUE 109.
       10  MQCMD-COPY-CF-STRUC   PIC S9(9) BINARY VALUE 110.
       10  MQCMD-COPY-STG-CLASS   PIC S9(9) BINARY VALUE 111.
       10  MQCMD-DELETE-CF-STRUC   PIC S9(9) BINARY VALUE 112.
       10  MQCMD-DELETE-STG-CLASS   PIC S9(9) BINARY VALUE 113.
       10  MQCMD-INQUIRE-ARCHIVE   PIC S9(9) BINARY VALUE 114.
       10  MQCMD-INQUIRE-CF-STRUC   PIC S9(9) BINARY VALUE 115.
       10  MQCMD-INQUIRE-CF-STRUC-STATUS   PIC S9(9) BINARY VALUE 116.
       10  MQCMD-INQUIRE-CMD-SERVER   PIC S9(9) BINARY VALUE 117.
       10  MQCMD-INQUIRE-CHANNEL-INIT   PIC S9(9) BINARY VALUE 118.
       10  MQCMD-INQUIRE-QSG   PIC S9(9) BINARY VALUE 119.
       10  MQCMD-INQUIRE-LOG   PIC S9(9) BINARY VALUE 120.
       10  MQCMD-INQUIRE-SECURITY   PIC S9(9) BINARY VALUE 121.
       10  MQCMD-INQUIRE-STG-CLASS   PIC S9(9) BINARY VALUE 122.
       10  MQCMD-INQUIRE-SYSTEM   PIC S9(9) BINARY VALUE 123.
       10  MQCMD-INQUIRE-THREAD   PIC S9(9) BINARY VALUE 124.
       10  MQCMD-INQUIRE-TRACE   PIC S9(9) BINARY VALUE 125.
       10  MQCMD-INQUIRE-USAGE   PIC S9(9) BINARY VALUE 126.
       10  MQCMD-MOVE-Q   PIC S9(9) BINARY VALUE 127.
       10  MQCMD-RECOVER-BSDS   PIC S9(9) BINARY VALUE 128.
       10  MQCMD-RECOVER-CF-STRUC   PIC S9(9) BINARY VALUE 129.
       10  MQCMD-RESET-TPIPE   PIC S9(9) BINARY VALUE 130.
       10  MQCMD-RESOLVE-INDOUBT   PIC S9(9) BINARY VALUE 131.
       10  MQCMD-RESUME-Q-MGR   PIC S9(9) BINARY VALUE 132.
       10  MQCMD-REVERIFY-SECURITY   PIC S9(9) BINARY VALUE 133.
       10  MQCMD-SET-ARCHIVE   PIC S9(9) BINARY VALUE 134.
       10  MQCMD-SET-LOG   PIC S9(9) BINARY VALUE 136.
       10  MQCMD-SET-SYSTEM   PIC S9(9) BINARY VALUE 137.
       10  MQCMD-START-CMD-SERVER   PIC S9(9) BINARY VALUE 138.
       10  MQCMD-START-Q-MGR   PIC S9(9) BINARY VALUE 139.
       10  MQCMD-START-TRACE   PIC S9(9) BINARY VALUE 140.
       10  MQCMD-STOP-CHANNEL-INIT   PIC S9(9) BINARY VALUE 141.
       10  MQCMD-STOP-CHANNEL-LISTENER   PIC S9(9) BINARY VALUE 142.
       10  MQCMD-STOP-CMD-SERVER   PIC S9(9) BINARY VALUE 143.
       10  MQCMD-STOP-Q-MGR   PIC S9(9) BINARY VALUE 144.
       10  MQCMD-STOP-TRACE   PIC S9(9) BINARY VALUE 145.
       10  MQCMD-SUSPEND-Q-MGR   PIC S9(9) BINARY VALUE 146.
       10  MQCMD-INQUIRE-CF-STRUC-NAMES   PIC S9(9) BINARY VALUE 147.
       10  MQCMD-INQUIRE-STG-CLASS-NAMES   PIC S9(9) BINARY VALUE 148.
       10  MQCMD-CHANGE-SERVICE   PIC S9(9) BINARY VALUE 149.
       10  MQCMD-COPY-SERVICE   PIC S9(9) BINARY VALUE 150.
       10  MQCMD-CREATE-SERVICE   PIC S9(9) BINARY VALUE 151.
       10  MQCMD-DELETE-SERVICE   PIC S9(9) BINARY VALUE 152.
       10  MQCMD-INQUIRE-SERVICE   PIC S9(9) BINARY VALUE 153.
       10  MQCMD-INQUIRE-SERVICE-STATUS   PIC S9(9) BINARY VALUE 154.
       10  MQCMD-START-SERVICE   PIC S9(9) BINARY VALUE 155.
       10  MQCMD-STOP-SERVICE   PIC S9(9) BINARY VALUE 156.
       10  MQCMD-DELETE-BUFFER-POOL   PIC S9(9) BINARY VALUE 157.
       10  MQCMD-DELETE-PAGE-SET   PIC S9(9) BINARY VALUE 158.
       10  MQCMD-CHANGE-BUFFER-POOL   PIC S9(9) BINARY VALUE 159.
       10  MQCMD-CHANGE-PAGE-SET   PIC S9(9) BINARY VALUE 160.
       10  MQCMD-INQUIRE-Q-MGR-STATUS   PIC S9(9) BINARY VALUE 161.
       10  MQCMD-CREATE-LOG   PIC S9(9) BINARY VALUE 162.
       10  MQCMD-STATISTICS-MQI   PIC S9(9) BINARY VALUE 164.
       10  MQCMD-STATISTICS-Q   PIC S9(9) BINARY VALUE 165.
       10  MQCMD-STATISTICS-CHANNEL   PIC S9(9) BINARY VALUE 166.
       10  MQCMD-ACCOUNTING-MQI   PIC S9(9) BINARY VALUE 167.
       10  MQCMD-ACCOUNTING-Q   PIC S9(9) BINARY VALUE 168.
       10  MQCMD-INQUIRE-AUTH-SERVICE   PIC S9(9) BINARY VALUE 169.
       10  MQCMD-CHANGE-TOPIC   PIC S9(9) BINARY VALUE 170.
       10  MQCMD-COPY-TOPIC   PIC S9(9) BINARY VALUE 171.
       10  MQCMD-CREATE-TOPIC   PIC S9(9) BINARY VALUE 172.
       10  MQCMD-DELETE-TOPIC   PIC S9(9) BINARY VALUE 173.
       10  MQCMD-INQUIRE-TOPIC   PIC S9(9) BINARY VALUE 174.
       10  MQCMD-INQUIRE-TOPIC-NAMES   PIC S9(9) BINARY VALUE 175.
       10  MQCMD-INQUIRE-SUBSCRIPTION   PIC S9(9) BINARY VALUE 176.
       10  MQCMD-CREATE-SUBSCRIPTION   PIC S9(9) BINARY VALUE 177.
       10  MQCMD-CHANGE-SUBSCRIPTION   PIC S9(9) BINARY VALUE 178.
       10  MQCMD-DELETE-SUBSCRIPTION   PIC S9(9) BINARY VALUE 179.
       10  MQCMD-COPY-SUBSCRIPTION   PIC S9(9) BINARY VALUE 181.
       10  MQCMD-INQUIRE-SUB-STATUS   PIC S9(9) BINARY VALUE 182.
       10  MQCMD-INQUIRE-TOPIC-STATUS   PIC S9(9) BINARY VALUE 183.
       10  MQCMD-CLEAR-TOPIC-STRING   PIC S9(9) BINARY VALUE 184.
       10  MQCMD-INQUIRE-PUBSUB-STATUS   PIC S9(9) BINARY VALUE 185.
       10  MQCMD-INQUIRE-SMDS   PIC S9(9) BINARY VALUE 186.
       10  MQCMD-CHANGE-SMDS   PIC S9(9) BINARY VALUE 187.
       10  MQCMD-RESET-SMDS   PIC S9(9) BINARY VALUE 188.
       10  MQCMD-CREATE-COMM-INFO   PIC S9(9) BINARY VALUE 190.
       10  MQCMD-INQUIRE-COMM-INFO   PIC S9(9) BINARY VALUE 191.
       10  MQCMD-CHANGE-COMM-INFO   PIC S9(9) BINARY VALUE 192.
       10  MQCMD-COPY-COMM-INFO   PIC S9(9) BINARY VALUE 193.
       10  MQCMD-DELETE-COMM-INFO   PIC S9(9) BINARY VALUE 194.
       10  MQCMD-PURGE-CHANNEL   PIC S9(9) BINARY VALUE 195.
       10  MQCMD-MQXR-DIAGNOSTICS   PIC S9(9) BINARY VALUE 196.
       10  MQCMD-START-SMDSCONN   PIC S9(9) BINARY VALUE 197.
       10  MQCMD-STOP-SMDSCONN   PIC S9(9) BINARY VALUE 198.
       10  MQCMD-INQUIRE-SMDSCONN   PIC S9(9) BINARY VALUE 199.
       10  MQCMD-INQUIRE-MQXR-STATUS   PIC S9(9) BINARY VALUE 200.
       10  MQCMD-START-CLIENT-TRACE   PIC S9(9) BINARY VALUE 201.
       10  MQCMD-STOP-CLIENT-TRACE   PIC S9(9) BINARY VALUE 202.
       10  MQCMD-SET-CHLAUTH-REC   PIC S9(9) BINARY VALUE 203.
       10  MQCMD-INQUIRE-CHLAUTH-RECS   PIC S9(9) BINARY VALUE 204.
       10  MQCMD-INQUIRE-PROT-POLICY   PIC S9(9) BINARY VALUE 205.
       10  MQCMD-CREATE-PROT-POLICY   PIC S9(9) BINARY VALUE 206.
       10  MQCMD-DELETE-PROT-POLICY   PIC S9(9) BINARY VALUE 207.
       10  MQCMD-CHANGE-PROT-POLICY   PIC S9(9) BINARY VALUE 208.
       10  MQCMD-SET-PROT-POLICY   PIC S9(9) BINARY VALUE 208.
       10  MQCMD-ACTIVITY-TRACE   PIC S9(9) BINARY VALUE 209.
       10  MQCMD-RESET-CF-STRUC   PIC S9(9) BINARY VALUE 213.
       10  MQCMD-INQUIRE-XR-CAPABILITY   PIC S9(9) BINARY VALUE 214.
       10  MQCMD-INQUIRE-AMQP-CAPABILITY   PIC S9(9) BINARY VALUE 216.
       10  MQCMD-AMQP-DIAGNOSTICS   PIC S9(9) BINARY VALUE 217.
       10  MQCMD-INTER-Q-MGR-STATUS   PIC S9(9) BINARY VALUE 218.
       10  MQCMD-INTER-Q-MGR-BALANCE   PIC S9(9) BINARY VALUE 219.
       10  MQCMD-INQUIRE-APPL-STATUS   PIC S9(9) BINARY VALUE 220.

      ** Control Options
       10  MQCFC-LAST   PIC S9(9) BINARY VALUE 1.
       10  MQCFC-NOT-LAST   PIC S9(9) BINARY VALUE 0.

      ** Reason Codes
       10  MQRCCF-CFH-TYPE-ERROR   PIC S9(9) BINARY VALUE 3001.
       10  MQRCCF-CFH-LENGTH-ERROR   PIC S9(9) BINARY VALUE 3002.
       10  MQRCCF-CFH-VERSION-ERROR   PIC S9(9) BINARY VALUE 3003.
       10  MQRCCF-CFH-MSG-SEQ-NUMBER-ERR   PIC S9(9) BINARY VALUE 3004.
       10  MQRCCF-CFH-CONTROL-ERROR   PIC S9(9) BINARY VALUE 3005.
       10  MQRCCF-CFH-PARM-COUNT-ERROR   PIC S9(9) BINARY VALUE 3006.
       10  MQRCCF-CFH-COMMAND-ERROR   PIC S9(9) BINARY VALUE 3007.
       10  MQRCCF-COMMAND-FAILED   PIC S9(9) BINARY VALUE 3008.
       10  MQRCCF-CFIN-LENGTH-ERROR   PIC S9(9) BINARY VALUE 3009.
       10  MQRCCF-CFST-LENGTH-ERROR   PIC S9(9) BINARY VALUE 3010.
       10  MQRCCF-CFST-STRING-LENGTH-ERR   PIC S9(9) BINARY VALUE 3011.
       10  MQRCCF-FORCE-VALUE-ERROR   PIC S9(9) BINARY VALUE 3012.
       10  MQRCCF-STRUCTURE-TYPE-ERROR   PIC S9(9) BINARY VALUE 3013.
       10  MQRCCF-CFIN-PARM-ID-ERROR   PIC S9(9) BINARY VALUE 3014.
       10  MQRCCF-CFST-PARM-ID-ERROR   PIC S9(9) BINARY VALUE 3015.
       10  MQRCCF-MSG-LENGTH-ERROR   PIC S9(9) BINARY VALUE 3016.
       10  MQRCCF-CFIN-DUPLICATE-PARM   PIC S9(9) BINARY VALUE 3017.
       10  MQRCCF-CFST-DUPLICATE-PARM   PIC S9(9) BINARY VALUE 3018.
       10  MQRCCF-PARM-COUNT-TOO-SMALL   PIC S9(9) BINARY VALUE 3019.
       10  MQRCCF-PARM-COUNT-TOO-BIG   PIC S9(9) BINARY VALUE 3020.
       10  MQRCCF-Q-ALREADY-IN-CELL   PIC S9(9) BINARY VALUE 3021.
       10  MQRCCF-Q-TYPE-ERROR   PIC S9(9) BINARY VALUE 3022.
       10  MQRCCF-MD-FORMAT-ERROR   PIC S9(9) BINARY VALUE 3023.
       10  MQRCCF-CFSL-LENGTH-ERROR   PIC S9(9) BINARY VALUE 3024.
       10  MQRCCF-REPLACE-VALUE-ERROR   PIC S9(9) BINARY VALUE 3025.
       10  MQRCCF-CFIL-DUPLICATE-VALUE   PIC S9(9) BINARY VALUE 3026.
       10  MQRCCF-CFIL-COUNT-ERROR   PIC S9(9) BINARY VALUE 3027.
       10  MQRCCF-CFIL-LENGTH-ERROR   PIC S9(9) BINARY VALUE 3028.
       10  MQRCCF-QUIESCE-VALUE-ERROR   PIC S9(9) BINARY VALUE 3029.
       10  MQRCCF-MODE-VALUE-ERROR   PIC S9(9) BINARY VALUE 3029.
       10  MQRCCF-MSG-SEQ-NUMBER-ERROR   PIC S9(9) BINARY VALUE 3030.
       10  MQRCCF-PING-DATA-COUNT-ERROR   PIC S9(9) BINARY VALUE 3031.
       10  MQRCCF-PING-DATA-COMPARE-ERROR   PIC S9(9) BINARY VALUE 3032.
       10  MQRCCF-CFSL-PARM-ID-ERROR   PIC S9(9) BINARY VALUE 3033.
       10  MQRCCF-CHANNEL-TYPE-ERROR   PIC S9(9) BINARY VALUE 3034.
       10  MQRCCF-PARM-SEQUENCE-ERROR   PIC S9(9) BINARY VALUE 3035.
       10  MQRCCF-XMIT-PROTOCOL-TYPE-ERR   PIC S9(9) BINARY VALUE 3036.
       10  MQRCCF-BATCH-SIZE-ERROR   PIC S9(9) BINARY VALUE 3037.
       10  MQRCCF-DISC-INT-ERROR   PIC S9(9) BINARY VALUE 3038.
       10  MQRCCF-SHORT-RETRY-ERROR   PIC S9(9) BINARY VALUE 3039.
       10  MQRCCF-SHORT-TIMER-ERROR   PIC S9(9) BINARY VALUE 3040.
       10  MQRCCF-LONG-RETRY-ERROR   PIC S9(9) BINARY VALUE 3041.
       10  MQRCCF-LONG-TIMER-ERROR   PIC S9(9) BINARY VALUE 3042.
       10  MQRCCF-SEQ-NUMBER-WRAP-ERROR   PIC S9(9) BINARY VALUE 3043.
       10  MQRCCF-MAX-MSG-LENGTH-ERROR   PIC S9(9) BINARY VALUE 3044.
       10  MQRCCF-PUT-AUTH-ERROR   PIC S9(9) BINARY VALUE 3045.
       10  MQRCCF-PURGE-VALUE-ERROR   PIC S9(9) BINARY VALUE 3046.
       10  MQRCCF-CFIL-PARM-ID-ERROR   PIC S9(9) BINARY VALUE 3047.
       10  MQRCCF-MSG-TRUNCATED   PIC S9(9) BINARY VALUE 3048.
       10  MQRCCF-CCSID-ERROR   PIC S9(9) BINARY VALUE 3049.
       10  MQRCCF-ENCODING-ERROR   PIC S9(9) BINARY VALUE 3050.
       10  MQRCCF-QUEUES-VALUE-ERROR   PIC S9(9) BINARY VALUE 3051.
       10  MQRCCF-DATA-CONV-VALUE-ERROR   PIC S9(9) BINARY VALUE 3052.
       10  MQRCCF-INDOUBT-VALUE-ERROR   PIC S9(9) BINARY VALUE 3053.
       10  MQRCCF-ESCAPE-TYPE-ERROR   PIC S9(9) BINARY VALUE 3054.
       10  MQRCCF-REPOS-VALUE-ERROR   PIC S9(9) BINARY VALUE 3055.
       10  MQRCCF-CHANNEL-TABLE-ERROR   PIC S9(9) BINARY VALUE 3062.
       10  MQRCCF-MCA-TYPE-ERROR   PIC S9(9) BINARY VALUE 3063.
       10  MQRCCF-CHL-INST-TYPE-ERROR   PIC S9(9) BINARY VALUE 3064.
       10  MQRCCF-CHL-STATUS-NOT-FOUND   PIC S9(9) BINARY VALUE 3065.
       10  MQRCCF-CFSL-DUPLICATE-PARM   PIC S9(9) BINARY VALUE 3066.
       10  MQRCCF-CFSL-TOTAL-LENGTH-ERROR   PIC S9(9) BINARY VALUE 3067.
       10  MQRCCF-CFSL-COUNT-ERROR   PIC S9(9) BINARY VALUE 3068.
       10  MQRCCF-CFSL-STRING-LENGTH-ERR   PIC S9(9) BINARY VALUE 3069.
       10  MQRCCF-BROKER-DELETED   PIC S9(9) BINARY VALUE 3070.
       10  MQRCCF-STREAM-ERROR   PIC S9(9) BINARY VALUE 3071.
       10  MQRCCF-TOPIC-ERROR   PIC S9(9) BINARY VALUE 3072.
       10  MQRCCF-NOT-REGISTERED   PIC S9(9) BINARY VALUE 3073.
       10  MQRCCF-Q-MGR-NAME-ERROR   PIC S9(9) BINARY VALUE 3074.
       10  MQRCCF-INCORRECT-STREAM   PIC S9(9) BINARY VALUE 3075.
       10  MQRCCF-Q-NAME-ERROR   PIC S9(9) BINARY VALUE 3076.
       10  MQRCCF-NO-RETAINED-MSG   PIC S9(9) BINARY VALUE 3077.
       10  MQRCCF-DUPLICATE-IDENTITY   PIC S9(9) BINARY VALUE 3078.
       10  MQRCCF-INCORRECT-Q   PIC S9(9) BINARY VALUE 3079.
       10  MQRCCF-CORREL-ID-ERROR   PIC S9(9) BINARY VALUE 3080.
       10  MQRCCF-NOT-AUTHORIZED   PIC S9(9) BINARY VALUE 3081.
       10  MQRCCF-UNKNOWN-STREAM   PIC S9(9) BINARY VALUE 3082.
       10  MQRCCF-REG-OPTIONS-ERROR   PIC S9(9) BINARY VALUE 3083.
       10  MQRCCF-PUB-OPTIONS-ERROR   PIC S9(9) BINARY VALUE 3084.
       10  MQRCCF-UNKNOWN-BROKER   PIC S9(9) BINARY VALUE 3085.
       10  MQRCCF-Q-MGR-CCSID-ERROR   PIC S9(9) BINARY VALUE 3086.
       10  MQRCCF-DEL-OPTIONS-ERROR   PIC S9(9) BINARY VALUE 3087.
       10  MQRCCF-CLUSTER-NAME-CONFLICT   PIC S9(9) BINARY VALUE 3088.
       10  MQRCCF-REPOS-NAME-CONFLICT   PIC S9(9) BINARY VALUE 3089.
       10  MQRCCF-CLUSTER-Q-USAGE-ERROR   PIC S9(9) BINARY VALUE 3090.
       10  MQRCCF-ACTION-VALUE-ERROR   PIC S9(9) BINARY VALUE 3091.
       10  MQRCCF-COMMS-LIBRARY-ERROR   PIC S9(9) BINARY VALUE 3092.
       10  MQRCCF-NETBIOS-NAME-ERROR   PIC S9(9) BINARY VALUE 3093.
       10  MQRCCF-BROKER-COMMAND-FAILED   PIC S9(9) BINARY VALUE 3094.
       10  MQRCCF-CFST-CONFLICTING-PARM   PIC S9(9) BINARY VALUE 3095.
       10  MQRCCF-PATH-NOT-VALID   PIC S9(9) BINARY VALUE 3096.
       10  MQRCCF-PARM-SYNTAX-ERROR   PIC S9(9) BINARY VALUE 3097.
       10  MQRCCF-PWD-LENGTH-ERROR   PIC S9(9) BINARY VALUE 3098.
       10  MQRCCF-FILTER-ERROR   PIC S9(9) BINARY VALUE 3150.
       10  MQRCCF-WRONG-USER   PIC S9(9) BINARY VALUE 3151.
       10  MQRCCF-DUPLICATE-SUBSCRIPTION   PIC S9(9) BINARY VALUE 3152.
       10  MQRCCF-SUB-NAME-ERROR   PIC S9(9) BINARY VALUE 3153.
       10  MQRCCF-SUB-IDENTITY-ERROR   PIC S9(9) BINARY VALUE 3154.
       10  MQRCCF-SUBSCRIPTION-IN-USE   PIC S9(9) BINARY VALUE 3155.
       10  MQRCCF-SUBSCRIPTION-LOCKED   PIC S9(9) BINARY VALUE 3156.
       10  MQRCCF-ALREADY-JOINED   PIC S9(9) BINARY VALUE 3157.
       10  MQRCCF-OBJECT-IN-USE   PIC S9(9) BINARY VALUE 3160.
       10  MQRCCF-UNKNOWN-FILE-NAME   PIC S9(9) BINARY VALUE 3161.
       10  MQRCCF-FILE-NOT-AVAILABLE   PIC S9(9) BINARY VALUE 3162.
       10  MQRCCF-DISC-RETRY-ERROR   PIC S9(9) BINARY VALUE 3163.
       10  MQRCCF-ALLOC-RETRY-ERROR   PIC S9(9) BINARY VALUE 3164.
       10  MQRCCF-ALLOC-SLOW-TIMER-ERROR   PIC S9(9) BINARY VALUE 3165.
       10  MQRCCF-ALLOC-FAST-TIMER-ERROR   PIC S9(9) BINARY VALUE 3166.
       10  MQRCCF-PORT-NUMBER-ERROR   PIC S9(9) BINARY VALUE 3167.
       10  MQRCCF-CHL-SYSTEM-NOT-ACTIVE   PIC S9(9) BINARY VALUE 3168.
       10  MQRCCF-ENTITY-NAME-MISSING   PIC S9(9) BINARY VALUE 3169.
       10  MQRCCF-PROFILE-NAME-ERROR   PIC S9(9) BINARY VALUE 3170.
       10  MQRCCF-AUTH-VALUE-ERROR   PIC S9(9) BINARY VALUE 3171.
       10  MQRCCF-AUTH-VALUE-MISSING   PIC S9(9) BINARY VALUE 3172.
       10  MQRCCF-OBJECT-TYPE-MISSING   PIC S9(9) BINARY VALUE 3173.
       10  MQRCCF-CONNECTION-ID-ERROR   PIC S9(9) BINARY VALUE 3174.
       10  MQRCCF-LOG-TYPE-ERROR   PIC S9(9) BINARY VALUE 3175.
       10  MQRCCF-PROGRAM-NOT-AVAILABLE   PIC S9(9) BINARY VALUE 3176.
       10  MQRCCF-PROGRAM-AUTH-FAILED   PIC S9(9) BINARY VALUE 3177.
       10  MQRCCF-NONE-FOUND   PIC S9(9) BINARY VALUE 3200.
       10  MQRCCF-SECURITY-SWITCH-OFF   PIC S9(9) BINARY VALUE 3201.
       10  MQRCCF-SECURITY-REFRESH-FAILED   PIC S9(9) BINARY VALUE 3202.
       10  MQRCCF-PARM-CONFLICT   PIC S9(9) BINARY VALUE 3203.
       10  MQRCCF-COMMAND-INHIBITED   PIC S9(9) BINARY VALUE 3204.
       10  MQRCCF-OBJECT-BEING-DELETED   PIC S9(9) BINARY VALUE 3205.
       10  MQRCCF-STORAGE-CLASS-IN-USE   PIC S9(9) BINARY VALUE 3207.
       10  MQRCCF-OBJECT-NAME-RESTRICTED   PIC S9(9) BINARY VALUE 3208.
       10  MQRCCF-OBJECT-LIMIT-EXCEEDED   PIC S9(9) BINARY VALUE 3209.
       10  MQRCCF-OBJECT-OPEN-FORCE   PIC S9(9) BINARY VALUE 3210.
       10  MQRCCF-DISPOSITION-CONFLICT   PIC S9(9) BINARY VALUE 3211.
       10  MQRCCF-Q-MGR-NOT-IN-QSG   PIC S9(9) BINARY VALUE 3212.
       10  MQRCCF-ATTR-VALUE-FIXED   PIC S9(9) BINARY VALUE 3213.
       10  MQRCCF-NAMELIST-ERROR   PIC S9(9) BINARY VALUE 3215.
       10  MQRCCF-NO-CHANNEL-INITIATOR   PIC S9(9) BINARY VALUE 3217.
       10  MQRCCF-CHANNEL-INITIATOR-ERROR   PIC S9(9) BINARY VALUE 3218.
       10  MQRCCF-COMMAND-LEVEL-CONFLICT   PIC S9(9) BINARY VALUE 3222.
       10  MQRCCF-Q-ATTR-CONFLICT   PIC S9(9) BINARY VALUE 3223.
       10  MQRCCF-EVENTS-DISABLED   PIC S9(9) BINARY VALUE 3224.
       10  MQRCCF-COMMAND-SCOPE-ERROR   PIC S9(9) BINARY VALUE 3225.
       10  MQRCCF-COMMAND-REPLY-ERROR   PIC S9(9) BINARY VALUE 3226.
       10  MQRCCF-FUNCTION-RESTRICTED   PIC S9(9) BINARY VALUE 3227.
       10  MQRCCF-PARM-MISSING   PIC S9(9) BINARY VALUE 3228.
       10  MQRCCF-PARM-VALUE-ERROR   PIC S9(9) BINARY VALUE 3229.
       10  MQRCCF-COMMAND-LENGTH-ERROR   PIC S9(9) BINARY VALUE 3230.
       10  MQRCCF-COMMAND-ORIGIN-ERROR   PIC S9(9) BINARY VALUE 3231.
       10  MQRCCF-LISTENER-CONFLICT   PIC S9(9) BINARY VALUE 3232.
       10  MQRCCF-LISTENER-STARTED   PIC S9(9) BINARY VALUE 3233.
       10  MQRCCF-LISTENER-STOPPED   PIC S9(9) BINARY VALUE 3234.
       10  MQRCCF-CHANNEL-ERROR   PIC S9(9) BINARY VALUE 3235.
       10  MQRCCF-CF-STRUC-ERROR   PIC S9(9) BINARY VALUE 3236.
       10  MQRCCF-UNKNOWN-USER-ID   PIC S9(9) BINARY VALUE 3237.
       10  MQRCCF-UNEXPECTED-ERROR   PIC S9(9) BINARY VALUE 3238.
       10  MQRCCF-NO-XCF-PARTNER   PIC S9(9) BINARY VALUE 3239.
       10  MQRCCF-CFGR-PARM-ID-ERROR   PIC S9(9) BINARY VALUE 3240.
       10  MQRCCF-CFIF-LENGTH-ERROR   PIC S9(9) BINARY VALUE 3241.
       10  MQRCCF-CFIF-OPERATOR-ERROR   PIC S9(9) BINARY VALUE 3242.
       10  MQRCCF-CFIF-PARM-ID-ERROR   PIC S9(9) BINARY VALUE 3243.
       10  MQRCCF-CFSF-FILTER-VAL-LEN-ERR   PIC S9(9) BINARY VALUE 3244.
       10  MQRCCF-CFSF-LENGTH-ERROR   PIC S9(9) BINARY VALUE 3245.
       10  MQRCCF-CFSF-OPERATOR-ERROR   PIC S9(9) BINARY VALUE 3246.
       10  MQRCCF-CFSF-PARM-ID-ERROR   PIC S9(9) BINARY VALUE 3247.
       10  MQRCCF-TOO-MANY-FILTERS   PIC S9(9) BINARY VALUE 3248.
       10  MQRCCF-LISTENER-RUNNING   PIC S9(9) BINARY VALUE 3249.
       10  MQRCCF-LSTR-STATUS-NOT-FOUND   PIC S9(9) BINARY VALUE 3250.
       10  MQRCCF-SERVICE-RUNNING   PIC S9(9) BINARY VALUE 3251.
       10  MQRCCF-SERV-STATUS-NOT-FOUND   PIC S9(9) BINARY VALUE 3252.
       10  MQRCCF-SERVICE-STOPPED   PIC S9(9) BINARY VALUE 3253.
       10  MQRCCF-CFBS-DUPLICATE-PARM   PIC S9(9) BINARY VALUE 3254.
       10  MQRCCF-CFBS-LENGTH-ERROR   PIC S9(9) BINARY VALUE 3255.
       10  MQRCCF-CFBS-PARM-ID-ERROR   PIC S9(9) BINARY VALUE 3256.
       10  MQRCCF-CFBS-STRING-LENGTH-ERR   PIC S9(9) BINARY VALUE 3257.
       10  MQRCCF-CFGR-LENGTH-ERROR   PIC S9(9) BINARY VALUE 3258.
       10  MQRCCF-CFGR-PARM-COUNT-ERROR   PIC S9(9) BINARY VALUE 3259.
       10  MQRCCF-CONN-NOT-STOPPED   PIC S9(9) BINARY VALUE 3260.
       10  MQRCCF-SERVICE-REQUEST-PENDING   PIC S9(9) BINARY VALUE 3261.
       10  MQRCCF-NO-START-CMD   PIC S9(9) BINARY VALUE 3262.
       10  MQRCCF-NO-STOP-CMD   PIC S9(9) BINARY VALUE 3263.
       10  MQRCCF-CFBF-LENGTH-ERROR   PIC S9(9) BINARY VALUE 3264.
       10  MQRCCF-CFBF-PARM-ID-ERROR   PIC S9(9) BINARY VALUE 3265.
       10  MQRCCF-CFBF-OPERATOR-ERROR   PIC S9(9) BINARY VALUE 3266.
       10  MQRCCF-CFBF-FILTER-VAL-LEN-ERR   PIC S9(9) BINARY VALUE 3267.
       10  MQRCCF-LISTENER-STILL-ACTIVE   PIC S9(9) BINARY VALUE 3268.
       10  MQRCCF-DEF-XMIT-Q-CLUS-ERROR   PIC S9(9) BINARY VALUE 3269.
       10  MQRCCF-TOPICSTR-ALREADY-EXISTS   PIC S9(9) BINARY VALUE 3300.
       10  MQRCCF-SHARING-CONVS-ERROR   PIC S9(9) BINARY VALUE 3301.
       10  MQRCCF-SHARING-CONVS-TYPE   PIC S9(9) BINARY VALUE 3302.
       10  MQRCCF-SECURITY-CASE-CONFLICT   PIC S9(9) BINARY VALUE 3303.
       10  MQRCCF-TOPIC-TYPE-ERROR   PIC S9(9) BINARY VALUE 3305.
       10  MQRCCF-MAX-INSTANCES-ERROR   PIC S9(9) BINARY VALUE 3306.
       10  MQRCCF-MAX-INSTS-PER-CLNT-ERR   PIC S9(9) BINARY VALUE 3307.
       10  MQRCCF-TOPIC-STRING-NOT-FOUND   PIC S9(9) BINARY VALUE 3308.
       10  MQRCCF-SUBSCRIPTION-POINT-ERR   PIC S9(9) BINARY VALUE 3309.
       10  MQRCCF-SUB-ALREADY-EXISTS   PIC S9(9) BINARY VALUE 3311.
       10  MQRCCF-UNKNOWN-OBJECT-NAME   PIC S9(9) BINARY VALUE 3312.
       10  MQRCCF-REMOTE-Q-NAME-ERROR   PIC S9(9) BINARY VALUE 3313.
       10  MQRCCF-DURABILITY-NOT-ALLOWED   PIC S9(9) BINARY VALUE 3314.
       10  MQRCCF-HOBJ-ERROR   PIC S9(9) BINARY VALUE 3315.
       10  MQRCCF-DEST-NAME-ERROR   PIC S9(9) BINARY VALUE 3316.
       10  MQRCCF-INVALID-DESTINATION   PIC S9(9) BINARY VALUE 3317.
       10  MQRCCF-PUBSUB-INHIBITED   PIC S9(9) BINARY VALUE 3318.
       10  MQRCCF-GROUPUR-CHECKS-FAILED   PIC S9(9) BINARY VALUE 3319.
       10  MQRCCF-COMM-INFO-TYPE-ERROR   PIC S9(9) BINARY VALUE 3320.
       10  MQRCCF-USE-CLIENT-ID-ERROR   PIC S9(9) BINARY VALUE 3321.
       10  MQRCCF-CLIENT-ID-NOT-FOUND   PIC S9(9) BINARY VALUE 3322.
       10  MQRCCF-CLIENT-ID-ERROR   PIC S9(9) BINARY VALUE 3323.
       10  MQRCCF-PORT-IN-USE   PIC S9(9) BINARY VALUE 3324.
       10  MQRCCF-SSL-ALT-PROVIDER-REQD   PIC S9(9) BINARY VALUE 3325.
       10  MQRCCF-CHLAUTH-TYPE-ERROR   PIC S9(9) BINARY VALUE 3326.
       10  MQRCCF-CHLAUTH-ACTION-ERROR   PIC S9(9) BINARY VALUE 3327.
       10  MQRCCF-POLICY-NOT-FOUND   PIC S9(9) BINARY VALUE 3328.
       10  MQRCCF-ENCRYPTION-ALG-ERROR   PIC S9(9) BINARY VALUE 3329.
       10  MQRCCF-SIGNATURE-ALG-ERROR   PIC S9(9) BINARY VALUE 3330.
       10  MQRCCF-TOLERATION-POL-ERROR   PIC S9(9) BINARY VALUE 3331.
       10  MQRCCF-POLICY-VERSION-ERROR   PIC S9(9) BINARY VALUE 3332.
       10  MQRCCF-RECIPIENT-DN-MISSING   PIC S9(9) BINARY VALUE 3333.
       10  MQRCCF-POLICY-NAME-MISSING   PIC S9(9) BINARY VALUE 3334.
       10  MQRCCF-CHLAUTH-USERSRC-ERROR   PIC S9(9) BINARY VALUE 3335.
       10  MQRCCF-WRONG-CHLAUTH-TYPE   PIC S9(9) BINARY VALUE 3336.
       10  MQRCCF-CHLAUTH-ALREADY-EXISTS   PIC S9(9) BINARY VALUE 3337.
       10  MQRCCF-CHLAUTH-NOT-FOUND   PIC S9(9) BINARY VALUE 3338.
       10  MQRCCF-WRONG-CHLAUTH-ACTION   PIC S9(9) BINARY VALUE 3339.
       10  MQRCCF-WRONG-CHLAUTH-USERSRC   PIC S9(9) BINARY VALUE 3340.
       10  MQRCCF-CHLAUTH-WARN-ERROR   PIC S9(9) BINARY VALUE 3341.
       10  MQRCCF-WRONG-CHLAUTH-MATCH   PIC S9(9) BINARY VALUE 3342.
       10  MQRCCF-IPADDR-RANGE-CONFLICT   PIC S9(9) BINARY VALUE 3343.
       10  MQRCCF-CHLAUTH-MAX-EXCEEDED   PIC S9(9) BINARY VALUE 3344.
       10  MQRCCF-IPADDR-ERROR   PIC S9(9) BINARY VALUE 3345.
       10  MQRCCF-ADDRESS-ERROR   PIC S9(9) BINARY VALUE 3345.
       10  MQRCCF-IPADDR-RANGE-ERROR   PIC S9(9) BINARY VALUE 3346.
       10  MQRCCF-PROFILE-NAME-MISSING   PIC S9(9) BINARY VALUE 3347.
       10  MQRCCF-CHLAUTH-CLNTUSER-ERROR   PIC S9(9) BINARY VALUE 3348.
       10  MQRCCF-CHLAUTH-NAME-ERROR   PIC S9(9) BINARY VALUE 3349.
       10  MQRCCF-CHLAUTH-RUNCHECK-ERROR   PIC S9(9) BINARY VALUE 3350.
       10  MQRCCF-CF-STRUC-ALREADY-FAILED   PIC S9(9) BINARY VALUE 3351.
       10  MQRCCF-CFCONLOS-CHECKS-FAILED   PIC S9(9) BINARY VALUE 3352.
       10  MQRCCF-SUITE-B-ERROR   PIC S9(9) BINARY VALUE 3353.
       10  MQRCCF-CHANNEL-NOT-STARTED   PIC S9(9) BINARY VALUE 3354.
       10  MQRCCF-CUSTOM-ERROR   PIC S9(9) BINARY VALUE 3355.
       10  MQRCCF-BACKLOG-OUT-OF-RANGE   PIC S9(9) BINARY VALUE 3356.
       10  MQRCCF-CHLAUTH-DISABLED   PIC S9(9) BINARY VALUE 3357.
       10  MQRCCF-SMDS-REQUIRES-DSGROUP   PIC S9(9) BINARY VALUE 3358.
       10  MQRCCF-PSCLUS-DISABLED-TOPDEF   PIC S9(9) BINARY VALUE 3359.
       10  MQRCCF-PSCLUS-TOPIC-EXISTS   PIC S9(9) BINARY VALUE 3360.
       10  MQRCCF-SSL-CIPHER-SUITE-ERROR   PIC S9(9) BINARY VALUE 3361.
       10  MQRCCF-SOCKET-ERROR   PIC S9(9) BINARY VALUE 3362.
       10  MQRCCF-CLUS-XMIT-Q-USAGE-ERROR   PIC S9(9) BINARY VALUE 3363.
       10  MQRCCF-CERT-VAL-POLICY-ERROR   PIC S9(9) BINARY VALUE 3364.
       10  MQRCCF-INVALID-PROTOCOL   PIC S9(9) BINARY VALUE 3365.
       10  MQRCCF-REVDNS-DISABLED   PIC S9(9) BINARY VALUE 3366.
       10  MQRCCF-CLROUTE-NOT-ALTERABLE   PIC S9(9) BINARY VALUE 3367.
       10  MQRCCF-CLUSTER-TOPIC-CONFLICT   PIC S9(9) BINARY VALUE 3368.
       10  MQRCCF-DEFCLXQ-MODEL-Q-ERROR   PIC S9(9) BINARY VALUE 3369.
       10  MQRCCF-CHLAUTH-CHKCLI-ERROR   PIC S9(9) BINARY VALUE 3370.
       10  MQRCCF-CERT-LABEL-NOT-ALLOWED   PIC S9(9) BINARY VALUE 3371.
       10  MQRCCF-Q-MGR-ATTR-CONFLICT   PIC S9(9) BINARY VALUE 3372.
       10  MQRCCF-ENTITY-TYPE-MISSING   PIC S9(9) BINARY VALUE 3373.
       10  MQRCCF-CLWL-EXIT-NAME-ERROR   PIC S9(9) BINARY VALUE 3374.
       10  MQRCCF-SERVICE-NAME-ERROR   PIC S9(9) BINARY VALUE 3375.
       10  MQRCCF-REMOTE-CHL-TYPE-ERROR   PIC S9(9) BINARY VALUE 3376.
       10  MQRCCF-TOPIC-RESTRICTED   PIC S9(9) BINARY VALUE 3377.
       10  MQRCCF-CURRENT-LOG-EXTENT   PIC S9(9) BINARY VALUE 3378.
       10  MQRCCF-LOG-EXTENT-NOT-FOUND   PIC S9(9) BINARY VALUE 3379.
       10  MQRCCF-LOG-NOT-REDUCED   PIC S9(9) BINARY VALUE 3380.
       10  MQRCCF-LOG-EXTENT-ERROR   PIC S9(9) BINARY VALUE 3381.
       10  MQRCCF-ACCESS-BLOCKED   PIC S9(9) BINARY VALUE 3382.
       10  MQRCCF-PS-REQUIRED-MQUC   PIC S9(9) BINARY VALUE 3383.
       10  MQRCCF-STREAMQ-DEST-NOT-SUPP   PIC S9(9) BINARY VALUE 3384.
       10  MQRCCF-STREAMQ-DEST-CONFLICT   PIC S9(9) BINARY VALUE 3385.
       10  MQRCCF-STREAMQ-NOT-SUPPORTED   PIC S9(9) BINARY VALUE 3386.
       10  MQRCCF-STREAMQ-CONFLICT   PIC S9(9) BINARY VALUE 3387.
       10  MQRCCF-OBJECT-ALREADY-EXISTS   PIC S9(9) BINARY VALUE 4001.
       10  MQRCCF-OBJECT-WRONG-TYPE   PIC S9(9) BINARY VALUE 4002.
       10  MQRCCF-LIKE-OBJECT-WRONG-TYPE   PIC S9(9) BINARY VALUE 4003.
       10  MQRCCF-OBJECT-OPEN   PIC S9(9) BINARY VALUE 4004.
       10  MQRCCF-ATTR-VALUE-ERROR   PIC S9(9) BINARY VALUE 4005.
       10  MQRCCF-UNKNOWN-Q-MGR   PIC S9(9) BINARY VALUE 4006.
       10  MQRCCF-Q-WRONG-TYPE   PIC S9(9) BINARY VALUE 4007.
       10  MQRCCF-OBJECT-NAME-ERROR   PIC S9(9) BINARY VALUE 4008.
       10  MQRCCF-ALLOCATE-FAILED   PIC S9(9) BINARY VALUE 4009.
       10  MQRCCF-HOST-NOT-AVAILABLE   PIC S9(9) BINARY VALUE 4010.
       10  MQRCCF-CONFIGURATION-ERROR   PIC S9(9) BINARY VALUE 4011.
       10  MQRCCF-CONNECTION-REFUSED   PIC S9(9) BINARY VALUE 4012.
       10  MQRCCF-ENTRY-ERROR   PIC S9(9) BINARY VALUE 4013.
       10  MQRCCF-SEND-FAILED   PIC S9(9) BINARY VALUE 4014.
       10  MQRCCF-RECEIVED-DATA-ERROR   PIC S9(9) BINARY VALUE 4015.
       10  MQRCCF-RECEIVE-FAILED   PIC S9(9) BINARY VALUE 4016.
       10  MQRCCF-CONNECTION-CLOSED   PIC S9(9) BINARY VALUE 4017.
       10  MQRCCF-NO-STORAGE   PIC S9(9) BINARY VALUE 4018.
       10  MQRCCF-NO-COMMS-MANAGER   PIC S9(9) BINARY VALUE 4019.
       10  MQRCCF-LISTENER-NOT-STARTED   PIC S9(9) BINARY VALUE 4020.
       10  MQRCCF-BIND-FAILED   PIC S9(9) BINARY VALUE 4024.
       10  MQRCCF-CHANNEL-INDOUBT   PIC S9(9) BINARY VALUE 4025.
       10  MQRCCF-MQCONN-FAILED   PIC S9(9) BINARY VALUE 4026.
       10  MQRCCF-MQOPEN-FAILED   PIC S9(9) BINARY VALUE 4027.
       10  MQRCCF-MQGET-FAILED   PIC S9(9) BINARY VALUE 4028.
       10  MQRCCF-MQPUT-FAILED   PIC S9(9) BINARY VALUE 4029.
       10  MQRCCF-PING-ERROR   PIC S9(9) BINARY VALUE 4030.
       10  MQRCCF-CHANNEL-IN-USE   PIC S9(9) BINARY VALUE 4031.
       10  MQRCCF-CHANNEL-NOT-FOUND   PIC S9(9) BINARY VALUE 4032.
       10  MQRCCF-UNKNOWN-REMOTE-CHANNEL   PIC S9(9) BINARY VALUE 4033.
       10  MQRCCF-REMOTE-QM-UNAVAILABLE   PIC S9(9) BINARY VALUE 4034.
       10  MQRCCF-REMOTE-QM-TERMINATING   PIC S9(9) BINARY VALUE 4035.
       10  MQRCCF-MQINQ-FAILED   PIC S9(9) BINARY VALUE 4036.
       10  MQRCCF-NOT-XMIT-Q   PIC S9(9) BINARY VALUE 4037.
       10  MQRCCF-CHANNEL-DISABLED   PIC S9(9) BINARY VALUE 4038.
       10  MQRCCF-USER-EXIT-NOT-AVAILABLE   PIC S9(9) BINARY VALUE 4039.
       10  MQRCCF-COMMIT-FAILED   PIC S9(9) BINARY VALUE 4040.
       10  MQRCCF-WRONG-CHANNEL-TYPE   PIC S9(9) BINARY VALUE 4041.
       10  MQRCCF-CHANNEL-ALREADY-EXISTS   PIC S9(9) BINARY VALUE 4042.
       10  MQRCCF-DATA-TOO-LARGE   PIC S9(9) BINARY VALUE 4043.
       10  MQRCCF-CHANNEL-NAME-ERROR   PIC S9(9) BINARY VALUE 4044.
       10  MQRCCF-XMIT-Q-NAME-ERROR   PIC S9(9) BINARY VALUE 4045.
       10  MQRCCF-MCA-NAME-ERROR   PIC S9(9) BINARY VALUE 4047.
       10  MQRCCF-SEND-EXIT-NAME-ERROR   PIC S9(9) BINARY VALUE 4048.
       10  MQRCCF-SEC-EXIT-NAME-ERROR   PIC S9(9) BINARY VALUE 4049.
       10  MQRCCF-MSG-EXIT-NAME-ERROR   PIC S9(9) BINARY VALUE 4050.
       10  MQRCCF-RCV-EXIT-NAME-ERROR   PIC S9(9) BINARY VALUE 4051.
       10  MQRCCF-XMIT-Q-NAME-WRONG-TYPE   PIC S9(9) BINARY VALUE 4052.
       10  MQRCCF-MCA-NAME-WRONG-TYPE   PIC S9(9) BINARY VALUE 4053.
       10  MQRCCF-DISC-INT-WRONG-TYPE   PIC S9(9) BINARY VALUE 4054.
       10  MQRCCF-SHORT-RETRY-WRONG-TYPE   PIC S9(9) BINARY VALUE 4055.
       10  MQRCCF-SHORT-TIMER-WRONG-TYPE   PIC S9(9) BINARY VALUE 4056.
       10  MQRCCF-LONG-RETRY-WRONG-TYPE   PIC S9(9) BINARY VALUE 4057.
       10  MQRCCF-LONG-TIMER-WRONG-TYPE   PIC S9(9) BINARY VALUE 4058.
       10  MQRCCF-PUT-AUTH-WRONG-TYPE   PIC S9(9) BINARY VALUE 4059.
       10  MQRCCF-KEEP-ALIVE-INT-ERROR   PIC S9(9) BINARY VALUE 4060.
       10  MQRCCF-MISSING-CONN-NAME   PIC S9(9) BINARY VALUE 4061.
       10  MQRCCF-CONN-NAME-ERROR   PIC S9(9) BINARY VALUE 4062.
       10  MQRCCF-MQSET-FAILED   PIC S9(9) BINARY VALUE 4063.
       10  MQRCCF-CHANNEL-NOT-ACTIVE   PIC S9(9) BINARY VALUE 4064.
       10  MQRCCF-TERMINATED-BY-SEC-EXIT   PIC S9(9) BINARY VALUE 4065.
       10  MQRCCF-DYNAMIC-Q-SCOPE-ERROR   PIC S9(9) BINARY VALUE 4067.
       10  MQRCCF-CELL-DIR-NOT-AVAILABLE   PIC S9(9) BINARY VALUE 4068.
       10  MQRCCF-MR-COUNT-ERROR   PIC S9(9) BINARY VALUE 4069.
       10  MQRCCF-MR-COUNT-WRONG-TYPE   PIC S9(9) BINARY VALUE 4070.
       10  MQRCCF-MR-EXIT-NAME-ERROR   PIC S9(9) BINARY VALUE 4071.
       10  MQRCCF-MR-EXIT-NAME-WRONG-TYPE   PIC S9(9) BINARY VALUE 4072.
       10  MQRCCF-MR-INTERVAL-ERROR   PIC S9(9) BINARY VALUE 4073.
       10  MQRCCF-MR-INTERVAL-WRONG-TYPE   PIC S9(9) BINARY VALUE 4074.
       10  MQRCCF-NPM-SPEED-ERROR   PIC S9(9) BINARY VALUE 4075.
       10  MQRCCF-NPM-SPEED-WRONG-TYPE   PIC S9(9) BINARY VALUE 4076.
       10  MQRCCF-HB-INTERVAL-ERROR   PIC S9(9) BINARY VALUE 4077.
       10  MQRCCF-HB-INTERVAL-WRONG-TYPE   PIC S9(9) BINARY VALUE 4078.
       10  MQRCCF-CHAD-ERROR   PIC S9(9) BINARY VALUE 4079.
       10  MQRCCF-CHAD-WRONG-TYPE   PIC S9(9) BINARY VALUE 4080.
       10  MQRCCF-CHAD-EVENT-ERROR   PIC S9(9) BINARY VALUE 4081.
       10  MQRCCF-CHAD-EVENT-WRONG-TYPE   PIC S9(9) BINARY VALUE 4082.
       10  MQRCCF-CHAD-EXIT-ERROR   PIC S9(9) BINARY VALUE 4083.
       10  MQRCCF-CHAD-EXIT-WRONG-TYPE   PIC S9(9) BINARY VALUE 4084.
       10  MQRCCF-SUPPRESSED-BY-EXIT   PIC S9(9) BINARY VALUE 4085.
       10  MQRCCF-BATCH-INT-ERROR   PIC S9(9) BINARY VALUE 4086.
       10  MQRCCF-BATCH-INT-WRONG-TYPE   PIC S9(9) BINARY VALUE 4087.
       10  MQRCCF-NET-PRIORITY-ERROR   PIC S9(9) BINARY VALUE 4088.
       10  MQRCCF-NET-PRIORITY-WRONG-TYPE   PIC S9(9) BINARY VALUE 4089.
       10  MQRCCF-CHANNEL-CLOSED   PIC S9(9) BINARY VALUE 4090.
       10  MQRCCF-Q-STATUS-NOT-FOUND   PIC S9(9) BINARY VALUE 4091.
       10  MQRCCF-SSL-CIPHER-SPEC-ERROR   PIC S9(9) BINARY VALUE 4092.
       10  MQRCCF-SSL-PEER-NAME-ERROR   PIC S9(9) BINARY VALUE 4093.
       10  MQRCCF-SSL-CLIENT-AUTH-ERROR   PIC S9(9) BINARY VALUE 4094.
       10  MQRCCF-RETAINED-NOT-SUPPORTED   PIC S9(9) BINARY VALUE 4095.
       10  MQRCCF-KWD-VALUE-WRONG-TYPE   PIC S9(9) BINARY VALUE 4096.
       10  MQRCCF-APPL-STATUS-NOT-FOUND   PIC S9(9) BINARY VALUE 4097.

      ******************************************************************
      **  Values Related to MQCFBF Structure                       
      ******************************************************************
      ** Structure Length (Fixed Part)
       10  MQCFBF-STRUC-LENGTH-FIXED   PIC S9(9) BINARY VALUE 20.

      ******************************************************************
      **  Values Related to MQCFBS Structure                       
      ******************************************************************
      ** Structure Length (Fixed Part)
       10  MQCFBS-STRUC-LENGTH-FIXED   PIC S9(9) BINARY VALUE 16.

      ******************************************************************
      **  Values Related to MQCFGR Structure                       
      ******************************************************************
      ** Structure Length
       10  MQCFGR-STRUC-LENGTH   PIC S9(9) BINARY VALUE 16.

      ******************************************************************
      **  Values Related to MQCFIF Structure                       
      ******************************************************************
      ** Structure Length
       10  MQCFIF-STRUC-LENGTH   PIC S9(9) BINARY VALUE 20.

      ******************************************************************
      **  Values Related to MQCFIL Structure                       
      ******************************************************************
      ** Structure Length (Fixed Part)
       10  MQCFIL-STRUC-LENGTH-FIXED   PIC S9(9) BINARY VALUE 16.

      ******************************************************************
      **  Values Related to MQCFIL64 Structure                     
      ******************************************************************
      ** Structure Length (Fixed Part)
       10  MQCFIL64-STRUC-LENGTH-FIXED   PIC S9(9) BINARY VALUE 16.

      ******************************************************************
      **  Values Related to MQCFIN Structure                       
      ******************************************************************
      ** Structure Length
       10  MQCFIN-STRUC-LENGTH   PIC S9(9) BINARY VALUE 16.

      ******************************************************************
      **  Values Related to MQCFIN64 Structure                     
      ******************************************************************
      ** Structure Length
       10  MQCFIN64-STRUC-LENGTH   PIC S9(9) BINARY VALUE 24.

      ******************************************************************
      **  Values Related to MQCFSF Structure                       
      ******************************************************************
      ** Structure Length (Fixed Part)
       10  MQCFSF-STRUC-LENGTH-FIXED   PIC S9(9) BINARY VALUE 24.

      ******************************************************************
      **  Values Related to MQCFSL Structure                       
      ******************************************************************
      ** Structure Length (Fixed Part)
       10  MQCFSL-STRUC-LENGTH-FIXED   PIC S9(9) BINARY VALUE 24.

      ******************************************************************
      **  Values Related to MQCFST Structure                       
      ******************************************************************
      ** Structure Length (Fixed Part)
       10  MQCFST-STRUC-LENGTH-FIXED   PIC S9(9) BINARY VALUE 20.

      ******************************************************************
      **  Values Related to MQEPH Structure                        
      ******************************************************************
      ** Structure Identifier
       10  MQEPH-STRUC-ID   PIC X(4) VALUE 'EPH '.

      ** Structure Length (Fixed Part)
       10  MQEPH-STRUC-LENGTH-FIXED   PIC S9(9) BINARY VALUE 68.

      ** Structure Version Number
       10  MQEPH-VERSION-1   PIC S9(9) BINARY VALUE 1.
       10  MQEPH-CURRENT-VERSION   PIC S9(9) BINARY VALUE 1.

      ** Structure Length
       10  MQEPH-LENGTH-1   PIC S9(9) BINARY VALUE 68.
       10  MQEPH-CURRENT-LENGTH   PIC S9(9) BINARY VALUE 68.

      ** Flags
       10  MQEPH-NONE   PIC S9(9) BINARY VALUE 0.
       10  MQEPH-CCSID-EMBEDDED   PIC S9(9) BINARY VALUE 1.

      ******************************************************************
      **  Values Related to All Structures                         
      ******************************************************************
      ** String Lengths
       10  MQ-ARCHIVE-PFX-LENGTH   PIC S9(9) BINARY VALUE 36.
       10  MQ-ARCHIVE-UNIT-LENGTH   PIC S9(9) BINARY VALUE 8.
       10  MQ-ASID-LENGTH   PIC S9(9) BINARY VALUE 4.
       10  MQ-AUTH-PROFILE-NAME-LENGTH   PIC S9(9) BINARY VALUE 48.
       10  MQ-CF-LEID-LENGTH   PIC S9(9) BINARY VALUE 12.
       10  MQ-COMMAND-MQSC-LENGTH   PIC S9(9) BINARY VALUE 32768.
       10  MQ-DATA-SET-NAME-LENGTH   PIC S9(9) BINARY VALUE 44.
       10  MQ-DB2-NAME-LENGTH   PIC S9(9) BINARY VALUE 4.
       10  MQ-DSG-NAME-LENGTH   PIC S9(9) BINARY VALUE 8.
       10  MQ-ENTITY-NAME-LENGTH   PIC S9(9) BINARY VALUE 1024.
       10  MQ-ENV-INFO-LENGTH   PIC S9(9) BINARY VALUE 96.
       10  MQ-GROUP-ADDRESS-LENGTH   PIC S9(9) BINARY VALUE 264.
       10  MQ-IP-ADDRESS-LENGTH   PIC S9(9) BINARY VALUE 48.
       10  MQ-LOG-CORREL-ID-LENGTH   PIC S9(9) BINARY VALUE 8.
       10  MQ-LOG-EXTENT-NAME-LENGTH   PIC S9(9) BINARY VALUE 24.
       10  MQ-LOG-PATH-LENGTH   PIC S9(9) BINARY VALUE 1024.
       10  MQ-LRSN-LENGTH   PIC S9(9) BINARY VALUE 12.
       10  MQ-ORIGIN-NAME-LENGTH   PIC S9(9) BINARY VALUE 8.
       10  MQ-PSB-NAME-LENGTH   PIC S9(9) BINARY VALUE 8.
       10  MQ-PST-ID-LENGTH   PIC S9(9) BINARY VALUE 8.
       10  MQ-Q-MGR-CPF-LENGTH   PIC S9(9) BINARY VALUE 4.
       10  MQ-RESPONSE-ID-LENGTH   PIC S9(9) BINARY VALUE 24.
       10  MQ-RBA-LENGTH   PIC S9(9) BINARY VALUE 16.
       10  MQ-SECURITY-PROFILE-LENGTH   PIC S9(9) BINARY VALUE 40.
       10  MQ-SERVICE-COMPONENT-LENGTH   PIC S9(9) BINARY VALUE 48.
       10  MQ-SUB-NAME-LENGTH   PIC S9(9) BINARY VALUE 10240.
       10  MQ-SYSP-SERVICE-LENGTH   PIC S9(9) BINARY VALUE 32.
       10  MQ-SYSTEM-NAME-LENGTH   PIC S9(9) BINARY VALUE 8.
       10  MQ-TASK-NUMBER-LENGTH   PIC S9(9) BINARY VALUE 8.
       10  MQ-TPIPE-PFX-LENGTH   PIC S9(9) BINARY VALUE 4.
       10  MQ-UOW-ID-LENGTH   PIC S9(9) BINARY VALUE 256.
       10  MQ-USER-DATA-LENGTH   PIC S9(9) BINARY VALUE 10240.
       10  MQ-VOLSER-LENGTH   PIC S9(9) BINARY VALUE 6.
       10  MQ-REMOTE-PRODUCT-LENGTH   PIC S9(9) BINARY VALUE 4.
       10  MQ-REMOTE-VERSION-LENGTH   PIC S9(9) BINARY VALUE 8.

      ** Filter Operators
       10  MQCFOP-LESS   PIC S9(9) BINARY VALUE 1.
       10  MQCFOP-EQUAL   PIC S9(9) BINARY VALUE 2.
       10  MQCFOP-GREATER   PIC S9(9) BINARY VALUE 4.
       10  MQCFOP-NOT-LESS   PIC S9(9) BINARY VALUE 6.
       10  MQCFOP-NOT-EQUAL   PIC S9(9) BINARY VALUE 5.
       10  MQCFOP-NOT-GREATER   PIC S9(9) BINARY VALUE 3.
       10  MQCFOP-LIKE   PIC S9(9) BINARY VALUE 18.
       10  MQCFOP-NOT-LIKE   PIC S9(9) BINARY VALUE 21.
       10  MQCFOP-CONTAINS   PIC S9(9) BINARY VALUE 10.
       10  MQCFOP-EXCLUDES   PIC S9(9) BINARY VALUE 13.
       10  MQCFOP-CONTAINS-GEN   PIC S9(9) BINARY VALUE 26.
       10  MQCFOP-EXCLUDES-GEN   PIC S9(9) BINARY VALUE 29.

      ** Types of Structure
       10  MQCFT-NONE   PIC S9(9) BINARY VALUE 0.
       10  MQCFT-COMMAND   PIC S9(9) BINARY VALUE 1.
       10  MQCFT-RESPONSE   PIC S9(9) BINARY VALUE 2.
       10  MQCFT-INTEGER   PIC S9(9) BINARY VALUE 3.
       10  MQCFT-STRING   PIC S9(9) BINARY VALUE 4.
       10  MQCFT-INTEGER-LIST   PIC S9(9) BINARY VALUE 5.
       10  MQCFT-STRING-LIST   PIC S9(9) BINARY VALUE 6.
       10  MQCFT-EVENT   PIC S9(9) BINARY VALUE 7.
       10  MQCFT-USER   PIC S9(9) BINARY VALUE 8.
       10  MQCFT-BYTE-STRING   PIC S9(9) BINARY VALUE 9.
       10  MQCFT-TRACE-ROUTE   PIC S9(9) BINARY VALUE 10.
       10  MQCFT-REPORT   PIC S9(9) BINARY VALUE 12.
       10  MQCFT-INTEGER-FILTER   PIC S9(9) BINARY VALUE 13.
       10  MQCFT-STRING-FILTER   PIC S9(9) BINARY VALUE 14.
       10  MQCFT-BYTE-STRING-FILTER   PIC S9(9) BINARY VALUE 15.
       10  MQCFT-COMMAND-XR   PIC S9(9) BINARY VALUE 16.
       10  MQCFT-XR-MSG   PIC S9(9) BINARY VALUE 17.
       10  MQCFT-XR-ITEM   PIC S9(9) BINARY VALUE 18.
       10  MQCFT-XR-SUMMARY   PIC S9(9) BINARY VALUE 19.
       10  MQCFT-GROUP   PIC S9(9) BINARY VALUE 20.
       10  MQCFT-STATISTICS   PIC S9(9) BINARY VALUE 21.
       10  MQCFT-ACCOUNTING   PIC S9(9) BINARY VALUE 22.
       10  MQCFT-INTEGER64   PIC S9(9) BINARY VALUE 23.
       10  MQCFT-INTEGER64-LIST   PIC S9(9) BINARY VALUE 25.
       10  MQCFT-APP-ACTIVITY   PIC S9(9) BINARY VALUE 26.
       10  MQCFT-STATUS   PIC S9(9) BINARY VALUE 27.

      ** Major Release Function
       10  MQOPMODE-COMPAT   PIC S9(9) BINARY VALUE 0.
       10  MQOPMODE-NEW-FUNCTION   PIC S9(9) BINARY VALUE 1.

      ******************************************************************
      **  Values Related to Byte Parameter Structures              
      ******************************************************************
      ** Byte Parameter Types
       10  MQBACF-FIRST   PIC S9(9) BINARY VALUE 7001.
       10  MQBACF-EVENT-ACCOUNTING-TOKEN   PIC S9(9) BINARY VALUE 7001.
       10  MQBACF-EVENT-SECURITY-ID   PIC S9(9) BINARY VALUE 7002.
       10  MQBACF-RESPONSE-SET   PIC S9(9) BINARY VALUE 7003.
       10  MQBACF-RESPONSE-ID   PIC S9(9) BINARY VALUE 7004.
       10  MQBACF-EXTERNAL-UOW-ID   PIC S9(9) BINARY VALUE 7005.
       10  MQBACF-CONNECTION-ID   PIC S9(9) BINARY VALUE 7006.
       10  MQBACF-GENERIC-CONNECTION-ID   PIC S9(9) BINARY VALUE 7007.
       10  MQBACF-ORIGIN-UOW-ID   PIC S9(9) BINARY VALUE 7008.
       10  MQBACF-Q-MGR-UOW-ID   PIC S9(9) BINARY VALUE 7009.
       10  MQBACF-ACCOUNTING-TOKEN   PIC S9(9) BINARY VALUE 7010.
       10  MQBACF-CORREL-ID   PIC S9(9) BINARY VALUE 7011.
       10  MQBACF-GROUP-ID   PIC S9(9) BINARY VALUE 7012.
       10  MQBACF-MSG-ID   PIC S9(9) BINARY VALUE 7013.
       10  MQBACF-CF-LEID   PIC S9(9) BINARY VALUE 7014.
       10  MQBACF-DESTINATION-CORREL-ID   PIC S9(9) BINARY VALUE 7015.
       10  MQBACF-SUB-ID   PIC S9(9) BINARY VALUE 7016.
       10  MQBACF-ALTERNATE-SECURITYID   PIC S9(9) BINARY VALUE 7019.
       10  MQBACF-MESSAGE-DATA   PIC S9(9) BINARY VALUE 7020.
       10  MQBACF-MQBO-STRUCT   PIC S9(9) BINARY VALUE 7021.
       10  MQBACF-MQCB-FUNCTION   PIC S9(9) BINARY VALUE 7022.
       10  MQBACF-MQCBC-STRUCT   PIC S9(9) BINARY VALUE 7023.
       10  MQBACF-MQCBD-STRUCT   PIC S9(9) BINARY VALUE 7024.
       10  MQBACF-MQCD-STRUCT   PIC S9(9) BINARY VALUE 7025.
       10  MQBACF-MQCNO-STRUCT   PIC S9(9) BINARY VALUE 7026.
       10  MQBACF-MQGMO-STRUCT   PIC S9(9) BINARY VALUE 7027.
       10  MQBACF-MQMD-STRUCT   PIC S9(9) BINARY VALUE 7028.
       10  MQBACF-MQPMO-STRUCT   PIC S9(9) BINARY VALUE 7029.
       10  MQBACF-MQSD-STRUCT   PIC S9(9) BINARY VALUE 7030.
       10  MQBACF-MQSTS-STRUCT   PIC S9(9) BINARY VALUE 7031.
       10  MQBACF-SUB-CORREL-ID   PIC S9(9) BINARY VALUE 7032.
       10  MQBACF-XA-XID   PIC S9(9) BINARY VALUE 7033.
       10  MQBACF-XQH-CORREL-ID   PIC S9(9) BINARY VALUE 7034.
       10  MQBACF-XQH-MSG-ID   PIC S9(9) BINARY VALUE 7035.
       10  MQBACF-REQUEST-ID   PIC S9(9) BINARY VALUE 7036.
       10  MQBACF-PROPERTIES-DATA   PIC S9(9) BINARY VALUE 7037.
       10  MQBACF-CONN-TAG   PIC S9(9) BINARY VALUE 7038.
       10  MQBACF-MQBNO-STRUCT   PIC S9(9) BINARY VALUE 7039.
       10  MQBACF-LAST-USED   PIC S9(9) BINARY VALUE 7039.

      ******************************************************************
      **  Values Related to Integer Parameter Structures           
      ******************************************************************
      ** Integer Monitoring Parameter Types
       10  MQIAMO-FIRST   PIC S9(9) BINARY VALUE 701.
       10  MQIAMO-AVG-BATCH-SIZE   PIC S9(9) BINARY VALUE 702.
       10  MQIAMO-AVG-Q-TIME   PIC S9(9) BINARY VALUE 703.
       10  MQIAMO64-AVG-Q-TIME   PIC S9(9) BINARY VALUE 703.
       10  MQIAMO-BACKOUTS   PIC S9(9) BINARY VALUE 704.
       10  MQIAMO-BROWSES   PIC S9(9) BINARY VALUE 705.
       10  MQIAMO-BROWSE-MAX-BYTES   PIC S9(9) BINARY VALUE 706.
       10  MQIAMO-BROWSE-MIN-BYTES   PIC S9(9) BINARY VALUE 707.
       10  MQIAMO-BROWSES-FAILED   PIC S9(9) BINARY VALUE 708.
       10  MQIAMO-CLOSES   PIC S9(9) BINARY VALUE 709.
       10  MQIAMO-COMMITS   PIC S9(9) BINARY VALUE 710.
       10  MQIAMO-COMMITS-FAILED   PIC S9(9) BINARY VALUE 711.
       10  MQIAMO-CONNS   PIC S9(9) BINARY VALUE 712.
       10  MQIAMO-CONNS-MAX   PIC S9(9) BINARY VALUE 713.
       10  MQIAMO-DISCS   PIC S9(9) BINARY VALUE 714.
       10  MQIAMO-DISCS-IMPLICIT   PIC S9(9) BINARY VALUE 715.
       10  MQIAMO-DISC-TYPE   PIC S9(9) BINARY VALUE 716.
       10  MQIAMO-EXIT-TIME-AVG   PIC S9(9) BINARY VALUE 717.
       10  MQIAMO-EXIT-TIME-MAX   PIC S9(9) BINARY VALUE 718.
       10  MQIAMO-EXIT-TIME-MIN   PIC S9(9) BINARY VALUE 719.
       10  MQIAMO-FULL-BATCHES   PIC S9(9) BINARY VALUE 720.
       10  MQIAMO-GENERATED-MSGS   PIC S9(9) BINARY VALUE 721.
       10  MQIAMO-GETS   PIC S9(9) BINARY VALUE 722.
       10  MQIAMO-GET-MAX-BYTES   PIC S9(9) BINARY VALUE 723.
       10  MQIAMO-GET-MIN-BYTES   PIC S9(9) BINARY VALUE 724.
       10  MQIAMO-GETS-FAILED   PIC S9(9) BINARY VALUE 725.
       10  MQIAMO-INCOMPLETE-BATCHES   PIC S9(9) BINARY VALUE 726.
       10  MQIAMO-INQS   PIC S9(9) BINARY VALUE 727.
       10  MQIAMO-MSGS   PIC S9(9) BINARY VALUE 728.
       10  MQIAMO-NET-TIME-AVG   PIC S9(9) BINARY VALUE 729.
       10  MQIAMO-NET-TIME-MAX   PIC S9(9) BINARY VALUE 730.
       10  MQIAMO-NET-TIME-MIN   PIC S9(9) BINARY VALUE 731.
       10  MQIAMO-OBJECT-COUNT   PIC S9(9) BINARY VALUE 732.
       10  MQIAMO-OPENS   PIC S9(9) BINARY VALUE 733.
       10  MQIAMO-PUT1S   PIC S9(9) BINARY VALUE 734.
       10  MQIAMO-PUTS   PIC S9(9) BINARY VALUE 735.
       10  MQIAMO-PUT-MAX-BYTES   PIC S9(9) BINARY VALUE 736.
       10  MQIAMO-PUT-MIN-BYTES   PIC S9(9) BINARY VALUE 737.
       10  MQIAMO-PUT-RETRIES   PIC S9(9) BINARY VALUE 738.
       10  MQIAMO-Q-MAX-DEPTH   PIC S9(9) BINARY VALUE 739.
       10  MQIAMO-Q-MIN-DEPTH   PIC S9(9) BINARY VALUE 740.
       10  MQIAMO-Q-TIME-AVG   PIC S9(9) BINARY VALUE 741.
       10  MQIAMO64-Q-TIME-AVG   PIC S9(9) BINARY VALUE 741.
       10  MQIAMO-Q-TIME-MAX   PIC S9(9) BINARY VALUE 742.
       10  MQIAMO64-Q-TIME-MAX   PIC S9(9) BINARY VALUE 742.
       10  MQIAMO-Q-TIME-MIN   PIC S9(9) BINARY VALUE 743.
       10  MQIAMO64-Q-TIME-MIN   PIC S9(9) BINARY VALUE 743.
       10  MQIAMO-SETS   PIC S9(9) BINARY VALUE 744.
       10  MQIAMO64-BROWSE-BYTES   PIC S9(9) BINARY VALUE 745.
       10  MQIAMO64-BYTES   PIC S9(9) BINARY VALUE 746.
       10  MQIAMO64-GET-BYTES   PIC S9(9) BINARY VALUE 747.
       10  MQIAMO64-PUT-BYTES   PIC S9(9) BINARY VALUE 748.
       10  MQIAMO-CONNS-FAILED   PIC S9(9) BINARY VALUE 749.
       10  MQIAMO-OPENS-FAILED   PIC S9(9) BINARY VALUE 751.
       10  MQIAMO-INQS-FAILED   PIC S9(9) BINARY VALUE 752.
       10  MQIAMO-SETS-FAILED   PIC S9(9) BINARY VALUE 753.
       10  MQIAMO-PUTS-FAILED   PIC S9(9) BINARY VALUE 754.
       10  MQIAMO-PUT1S-FAILED   PIC S9(9) BINARY VALUE 755.
       10  MQIAMO-CLOSES-FAILED   PIC S9(9) BINARY VALUE 757.
       10  MQIAMO-MSGS-EXPIRED   PIC S9(9) BINARY VALUE 758.
       10  MQIAMO-MSGS-NOT-QUEUED   PIC S9(9) BINARY VALUE 759.
       10  MQIAMO-MSGS-PURGED   PIC S9(9) BINARY VALUE 760.
       10  MQIAMO-SUBS-DUR   PIC S9(9) BINARY VALUE 764.
       10  MQIAMO-SUBS-NDUR   PIC S9(9) BINARY VALUE 765.
       10  MQIAMO-SUBS-FAILED   PIC S9(9) BINARY VALUE 766.
       10  MQIAMO-SUBRQS   PIC S9(9) BINARY VALUE 767.
       10  MQIAMO-SUBRQS-FAILED   PIC S9(9) BINARY VALUE 768.
       10  MQIAMO-CBS   PIC S9(9) BINARY VALUE 769.
       10  MQIAMO-CBS-FAILED   PIC S9(9) BINARY VALUE 770.
       10  MQIAMO-CTLS   PIC S9(9) BINARY VALUE 771.
       10  MQIAMO-CTLS-FAILED   PIC S9(9) BINARY VALUE 772.
       10  MQIAMO-STATS   PIC S9(9) BINARY VALUE 773.
       10  MQIAMO-STATS-FAILED   PIC S9(9) BINARY VALUE 774.
       10  MQIAMO-SUB-DUR-HIGHWATER   PIC S9(9) BINARY VALUE 775.
       10  MQIAMO-SUB-DUR-LOWWATER   PIC S9(9) BINARY VALUE 776.
       10  MQIAMO-SUB-NDUR-HIGHWATER   PIC S9(9) BINARY VALUE 777.
       10  MQIAMO-SUB-NDUR-LOWWATER   PIC S9(9) BINARY VALUE 778.
       10  MQIAMO-TOPIC-PUTS   PIC S9(9) BINARY VALUE 779.
       10  MQIAMO-TOPIC-PUTS-FAILED   PIC S9(9) BINARY VALUE 780.
       10  MQIAMO-TOPIC-PUT1S   PIC S9(9) BINARY VALUE 781.
       10  MQIAMO-TOPIC-PUT1S-FAILED   PIC S9(9) BINARY VALUE 782.
       10  MQIAMO64-TOPIC-PUT-BYTES   PIC S9(9) BINARY VALUE 783.
       10  MQIAMO-PUBLISH-MSG-COUNT   PIC S9(9) BINARY VALUE 784.
       10  MQIAMO64-PUBLISH-MSG-BYTES   PIC S9(9) BINARY VALUE 785.
       10  MQIAMO-UNSUBS-DUR   PIC S9(9) BINARY VALUE 786.
       10  MQIAMO-UNSUBS-NDUR   PIC S9(9) BINARY VALUE 787.
       10  MQIAMO-UNSUBS-FAILED   PIC S9(9) BINARY VALUE 788.
       10  MQIAMO-INTERVAL   PIC S9(9) BINARY VALUE 789.
       10  MQIAMO-MSGS-SENT   PIC S9(9) BINARY VALUE 790.
       10  MQIAMO-BYTES-SENT   PIC S9(9) BINARY VALUE 791.
       10  MQIAMO-REPAIR-BYTES   PIC S9(9) BINARY VALUE 792.
       10  MQIAMO-FEEDBACK-MODE   PIC S9(9) BINARY VALUE 793.
       10  MQIAMO-RELIABILITY-TYPE   PIC S9(9) BINARY VALUE 794.
       10  MQIAMO-LATE-JOIN-MARK   PIC S9(9) BINARY VALUE 795.
       10  MQIAMO-NACKS-RCVD   PIC S9(9) BINARY VALUE 796.
       10  MQIAMO-REPAIR-PKTS   PIC S9(9) BINARY VALUE 797.
       10  MQIAMO-HISTORY-PKTS   PIC S9(9) BINARY VALUE 798.
       10  MQIAMO-PENDING-PKTS   PIC S9(9) BINARY VALUE 799.
       10  MQIAMO-PKT-RATE   PIC S9(9) BINARY VALUE 800.
       10  MQIAMO-MCAST-XMIT-RATE   PIC S9(9) BINARY VALUE 801.
       10  MQIAMO-MCAST-BATCH-TIME   PIC S9(9) BINARY VALUE 802.
       10  MQIAMO-MCAST-HEARTBEAT   PIC S9(9) BINARY VALUE 803.
       10  MQIAMO-DEST-DATA-PORT   PIC S9(9) BINARY VALUE 804.
       10  MQIAMO-DEST-REPAIR-PORT   PIC S9(9) BINARY VALUE 805.
       10  MQIAMO-ACKS-RCVD   PIC S9(9) BINARY VALUE 806.
       10  MQIAMO-ACTIVE-ACKERS   PIC S9(9) BINARY VALUE 807.
       10  MQIAMO-PKTS-SENT   PIC S9(9) BINARY VALUE 808.
       10  MQIAMO-TOTAL-REPAIR-PKTS   PIC S9(9) BINARY VALUE 809.
       10  MQIAMO-TOTAL-PKTS-SENT   PIC S9(9) BINARY VALUE 810.
       10  MQIAMO-TOTAL-MSGS-SENT   PIC S9(9) BINARY VALUE 811.
       10  MQIAMO-TOTAL-BYTES-SENT   PIC S9(9) BINARY VALUE 812.
       10  MQIAMO-NUM-STREAMS   PIC S9(9) BINARY VALUE 813.
       10  MQIAMO-ACK-FEEDBACK   PIC S9(9) BINARY VALUE 814.
       10  MQIAMO-NACK-FEEDBACK   PIC S9(9) BINARY VALUE 815.
       10  MQIAMO-PKTS-LOST   PIC S9(9) BINARY VALUE 816.
       10  MQIAMO-MSGS-RCVD   PIC S9(9) BINARY VALUE 817.
       10  MQIAMO-MSG-BYTES-RCVD   PIC S9(9) BINARY VALUE 818.
       10  MQIAMO-MSGS-DELIVERED   PIC S9(9) BINARY VALUE 819.
       10  MQIAMO-PKTS-PROCESSED   PIC S9(9) BINARY VALUE 820.
       10  MQIAMO-PKTS-DELIVERED   PIC S9(9) BINARY VALUE 821.
       10  MQIAMO-PKTS-DROPPED   PIC S9(9) BINARY VALUE 822.
       10  MQIAMO-PKTS-DUPLICATED   PIC S9(9) BINARY VALUE 823.
       10  MQIAMO-NACKS-CREATED   PIC S9(9) BINARY VALUE 824.
       10  MQIAMO-NACK-PKTS-SENT   PIC S9(9) BINARY VALUE 825.
       10  MQIAMO-REPAIR-PKTS-RQSTD   PIC S9(9) BINARY VALUE 826.
       10  MQIAMO-REPAIR-PKTS-RCVD   PIC S9(9) BINARY VALUE 827.
       10  MQIAMO-PKTS-REPAIRED   PIC S9(9) BINARY VALUE 828.
       10  MQIAMO-TOTAL-MSGS-RCVD   PIC S9(9) BINARY VALUE 829.
       10  MQIAMO-TOTAL-MSG-BYTES-RCVD   PIC S9(9) BINARY VALUE 830.
       10  MQIAMO-TOTAL-REPAIR-PKTS-RCVD   PIC S9(9) BINARY VALUE 831.
       10  MQIAMO-TOTAL-REPAIR-PKTS-RQSTD   PIC S9(9) BINARY VALUE 832.
       10  MQIAMO-TOTAL-MSGS-PROCESSED   PIC S9(9) BINARY VALUE 833.
       10  MQIAMO-TOTAL-MSGS-SELECTED   PIC S9(9) BINARY VALUE 834.
       10  MQIAMO-TOTAL-MSGS-EXPIRED   PIC S9(9) BINARY VALUE 835.
       10  MQIAMO-TOTAL-MSGS-DELIVERED   PIC S9(9) BINARY VALUE 836.
       10  MQIAMO-TOTAL-MSGS-RETURNED   PIC S9(9) BINARY VALUE 837.
       10  MQIAMO64-HIGHRES-TIME   PIC S9(9) BINARY VALUE 838.
       10  MQIAMO-MONITOR-CLASS   PIC S9(9) BINARY VALUE 839.
       10  MQIAMO-MONITOR-TYPE   PIC S9(9) BINARY VALUE 840.
       10  MQIAMO-MONITOR-ELEMENT   PIC S9(9) BINARY VALUE 841.
       10  MQIAMO-MONITOR-DATATYPE   PIC S9(9) BINARY VALUE 842.
       10  MQIAMO-MONITOR-FLAGS   PIC S9(9) BINARY VALUE 843.
       10  MQIAMO64-QMGR-OP-DURATION   PIC S9(9) BINARY VALUE 844.
       10  MQIAMO64-MONITOR-INTERVAL   PIC S9(9) BINARY VALUE 845.
       10  MQIAMO-LAST-USED   PIC S9(9) BINARY VALUE 845.

      ** Defined values for MQIAMO_MONITOR_FLAGS
       10  MQIAMO-MONITOR-FLAGS-NONE   PIC S9(9) BINARY VALUE 0.
       10  MQIAMO-MONITOR-FLAGS-OBJNAME   PIC S9(9) BINARY VALUE 1.

      ** Defined values for MQIAMO_MONITOR_DATATYPE
       10  MQIAMO-MONITOR-UNIT   PIC S9(9) BINARY VALUE 1.
       10  MQIAMO-MONITOR-DELTA   PIC S9(9) BINARY VALUE 2.
       10  MQIAMO-MONITOR-HUNDREDTHS   PIC S9(9) BINARY VALUE 100.
       10  MQIAMO-MONITOR-KB   PIC S9(9) BINARY VALUE 1024.
       10  MQIAMO-MONITOR-PERCENT   PIC S9(9) BINARY VALUE 10000.
       10  MQIAMO-MONITOR-MICROSEC   PIC S9(9) BINARY VALUE 1000000.
       10  MQIAMO-MONITOR-MB   PIC S9(9) BINARY VALUE 1048576.
       10  MQIAMO-MONITOR-GB   PIC S9(9) BINARY VALUE 100000000.

      ** Integer Parameter Types
       10  MQIACF-FIRST   PIC S9(9) BINARY VALUE 1001.
       10  MQIACF-Q-MGR-ATTRS   PIC S9(9) BINARY VALUE 1001.
       10  MQIACF-Q-ATTRS   PIC S9(9) BINARY VALUE 1002.
       10  MQIACF-PROCESS-ATTRS   PIC S9(9) BINARY VALUE 1003.
       10  MQIACF-NAMELIST-ATTRS   PIC S9(9) BINARY VALUE 1004.
       10  MQIACF-FORCE   PIC S9(9) BINARY VALUE 1005.
       10  MQIACF-REPLACE   PIC S9(9) BINARY VALUE 1006.
       10  MQIACF-PURGE   PIC S9(9) BINARY VALUE 1007.
       10  MQIACF-QUIESCE   PIC S9(9) BINARY VALUE 1008.
       10  MQIACF-MODE   PIC S9(9) BINARY VALUE 1008.
       10  MQIACF-ALL   PIC S9(9) BINARY VALUE 1009.
       10  MQIACF-EVENT-APPL-TYPE   PIC S9(9) BINARY VALUE 1010.
       10  MQIACF-EVENT-ORIGIN   PIC S9(9) BINARY VALUE 1011.
       10  MQIACF-PARAMETER-ID   PIC S9(9) BINARY VALUE 1012.
       10  MQIACF-ERROR-ID   PIC S9(9) BINARY VALUE 1013.
       10  MQIACF-ERROR-IDENTIFIER   PIC S9(9) BINARY VALUE 1013.
       10  MQIACF-SELECTOR   PIC S9(9) BINARY VALUE 1014.
       10  MQIACF-CHANNEL-ATTRS   PIC S9(9) BINARY VALUE 1015.
       10  MQIACF-OBJECT-TYPE   PIC S9(9) BINARY VALUE 1016.
       10  MQIACF-ESCAPE-TYPE   PIC S9(9) BINARY VALUE 1017.
       10  MQIACF-ERROR-OFFSET   PIC S9(9) BINARY VALUE 1018.
       10  MQIACF-AUTH-INFO-ATTRS   PIC S9(9) BINARY VALUE 1019.
       10  MQIACF-REASON-QUALIFIER   PIC S9(9) BINARY VALUE 1020.
       10  MQIACF-COMMAND   PIC S9(9) BINARY VALUE 1021.
       10  MQIACF-OPEN-OPTIONS   PIC S9(9) BINARY VALUE 1022.
       10  MQIACF-OPEN-TYPE   PIC S9(9) BINARY VALUE 1023.
       10  MQIACF-PROCESS-ID   PIC S9(9) BINARY VALUE 1024.
       10  MQIACF-THREAD-ID   PIC S9(9) BINARY VALUE 1025.
       10  MQIACF-Q-STATUS-ATTRS   PIC S9(9) BINARY VALUE 1026.
       10  MQIACF-UNCOMMITTED-MSGS   PIC S9(9) BINARY VALUE 1027.
       10  MQIACF-HANDLE-STATE   PIC S9(9) BINARY VALUE 1028.
       10  MQIACF-AUX-ERROR-DATA-INT-1   PIC S9(9) BINARY VALUE 1070.
       10  MQIACF-AUX-ERROR-DATA-INT-2   PIC S9(9) BINARY VALUE 1071.
       10  MQIACF-CONV-REASON-CODE   PIC S9(9) BINARY VALUE 1072.
       10  MQIACF-BRIDGE-TYPE   PIC S9(9) BINARY VALUE 1073.
       10  MQIACF-INQUIRY   PIC S9(9) BINARY VALUE 1074.
       10  MQIACF-WAIT-INTERVAL   PIC S9(9) BINARY VALUE 1075.
       10  MQIACF-OPTIONS   PIC S9(9) BINARY VALUE 1076.
       10  MQIACF-BROKER-OPTIONS   PIC S9(9) BINARY VALUE 1077.
       10  MQIACF-REFRESH-TYPE   PIC S9(9) BINARY VALUE 1078.
       10  MQIACF-SEQUENCE-NUMBER   PIC S9(9) BINARY VALUE 1079.
       10  MQIACF-INTEGER-DATA   PIC S9(9) BINARY VALUE 1080.
       10  MQIACF-REGISTRATION-OPTIONS   PIC S9(9) BINARY VALUE 1081.
       10  MQIACF-PUBLICATION-OPTIONS   PIC S9(9) BINARY VALUE 1082.
       10  MQIACF-CLUSTER-INFO   PIC S9(9) BINARY VALUE 1083.
       10  MQIACF-Q-MGR-DEFINITION-TYPE   PIC S9(9) BINARY VALUE 1084.
       10  MQIACF-Q-MGR-TYPE   PIC S9(9) BINARY VALUE 1085.
       10  MQIACF-ACTION   PIC S9(9) BINARY VALUE 1086.
       10  MQIACF-SUSPEND   PIC S9(9) BINARY VALUE 1087.
       10  MQIACF-BROKER-COUNT   PIC S9(9) BINARY VALUE 1088.
       10  MQIACF-APPL-COUNT   PIC S9(9) BINARY VALUE 1089.
       10  MQIACF-ANONYMOUS-COUNT   PIC S9(9) BINARY VALUE 1090.
       10  MQIACF-REG-REG-OPTIONS   PIC S9(9) BINARY VALUE 1091.
       10  MQIACF-DELETE-OPTIONS   PIC S9(9) BINARY VALUE 1092.
       10  MQIACF-CLUSTER-Q-MGR-ATTRS   PIC S9(9) BINARY VALUE 1093.
       10  MQIACF-REFRESH-INTERVAL   PIC S9(9) BINARY VALUE 1094.
       10  MQIACF-REFRESH-REPOSITORY   PIC S9(9) BINARY VALUE 1095.
       10  MQIACF-REMOVE-QUEUES   PIC S9(9) BINARY VALUE 1096.
       10  MQIACF-OPEN-INPUT-TYPE   PIC S9(9) BINARY VALUE 1098.
       10  MQIACF-OPEN-OUTPUT   PIC S9(9) BINARY VALUE 1099.
       10  MQIACF-OPEN-SET   PIC S9(9) BINARY VALUE 1100.
       10  MQIACF-OPEN-INQUIRE   PIC S9(9) BINARY VALUE 1101.
       10  MQIACF-OPEN-BROWSE   PIC S9(9) BINARY VALUE 1102.
       10  MQIACF-Q-STATUS-TYPE   PIC S9(9) BINARY VALUE 1103.
       10  MQIACF-Q-HANDLE   PIC S9(9) BINARY VALUE 1104.
       10  MQIACF-Q-STATUS   PIC S9(9) BINARY VALUE 1105.
       10  MQIACF-SECURITY-TYPE   PIC S9(9) BINARY VALUE 1106.
       10  MQIACF-CONNECTION-ATTRS   PIC S9(9) BINARY VALUE 1107.
       10  MQIACF-CONNECT-OPTIONS   PIC S9(9) BINARY VALUE 1108.
       10  MQIACF-CONN-INFO-TYPE   PIC S9(9) BINARY VALUE 1110.
       10  MQIACF-CONN-INFO-CONN   PIC S9(9) BINARY VALUE 1111.
       10  MQIACF-CONN-INFO-HANDLE   PIC S9(9) BINARY VALUE 1112.
       10  MQIACF-CONN-INFO-ALL   PIC S9(9) BINARY VALUE 1113.
       10  MQIACF-AUTH-PROFILE-ATTRS   PIC S9(9) BINARY VALUE 1114.
       10  MQIACF-AUTHORIZATION-LIST   PIC S9(9) BINARY VALUE 1115.
       10  MQIACF-AUTH-ADD-AUTHS   PIC S9(9) BINARY VALUE 1116.
       10  MQIACF-AUTH-REMOVE-AUTHS   PIC S9(9) BINARY VALUE 1117.
       10  MQIACF-ENTITY-TYPE   PIC S9(9) BINARY VALUE 1118.
       10  MQIACF-COMMAND-INFO   PIC S9(9) BINARY VALUE 1120.
       10  MQIACF-CMDSCOPE-Q-MGR-COUNT   PIC S9(9) BINARY VALUE 1121.
       10  MQIACF-Q-MGR-SYSTEM   PIC S9(9) BINARY VALUE 1122.
       10  MQIACF-Q-MGR-EVENT   PIC S9(9) BINARY VALUE 1123.
       10  MQIACF-Q-MGR-DQM   PIC S9(9) BINARY VALUE 1124.
       10  MQIACF-Q-MGR-CLUSTER   PIC S9(9) BINARY VALUE 1125.
       10  MQIACF-QSG-DISPS   PIC S9(9) BINARY VALUE 1126.
       10  MQIACF-UOW-STATE   PIC S9(9) BINARY VALUE 1128.
       10  MQIACF-SECURITY-ITEM   PIC S9(9) BINARY VALUE 1129.
       10  MQIACF-CF-STRUC-STATUS   PIC S9(9) BINARY VALUE 1130.
       10  MQIACF-UOW-TYPE   PIC S9(9) BINARY VALUE 1132.
       10  MQIACF-CF-STRUC-ATTRS   PIC S9(9) BINARY VALUE 1133.
       10  MQIACF-EXCLUDE-INTERVAL   PIC S9(9) BINARY VALUE 1134.
       10  MQIACF-CF-STATUS-TYPE   PIC S9(9) BINARY VALUE 1135.
       10  MQIACF-CF-STATUS-SUMMARY   PIC S9(9) BINARY VALUE 1136.
       10  MQIACF-CF-STATUS-CONNECT   PIC S9(9) BINARY VALUE 1137.
       10  MQIACF-CF-STATUS-BACKUP   PIC S9(9) BINARY VALUE 1138.
       10  MQIACF-CF-STRUC-TYPE   PIC S9(9) BINARY VALUE 1139.
       10  MQIACF-CF-STRUC-SIZE-MAX   PIC S9(9) BINARY VALUE 1140.
       10  MQIACF-CF-STRUC-SIZE-USED   PIC S9(9) BINARY VALUE 1141.
       10  MQIACF-CF-STRUC-ENTRIES-MAX   PIC S9(9) BINARY VALUE 1142.
       10  MQIACF-CF-STRUC-ENTRIES-USED   PIC S9(9) BINARY VALUE 1143.
       10  MQIACF-CF-STRUC-BACKUP-SIZE   PIC S9(9) BINARY VALUE 1144.
       10  MQIACF-MOVE-TYPE   PIC S9(9) BINARY VALUE 1145.
       10  MQIACF-MOVE-TYPE-MOVE   PIC S9(9) BINARY VALUE 1146.
       10  MQIACF-MOVE-TYPE-ADD   PIC S9(9) BINARY VALUE 1147.
       10  MQIACF-Q-MGR-NUMBER   PIC S9(9) BINARY VALUE 1148.
       10  MQIACF-Q-MGR-STATUS   PIC S9(9) BINARY VALUE 1149.
       10  MQIACF-DB2-CONN-STATUS   PIC S9(9) BINARY VALUE 1150.
       10  MQIACF-SECURITY-ATTRS   PIC S9(9) BINARY VALUE 1151.
       10  MQIACF-SECURITY-TIMEOUT   PIC S9(9) BINARY VALUE 1152.
       10  MQIACF-SECURITY-INTERVAL   PIC S9(9) BINARY VALUE 1153.
       10  MQIACF-SECURITY-SWITCH   PIC S9(9) BINARY VALUE 1154.
       10  MQIACF-SECURITY-SETTING   PIC S9(9) BINARY VALUE 1155.
       10  MQIACF-STORAGE-CLASS-ATTRS   PIC S9(9) BINARY VALUE 1156.
       10  MQIACF-USAGE-TYPE   PIC S9(9) BINARY VALUE 1157.
       10  MQIACF-BUFFER-POOL-ID   PIC S9(9) BINARY VALUE 1158.
       10  MQIACF-USAGE-TOTAL-PAGES   PIC S9(9) BINARY VALUE 1159.
       10  MQIACF-USAGE-UNUSED-PAGES   PIC S9(9) BINARY VALUE 1160.
       10  MQIACF-USAGE-PERSIST-PAGES   PIC S9(9) BINARY VALUE 1161.
       10  MQIACF-USAGE-NONPERSIST-PAGES   PIC S9(9) BINARY VALUE 1162.
       10  MQIACF-USAGE-RESTART-EXTENTS   PIC S9(9) BINARY VALUE 1163.
       10  MQIACF-USAGE-EXPAND-COUNT   PIC S9(9) BINARY VALUE 1164.
       10  MQIACF-PAGESET-STATUS   PIC S9(9) BINARY VALUE 1165.
       10  MQIACF-USAGE-TOTAL-BUFFERS   PIC S9(9) BINARY VALUE 1166.
       10  MQIACF-USAGE-DATA-SET-TYPE   PIC S9(9) BINARY VALUE 1167.
       10  MQIACF-USAGE-PAGESET   PIC S9(9) BINARY VALUE 1168.
       10  MQIACF-USAGE-DATA-SET   PIC S9(9) BINARY VALUE 1169.
       10  MQIACF-USAGE-BUFFER-POOL   PIC S9(9) BINARY VALUE 1170.
       10  MQIACF-MOVE-COUNT   PIC S9(9) BINARY VALUE 1171.
       10  MQIACF-EXPIRY-Q-COUNT   PIC S9(9) BINARY VALUE 1172.
       10  MQIACF-CONFIGURATION-OBJECTS   PIC S9(9) BINARY VALUE 1173.
       10  MQIACF-CONFIGURATION-EVENTS   PIC S9(9) BINARY VALUE 1174.
       10  MQIACF-SYSP-TYPE   PIC S9(9) BINARY VALUE 1175.
       10  MQIACF-SYSP-DEALLOC-INTERVAL   PIC S9(9) BINARY VALUE 1176.
       10  MQIACF-SYSP-MAX-ARCHIVE   PIC S9(9) BINARY VALUE 1177.
       10  MQIACF-SYSP-MAX-READ-TAPES   PIC S9(9) BINARY VALUE 1178.
       10  MQIACF-SYSP-IN-BUFFER-SIZE   PIC S9(9) BINARY VALUE 1179.
       10  MQIACF-SYSP-OUT-BUFFER-SIZE   PIC S9(9) BINARY VALUE 1180.
       10  MQIACF-SYSP-OUT-BUFFER-COUNT   PIC S9(9) BINARY VALUE 1181.
       10  MQIACF-SYSP-ARCHIVE   PIC S9(9) BINARY VALUE 1182.
       10  MQIACF-SYSP-DUAL-ACTIVE   PIC S9(9) BINARY VALUE 1183.
       10  MQIACF-SYSP-DUAL-ARCHIVE   PIC S9(9) BINARY VALUE 1184.
       10  MQIACF-SYSP-DUAL-BSDS   PIC S9(9) BINARY VALUE 1185.
       10  MQIACF-SYSP-MAX-CONNS   PIC S9(9) BINARY VALUE 1186.
       10  MQIACF-SYSP-MAX-CONNS-FORE   PIC S9(9) BINARY VALUE 1187.
       10  MQIACF-SYSP-MAX-CONNS-BACK   PIC S9(9) BINARY VALUE 1188.
       10  MQIACF-SYSP-EXIT-INTERVAL   PIC S9(9) BINARY VALUE 1189.
       10  MQIACF-SYSP-EXIT-TASKS   PIC S9(9) BINARY VALUE 1190.
       10  MQIACF-SYSP-CHKPOINT-COUNT   PIC S9(9) BINARY VALUE 1191.
       10  MQIACF-SYSP-OTMA-INTERVAL   PIC S9(9) BINARY VALUE 1192.
       10  MQIACF-SYSP-Q-INDEX-DEFER   PIC S9(9) BINARY VALUE 1193.
       10  MQIACF-SYSP-DB2-TASKS   PIC S9(9) BINARY VALUE 1194.
       10  MQIACF-SYSP-RESLEVEL-AUDIT   PIC S9(9) BINARY VALUE 1195.
       10  MQIACF-SYSP-ROUTING-CODE   PIC S9(9) BINARY VALUE 1196.
       10  MQIACF-SYSP-SMF-ACCOUNTING   PIC S9(9) BINARY VALUE 1197.
       10  MQIACF-SYSP-SMF-STATS   PIC S9(9) BINARY VALUE 1198.
       10  MQIACF-SYSP-SMF-INTERVAL   PIC S9(9) BINARY VALUE 1199.
       10  MQIACF-SYSP-SMF-STAT-TIME-MINS   PIC S9(9) BINARY VALUE 1199.
       10  MQIACF-SYSP-TRACE-CLASS   PIC S9(9) BINARY VALUE 1200.
       10  MQIACF-SYSP-TRACE-SIZE   PIC S9(9) BINARY VALUE 1201.
       10  MQIACF-SYSP-WLM-INTERVAL   PIC S9(9) BINARY VALUE 1202.
       10  MQIACF-SYSP-ALLOC-UNIT   PIC S9(9) BINARY VALUE 1203.
       10  MQIACF-SYSP-ARCHIVE-RETAIN   PIC S9(9) BINARY VALUE 1204.
       10  MQIACF-SYSP-ARCHIVE-WTOR   PIC S9(9) BINARY VALUE 1205.
       10  MQIACF-SYSP-BLOCK-SIZE   PIC S9(9) BINARY VALUE 1206.
       10  MQIACF-SYSP-CATALOG   PIC S9(9) BINARY VALUE 1207.
       10  MQIACF-SYSP-COMPACT   PIC S9(9) BINARY VALUE 1208.
       10  MQIACF-SYSP-ALLOC-PRIMARY   PIC S9(9) BINARY VALUE 1209.
       10  MQIACF-SYSP-ALLOC-SECONDARY   PIC S9(9) BINARY VALUE 1210.
       10  MQIACF-SYSP-PROTECT   PIC S9(9) BINARY VALUE 1211.
       10  MQIACF-SYSP-QUIESCE-INTERVAL   PIC S9(9) BINARY VALUE 1212.
       10  MQIACF-SYSP-TIMESTAMP   PIC S9(9) BINARY VALUE 1213.
       10  MQIACF-SYSP-UNIT-ADDRESS   PIC S9(9) BINARY VALUE 1214.
       10  MQIACF-SYSP-UNIT-STATUS   PIC S9(9) BINARY VALUE 1215.
       10  MQIACF-SYSP-LOG-COPY   PIC S9(9) BINARY VALUE 1216.
       10  MQIACF-SYSP-LOG-USED   PIC S9(9) BINARY VALUE 1217.
       10  MQIACF-SYSP-LOG-SUSPEND   PIC S9(9) BINARY VALUE 1218.
       10  MQIACF-SYSP-OFFLOAD-STATUS   PIC S9(9) BINARY VALUE 1219.
       10  MQIACF-SYSP-TOTAL-LOGS   PIC S9(9) BINARY VALUE 1220.
       10  MQIACF-SYSP-FULL-LOGS   PIC S9(9) BINARY VALUE 1221.
       10  MQIACF-LISTENER-ATTRS   PIC S9(9) BINARY VALUE 1222.
       10  MQIACF-LISTENER-STATUS-ATTRS   PIC S9(9) BINARY VALUE 1223.
       10  MQIACF-SERVICE-ATTRS   PIC S9(9) BINARY VALUE 1224.
       10  MQIACF-SERVICE-STATUS-ATTRS   PIC S9(9) BINARY VALUE 1225.
       10  MQIACF-Q-TIME-INDICATOR   PIC S9(9) BINARY VALUE 1226.
       10  MQIACF-OLDEST-MSG-AGE   PIC S9(9) BINARY VALUE 1227.
       10  MQIACF-AUTH-OPTIONS   PIC S9(9) BINARY VALUE 1228.
       10  MQIACF-Q-MGR-STATUS-ATTRS   PIC S9(9) BINARY VALUE 1229.
       10  MQIACF-CONNECTION-COUNT   PIC S9(9) BINARY VALUE 1230.
       10  MQIACF-Q-MGR-FACILITY   PIC S9(9) BINARY VALUE 1231.
       10  MQIACF-CHINIT-STATUS   PIC S9(9) BINARY VALUE 1232.
       10  MQIACF-CMD-SERVER-STATUS   PIC S9(9) BINARY VALUE 1233.
       10  MQIACF-ROUTE-DETAIL   PIC S9(9) BINARY VALUE 1234.
       10  MQIACF-RECORDED-ACTIVITIES   PIC S9(9) BINARY VALUE 1235.
       10  MQIACF-MAX-ACTIVITIES   PIC S9(9) BINARY VALUE 1236.
       10  MQIACF-DISCONTINUITY-COUNT   PIC S9(9) BINARY VALUE 1237.
       10  MQIACF-ROUTE-ACCUMULATION   PIC S9(9) BINARY VALUE 1238.
       10  MQIACF-ROUTE-DELIVERY   PIC S9(9) BINARY VALUE 1239.
       10  MQIACF-OPERATION-TYPE   PIC S9(9) BINARY VALUE 1240.
       10  MQIACF-BACKOUT-COUNT   PIC S9(9) BINARY VALUE 1241.
       10  MQIACF-COMP-CODE   PIC S9(9) BINARY VALUE 1242.
       10  MQIACF-ENCODING   PIC S9(9) BINARY VALUE 1243.
       10  MQIACF-EXPIRY   PIC S9(9) BINARY VALUE 1244.
       10  MQIACF-FEEDBACK   PIC S9(9) BINARY VALUE 1245.
       10  MQIACF-MSG-FLAGS   PIC S9(9) BINARY VALUE 1247.
       10  MQIACF-MSG-LENGTH   PIC S9(9) BINARY VALUE 1248.
       10  MQIACF-MSG-TYPE   PIC S9(9) BINARY VALUE 1249.
       10  MQIACF-OFFSET   PIC S9(9) BINARY VALUE 1250.
       10  MQIACF-ORIGINAL-LENGTH   PIC S9(9) BINARY VALUE 1251.
       10  MQIACF-PERSISTENCE   PIC S9(9) BINARY VALUE 1252.
       10  MQIACF-PRIORITY   PIC S9(9) BINARY VALUE 1253.
       10  MQIACF-REASON-CODE   PIC S9(9) BINARY VALUE 1254.
       10  MQIACF-REPORT   PIC S9(9) BINARY VALUE 1255.
       10  MQIACF-VERSION   PIC S9(9) BINARY VALUE 1256.
       10  MQIACF-UNRECORDED-ACTIVITIES   PIC S9(9) BINARY VALUE 1257.
       10  MQIACF-MONITORING   PIC S9(9) BINARY VALUE 1258.
       10  MQIACF-ROUTE-FORWARDING   PIC S9(9) BINARY VALUE 1259.
       10  MQIACF-SERVICE-STATUS   PIC S9(9) BINARY VALUE 1260.
       10  MQIACF-Q-TYPES   PIC S9(9) BINARY VALUE 1261.
       10  MQIACF-USER-ID-SUPPORT   PIC S9(9) BINARY VALUE 1262.
       10  MQIACF-INTERFACE-VERSION   PIC S9(9) BINARY VALUE 1263.
       10  MQIACF-AUTH-SERVICE-ATTRS   PIC S9(9) BINARY VALUE 1264.
       10  MQIACF-USAGE-EXPAND-TYPE   PIC S9(9) BINARY VALUE 1265.
       10  MQIACF-SYSP-CLUSTER-CACHE   PIC S9(9) BINARY VALUE 1266.
       10  MQIACF-SYSP-DB2-BLOB-TASKS   PIC S9(9) BINARY VALUE 1267.
       10  MQIACF-SYSP-WLM-INT-UNITS   PIC S9(9) BINARY VALUE 1268.
       10  MQIACF-TOPIC-ATTRS   PIC S9(9) BINARY VALUE 1269.
       10  MQIACF-PUBSUB-PROPERTIES   PIC S9(9) BINARY VALUE 1271.
       10  MQIACF-DESTINATION-CLASS   PIC S9(9) BINARY VALUE 1273.
       10  MQIACF-DURABLE-SUBSCRIPTION   PIC S9(9) BINARY VALUE 1274.
       10  MQIACF-SUBSCRIPTION-SCOPE   PIC S9(9) BINARY VALUE 1275.
       10  MQIACF-VARIABLE-USER-ID   PIC S9(9) BINARY VALUE 1277.
       10  MQIACF-REQUEST-ONLY   PIC S9(9) BINARY VALUE 1280.
       10  MQIACF-PUB-PRIORITY   PIC S9(9) BINARY VALUE 1283.
       10  MQIACF-SUB-ATTRS   PIC S9(9) BINARY VALUE 1287.
       10  MQIACF-WILDCARD-SCHEMA   PIC S9(9) BINARY VALUE 1288.
       10  MQIACF-SUB-TYPE   PIC S9(9) BINARY VALUE 1289.
       10  MQIACF-MESSAGE-COUNT   PIC S9(9) BINARY VALUE 1290.
       10  MQIACF-Q-MGR-PUBSUB   PIC S9(9) BINARY VALUE 1291.
       10  MQIACF-Q-MGR-VERSION   PIC S9(9) BINARY VALUE 1292.
       10  MQIACF-SUB-STATUS-ATTRS   PIC S9(9) BINARY VALUE 1294.
       10  MQIACF-TOPIC-STATUS   PIC S9(9) BINARY VALUE 1295.
       10  MQIACF-TOPIC-SUB   PIC S9(9) BINARY VALUE 1296.
       10  MQIACF-TOPIC-PUB   PIC S9(9) BINARY VALUE 1297.
       10  MQIACF-RETAINED-PUBLICATION   PIC S9(9) BINARY VALUE 1300.
       10  MQIACF-TOPIC-STATUS-ATTRS   PIC S9(9) BINARY VALUE 1301.
       10  MQIACF-TOPIC-STATUS-TYPE   PIC S9(9) BINARY VALUE 1302.
       10  MQIACF-SUB-OPTIONS   PIC S9(9) BINARY VALUE 1303.
       10  MQIACF-PUBLISH-COUNT   PIC S9(9) BINARY VALUE 1304.
       10  MQIACF-CLEAR-TYPE   PIC S9(9) BINARY VALUE 1305.
       10  MQIACF-CLEAR-SCOPE   PIC S9(9) BINARY VALUE 1306.
       10  MQIACF-SUB-LEVEL   PIC S9(9) BINARY VALUE 1307.
       10  MQIACF-ASYNC-STATE   PIC S9(9) BINARY VALUE 1308.
       10  MQIACF-SUB-SUMMARY   PIC S9(9) BINARY VALUE 1309.
       10  MQIACF-OBSOLETE-MSGS   PIC S9(9) BINARY VALUE 1310.
       10  MQIACF-PUBSUB-STATUS   PIC S9(9) BINARY VALUE 1311.
       10  MQIACF-PS-STATUS-TYPE   PIC S9(9) BINARY VALUE 1314.
       10  MQIACF-PUBSUB-STATUS-ATTRS   PIC S9(9) BINARY VALUE 1318.
       10  MQIACF-SELECTOR-TYPE   PIC S9(9) BINARY VALUE 1321.
       10  MQIACF-LOG-COMPRESSION   PIC S9(9) BINARY VALUE 1322.
       10  MQIACF-GROUPUR-CHECK-ID   PIC S9(9) BINARY VALUE 1323.
       10  MQIACF-MULC-CAPTURE   PIC S9(9) BINARY VALUE 1324.
       10  MQIACF-PERMIT-STANDBY   PIC S9(9) BINARY VALUE 1325.
       10  MQIACF-OPERATION-MODE   PIC S9(9) BINARY VALUE 1326.
       10  MQIACF-COMM-INFO-ATTRS   PIC S9(9) BINARY VALUE 1327.
       10  MQIACF-CF-SMDS-BLOCK-SIZE   PIC S9(9) BINARY VALUE 1328.
       10  MQIACF-CF-SMDS-EXPAND   PIC S9(9) BINARY VALUE 1329.
       10  MQIACF-USAGE-FREE-BUFF   PIC S9(9) BINARY VALUE 1330.
       10  MQIACF-USAGE-FREE-BUFF-PERC   PIC S9(9) BINARY VALUE 1331.
       10  MQIACF-CF-STRUC-ACCESS   PIC S9(9) BINARY VALUE 1332.
       10  MQIACF-CF-STATUS-SMDS   PIC S9(9) BINARY VALUE 1333.
       10  MQIACF-SMDS-ATTRS   PIC S9(9) BINARY VALUE 1334.
       10  MQIACF-USAGE-SMDS   PIC S9(9) BINARY VALUE 1335.
       10  MQIACF-USAGE-BLOCK-SIZE   PIC S9(9) BINARY VALUE 1336.
       10  MQIACF-USAGE-DATA-BLOCKS   PIC S9(9) BINARY VALUE 1337.
       10  MQIACF-USAGE-EMPTY-BUFFERS   PIC S9(9) BINARY VALUE 1338.
       10  MQIACF-USAGE-INUSE-BUFFERS   PIC S9(9) BINARY VALUE 1339.
       10  MQIACF-USAGE-LOWEST-FREE   PIC S9(9) BINARY VALUE 1340.
       10  MQIACF-USAGE-OFFLOAD-MSGS   PIC S9(9) BINARY VALUE 1341.
       10  MQIACF-USAGE-READS-SAVED   PIC S9(9) BINARY VALUE 1342.
       10  MQIACF-USAGE-SAVED-BUFFERS   PIC S9(9) BINARY VALUE 1343.
       10  MQIACF-USAGE-TOTAL-BLOCKS   PIC S9(9) BINARY VALUE 1344.
       10  MQIACF-USAGE-USED-BLOCKS   PIC S9(9) BINARY VALUE 1345.
       10  MQIACF-USAGE-USED-RATE   PIC S9(9) BINARY VALUE 1346.
       10  MQIACF-USAGE-WAIT-RATE   PIC S9(9) BINARY VALUE 1347.
       10  MQIACF-SMDS-OPENMODE   PIC S9(9) BINARY VALUE 1348.
       10  MQIACF-SMDS-STATUS   PIC S9(9) BINARY VALUE 1349.
       10  MQIACF-SMDS-AVAIL   PIC S9(9) BINARY VALUE 1350.
       10  MQIACF-MCAST-REL-INDICATOR   PIC S9(9) BINARY VALUE 1351.
       10  MQIACF-CHLAUTH-TYPE   PIC S9(9) BINARY VALUE 1352.
       10  MQIACF-MQXR-DIAGNOSTICS-TYPE   PIC S9(9) BINARY VALUE 1354.
       10  MQIACF-CHLAUTH-ATTRS   PIC S9(9) BINARY VALUE 1355.
       10  MQIACF-OPERATION-ID   PIC S9(9) BINARY VALUE 1356.
       10  MQIACF-API-CALLER-TYPE   PIC S9(9) BINARY VALUE 1357.
       10  MQIACF-API-ENVIRONMENT   PIC S9(9) BINARY VALUE 1358.
       10  MQIACF-TRACE-DETAIL   PIC S9(9) BINARY VALUE 1359.
       10  MQIACF-HOBJ   PIC S9(9) BINARY VALUE 1360.
       10  MQIACF-CALL-TYPE   PIC S9(9) BINARY VALUE 1361.
       10  MQIACF-MQCB-OPERATION   PIC S9(9) BINARY VALUE 1362.
       10  MQIACF-MQCB-TYPE   PIC S9(9) BINARY VALUE 1363.
       10  MQIACF-MQCB-OPTIONS   PIC S9(9) BINARY VALUE 1364.
       10  MQIACF-CLOSE-OPTIONS   PIC S9(9) BINARY VALUE 1365.
       10  MQIACF-CTL-OPERATION   PIC S9(9) BINARY VALUE 1366.
       10  MQIACF-GET-OPTIONS   PIC S9(9) BINARY VALUE 1367.
       10  MQIACF-RECS-PRESENT   PIC S9(9) BINARY VALUE 1368.
       10  MQIACF-KNOWN-DEST-COUNT   PIC S9(9) BINARY VALUE 1369.
       10  MQIACF-UNKNOWN-DEST-COUNT   PIC S9(9) BINARY VALUE 1370.
       10  MQIACF-INVALID-DEST-COUNT   PIC S9(9) BINARY VALUE 1371.
       10  MQIACF-RESOLVED-TYPE   PIC S9(9) BINARY VALUE 1372.
       10  MQIACF-PUT-OPTIONS   PIC S9(9) BINARY VALUE 1373.
       10  MQIACF-BUFFER-LENGTH   PIC S9(9) BINARY VALUE 1374.
       10  MQIACF-TRACE-DATA-LENGTH   PIC S9(9) BINARY VALUE 1375.
       10  MQIACF-SMDS-EXPANDST   PIC S9(9) BINARY VALUE 1376.
       10  MQIACF-STRUC-LENGTH   PIC S9(9) BINARY VALUE 1377.
       10  MQIACF-ITEM-COUNT   PIC S9(9) BINARY VALUE 1378.
       10  MQIACF-EXPIRY-TIME   PIC S9(9) BINARY VALUE 1379.
       10  MQIACF-CONNECT-TIME   PIC S9(9) BINARY VALUE 1380.
       10  MQIACF-DISCONNECT-TIME   PIC S9(9) BINARY VALUE 1381.
       10  MQIACF-HSUB   PIC S9(9) BINARY VALUE 1382.
       10  MQIACF-SUBRQ-OPTIONS   PIC S9(9) BINARY VALUE 1383.
       10  MQIACF-XA-RMID   PIC S9(9) BINARY VALUE 1384.
       10  MQIACF-XA-FLAGS   PIC S9(9) BINARY VALUE 1385.
       10  MQIACF-XA-RETCODE   PIC S9(9) BINARY VALUE 1386.
       10  MQIACF-XA-HANDLE   PIC S9(9) BINARY VALUE 1387.
       10  MQIACF-XA-RETVAL   PIC S9(9) BINARY VALUE 1388.
       10  MQIACF-STATUS-TYPE   PIC S9(9) BINARY VALUE 1389.
       10  MQIACF-XA-COUNT   PIC S9(9) BINARY VALUE 1390.
       10  MQIACF-SELECTOR-COUNT   PIC S9(9) BINARY VALUE 1391.
       10  MQIACF-SELECTORS   PIC S9(9) BINARY VALUE 1392.
       10  MQIACF-INTATTR-COUNT   PIC S9(9) BINARY VALUE 1393.
       10  MQIACF-INT-ATTRS   PIC S9(9) BINARY VALUE 1394.
       10  MQIACF-SUBRQ-ACTION   PIC S9(9) BINARY VALUE 1395.
       10  MQIACF-NUM-PUBS   PIC S9(9) BINARY VALUE 1396.
       10  MQIACF-POINTER-SIZE   PIC S9(9) BINARY VALUE 1397.
       10  MQIACF-REMOVE-AUTHREC   PIC S9(9) BINARY VALUE 1398.
       10  MQIACF-XR-ATTRS   PIC S9(9) BINARY VALUE 1399.
       10  MQIACF-APPL-FUNCTION-TYPE   PIC S9(9) BINARY VALUE 1400.
       10  MQIACF-AMQP-ATTRS   PIC S9(9) BINARY VALUE 1401.
       10  MQIACF-EXPORT-TYPE   PIC S9(9) BINARY VALUE 1402.
       10  MQIACF-EXPORT-ATTRS   PIC S9(9) BINARY VALUE 1403.
       10  MQIACF-SYSTEM-OBJECTS   PIC S9(9) BINARY VALUE 1404.
       10  MQIACF-CONNECTION-SWAP   PIC S9(9) BINARY VALUE 1405.
       10  MQIACF-AMQP-DIAGNOSTICS-TYPE   PIC S9(9) BINARY VALUE 1406.
       10  MQIACF-BUFFER-POOL-LOCATION   PIC S9(9) BINARY VALUE 1408.
       10  MQIACF-LDAP-CONNECTION-STATUS   PIC S9(9) BINARY VALUE 1409.
       10  MQIACF-SYSP-MAX-ACE-POOL   PIC S9(9) BINARY VALUE 1410.
       10  MQIACF-PAGECLAS   PIC S9(9) BINARY VALUE 1411.
       10  MQIACF-AUTH-REC-TYPE   PIC S9(9) BINARY VALUE 1412.
       10  MQIACF-SYSP-MAX-CONC-OFFLOADS   PIC S9(9) BINARY VALUE 1413.
       10  MQIACF-SYSP-ZHYPERWRITE   PIC S9(9) BINARY VALUE 1414.
       10  MQIACF-Q-MGR-STATUS-LOG   PIC S9(9) BINARY VALUE 1415.
       10  MQIACF-ARCHIVE-LOG-SIZE   PIC S9(9) BINARY VALUE 1416.
       10  MQIACF-MEDIA-LOG-SIZE   PIC S9(9) BINARY VALUE 1417.
       10  MQIACF-RESTART-LOG-SIZE   PIC S9(9) BINARY VALUE 1418.
       10  MQIACF-REUSABLE-LOG-SIZE   PIC S9(9) BINARY VALUE 1419.
       10  MQIACF-LOG-IN-USE   PIC S9(9) BINARY VALUE 1420.
       10  MQIACF-LOG-UTILIZATION   PIC S9(9) BINARY VALUE 1421.
       10  MQIACF-LOG-REDUCTION   PIC S9(9) BINARY VALUE 1422.
       10  MQIACF-IGNORE-STATE   PIC S9(9) BINARY VALUE 1423.
       10  MQIACF-MOVABLE-APPL-COUNT   PIC S9(9) BINARY VALUE 1424.
       10  MQIACF-APPL-INFO-ATTRS   PIC S9(9) BINARY VALUE 1425.
       10  MQIACF-APPL-MOVABLE   PIC S9(9) BINARY VALUE 1426.
       10  MQIACF-REMOTE-QMGR-ACTIVE   PIC S9(9) BINARY VALUE 1427.
       10  MQIACF-APPL-INFO-TYPE   PIC S9(9) BINARY VALUE 1428.
       10  MQIACF-APPL-INFO-APPL   PIC S9(9) BINARY VALUE 1429.
       10  MQIACF-APPL-INFO-QMGR   PIC S9(9) BINARY VALUE 1430.
       10  MQIACF-APPL-INFO-LOCAL   PIC S9(9) BINARY VALUE 1431.
       10  MQIACF-APPL-IMMOVABLE-COUNT   PIC S9(9) BINARY VALUE 1432.
       10  MQIACF-BALANCED   PIC S9(9) BINARY VALUE 1433.
       10  MQIACF-BALSTATE   PIC S9(9) BINARY VALUE 1434.
       10  MQIACF-APPL-IMMOVABLE-REASON   PIC S9(9) BINARY VALUE 1435.
       10  MQIACF-DS-ENCRYPTED   PIC S9(9) BINARY VALUE 1436.
       10  MQIACF-CUR-Q-FILE-SIZE   PIC S9(9) BINARY VALUE 1437.
       10  MQIACF-CUR-MAX-FILE-SIZE   PIC S9(9) BINARY VALUE 1438.
       10  MQIACF-BALANCING-TYPE   PIC S9(9) BINARY VALUE 1439.
       10  MQIACF-BALANCING-OPTIONS   PIC S9(9) BINARY VALUE 1440.
       10  MQIACF-BALANCING-TIMEOUT   PIC S9(9) BINARY VALUE 1441.
       10  MQIACF-SYSP-SMF-STAT-TIME-SECS   PIC S9(9) BINARY VALUE 1442.
       10  MQIACF-SYSP-SMF-ACCT-TIME-MINS   PIC S9(9) BINARY VALUE 1443.
       10  MQIACF-SYSP-SMF-ACCT-TIME-SECS   PIC S9(9) BINARY VALUE 1444.
       10  MQIACF-LAST-USED   PIC S9(9) BINARY VALUE 1444.

      ** Access Options
       10  MQCFACCESS-ENABLED   PIC S9(9) BINARY VALUE 0.
       10  MQCFACCESS-SUSPENDED   PIC S9(9) BINARY VALUE 1.
       10  MQCFACCESS-DISABLED   PIC S9(9) BINARY VALUE 2.

      ** Open Mode Options
       10  MQS-OPENMODE-NONE   PIC S9(9) BINARY VALUE 0.
       10  MQS-OPENMODE-READONLY   PIC S9(9) BINARY VALUE 1.
       10  MQS-OPENMODE-UPDATE   PIC S9(9) BINARY VALUE 2.
       10  MQS-OPENMODE-RECOVERY   PIC S9(9) BINARY VALUE 3.

      ** SMDS Status Options
       10  MQS-STATUS-CLOSED   PIC S9(9) BINARY VALUE 0.
       10  MQS-STATUS-CLOSING   PIC S9(9) BINARY VALUE 1.
       10  MQS-STATUS-OPENING   PIC S9(9) BINARY VALUE 2.
       10  MQS-STATUS-OPEN   PIC S9(9) BINARY VALUE 3.
       10  MQS-STATUS-NOTENABLED   PIC S9(9) BINARY VALUE 4.
       10  MQS-STATUS-ALLOCFAIL   PIC S9(9) BINARY VALUE 5.
       10  MQS-STATUS-OPENFAIL   PIC S9(9) BINARY VALUE 6.
       10  MQS-STATUS-STGFAIL   PIC S9(9) BINARY VALUE 7.
       10  MQS-STATUS-DATAFAIL   PIC S9(9) BINARY VALUE 8.

      ** SMDS Availability Options
       10  MQS-AVAIL-NORMAL   PIC S9(9) BINARY VALUE 0.
       10  MQS-AVAIL-ERROR   PIC S9(9) BINARY VALUE 1.
       10  MQS-AVAIL-STOPPED   PIC S9(9) BINARY VALUE 2.

      ** Values for MQIACF_BUFFER_POOL_LOCATION.
       10  MQBPLOCATION-BELOW   PIC S9(9) BINARY VALUE 0.
       10  MQBPLOCATION-ABOVE   PIC S9(9) BINARY VALUE 1.
       10  MQBPLOCATION-SWITCHING-ABOVE   PIC S9(9) BINARY VALUE 2.
       10  MQBPLOCATION-SWITCHING-BELOW   PIC S9(9) BINARY VALUE 3.

      ** Values for MQIACF_PAGECLAS.
       10  MQPAGECLAS-4KB   PIC S9(9) BINARY VALUE 0.
       10  MQPAGECLAS-FIXED4KB   PIC S9(9) BINARY VALUE 1.

      ** Expandst Options
       10  MQS-EXPANDST-NORMAL   PIC S9(9) BINARY VALUE 0.
       10  MQS-EXPANDST-FAILED   PIC S9(9) BINARY VALUE 1.
       10  MQS-EXPANDST-MAXIMUM   PIC S9(9) BINARY VALUE 2.

      ** Usage SMDS Options
       10  MQUSAGE-SMDS-AVAILABLE   PIC S9(9) BINARY VALUE 0.
       10  MQUSAGE-SMDS-NO-DATA   PIC S9(9) BINARY VALUE 1.

      ** Integer Channel Types
       10  MQIACH-FIRST   PIC S9(9) BINARY VALUE 1501.
       10  MQIACH-XMIT-PROTOCOL-TYPE   PIC S9(9) BINARY VALUE 1501.
       10  MQIACH-BATCH-SIZE   PIC S9(9) BINARY VALUE 1502.
       10  MQIACH-DISC-INTERVAL   PIC S9(9) BINARY VALUE 1503.
       10  MQIACH-SHORT-TIMER   PIC S9(9) BINARY VALUE 1504.
       10  MQIACH-SHORT-RETRY   PIC S9(9) BINARY VALUE 1505.
       10  MQIACH-LONG-TIMER   PIC S9(9) BINARY VALUE 1506.
       10  MQIACH-LONG-RETRY   PIC S9(9) BINARY VALUE 1507.
       10  MQIACH-PUT-AUTHORITY   PIC S9(9) BINARY VALUE 1508.
       10  MQIACH-SEQUENCE-NUMBER-WRAP   PIC S9(9) BINARY VALUE 1509.
       10  MQIACH-MAX-MSG-LENGTH   PIC S9(9) BINARY VALUE 1510.
       10  MQIACH-CHANNEL-TYPE   PIC S9(9) BINARY VALUE 1511.
       10  MQIACH-DATA-COUNT   PIC S9(9) BINARY VALUE 1512.
       10  MQIACH-NAME-COUNT   PIC S9(9) BINARY VALUE 1513.
       10  MQIACH-MSG-SEQUENCE-NUMBER   PIC S9(9) BINARY VALUE 1514.
       10  MQIACH-DATA-CONVERSION   PIC S9(9) BINARY VALUE 1515.
       10  MQIACH-IN-DOUBT   PIC S9(9) BINARY VALUE 1516.
       10  MQIACH-MCA-TYPE   PIC S9(9) BINARY VALUE 1517.
       10  MQIACH-SESSION-COUNT   PIC S9(9) BINARY VALUE 1518.
       10  MQIACH-ADAPTER   PIC S9(9) BINARY VALUE 1519.
       10  MQIACH-COMMAND-COUNT   PIC S9(9) BINARY VALUE 1520.
       10  MQIACH-SOCKET   PIC S9(9) BINARY VALUE 1521.
       10  MQIACH-PORT   PIC S9(9) BINARY VALUE 1522.
       10  MQIACH-CHANNEL-INSTANCE-TYPE   PIC S9(9) BINARY VALUE 1523.
       10  MQIACH-CHANNEL-INSTANCE-ATTRS   PIC S9(9) BINARY VALUE 1524.
       10  MQIACH-CHANNEL-ERROR-DATA   PIC S9(9) BINARY VALUE 1525.
       10  MQIACH-CHANNEL-TABLE   PIC S9(9) BINARY VALUE 1526.
       10  MQIACH-CHANNEL-STATUS   PIC S9(9) BINARY VALUE 1527.
       10  MQIACH-INDOUBT-STATUS   PIC S9(9) BINARY VALUE 1528.
       10  MQIACH-LAST-SEQ-NUMBER   PIC S9(9) BINARY VALUE 1529.
       10  MQIACH-LAST-SEQUENCE-NUMBER   PIC S9(9) BINARY VALUE 1529.
       10  MQIACH-CURRENT-MSGS   PIC S9(9) BINARY VALUE 1531.
       10  MQIACH-CURRENT-SEQ-NUMBER   PIC S9(9) BINARY VALUE 1532.
       10  MQIACH-CURRENT-SEQUENCE-NUMBER   PIC S9(9) BINARY VALUE 1532.
       10  MQIACH-SSL-RETURN-CODE   PIC S9(9) BINARY VALUE 1533.
       10  MQIACH-MSGS   PIC S9(9) BINARY VALUE 1534.
       10  MQIACH-BYTES-SENT   PIC S9(9) BINARY VALUE 1535.
       10  MQIACH-BYTES-RCVD   PIC S9(9) BINARY VALUE 1536.
       10  MQIACH-BYTES-RECEIVED   PIC S9(9) BINARY VALUE 1536.
       10  MQIACH-BATCHES   PIC S9(9) BINARY VALUE 1537.
       10  MQIACH-BUFFERS-SENT   PIC S9(9) BINARY VALUE 1538.
       10  MQIACH-BUFFERS-RCVD   PIC S9(9) BINARY VALUE 1539.
       10  MQIACH-BUFFERS-RECEIVED   PIC S9(9) BINARY VALUE 1539.
       10  MQIACH-LONG-RETRIES-LEFT   PIC S9(9) BINARY VALUE 1540.
       10  MQIACH-SHORT-RETRIES-LEFT   PIC S9(9) BINARY VALUE 1541.
       10  MQIACH-MCA-STATUS   PIC S9(9) BINARY VALUE 1542.
       10  MQIACH-STOP-REQUESTED   PIC S9(9) BINARY VALUE 1543.
       10  MQIACH-MR-COUNT   PIC S9(9) BINARY VALUE 1544.
       10  MQIACH-MR-INTERVAL   PIC S9(9) BINARY VALUE 1545.
       10  MQIACH-NPM-SPEED   PIC S9(9) BINARY VALUE 1562.
       10  MQIACH-HB-INTERVAL   PIC S9(9) BINARY VALUE 1563.
       10  MQIACH-BATCH-INTERVAL   PIC S9(9) BINARY VALUE 1564.
       10  MQIACH-NETWORK-PRIORITY   PIC S9(9) BINARY VALUE 1565.
       10  MQIACH-KEEP-ALIVE-INTERVAL   PIC S9(9) BINARY VALUE 1566.
       10  MQIACH-BATCH-HB   PIC S9(9) BINARY VALUE 1567.
       10  MQIACH-SSL-CLIENT-AUTH   PIC S9(9) BINARY VALUE 1568.
       10  MQIACH-ALLOC-RETRY   PIC S9(9) BINARY VALUE 1570.
       10  MQIACH-ALLOC-FAST-TIMER   PIC S9(9) BINARY VALUE 1571.
       10  MQIACH-ALLOC-SLOW-TIMER   PIC S9(9) BINARY VALUE 1572.
       10  MQIACH-DISC-RETRY   PIC S9(9) BINARY VALUE 1573.
       10  MQIACH-PORT-NUMBER   PIC S9(9) BINARY VALUE 1574.
       10  MQIACH-HDR-COMPRESSION   PIC S9(9) BINARY VALUE 1575.
       10  MQIACH-MSG-COMPRESSION   PIC S9(9) BINARY VALUE 1576.
       10  MQIACH-CLWL-CHANNEL-RANK   PIC S9(9) BINARY VALUE 1577.
       10  MQIACH-CLWL-CHANNEL-PRIORITY   PIC S9(9) BINARY VALUE 1578.
       10  MQIACH-CLWL-CHANNEL-WEIGHT   PIC S9(9) BINARY VALUE 1579.
       10  MQIACH-CHANNEL-DISP   PIC S9(9) BINARY VALUE 1580.
       10  MQIACH-INBOUND-DISP   PIC S9(9) BINARY VALUE 1581.
       10  MQIACH-CHANNEL-TYPES   PIC S9(9) BINARY VALUE 1582.
       10  MQIACH-ADAPS-STARTED   PIC S9(9) BINARY VALUE 1583.
       10  MQIACH-ADAPS-MAX   PIC S9(9) BINARY VALUE 1584.
       10  MQIACH-DISPS-STARTED   PIC S9(9) BINARY VALUE 1585.
       10  MQIACH-DISPS-MAX   PIC S9(9) BINARY VALUE 1586.
       10  MQIACH-SSLTASKS-STARTED   PIC S9(9) BINARY VALUE 1587.
       10  MQIACH-SSLTASKS-MAX   PIC S9(9) BINARY VALUE 1588.
       10  MQIACH-CURRENT-CHL   PIC S9(9) BINARY VALUE 1589.
       10  MQIACH-CURRENT-CHL-MAX   PIC S9(9) BINARY VALUE 1590.
       10  MQIACH-CURRENT-CHL-TCP   PIC S9(9) BINARY VALUE 1591.
       10  MQIACH-CURRENT-CHL-LU62   PIC S9(9) BINARY VALUE 1592.
       10  MQIACH-ACTIVE-CHL   PIC S9(9) BINARY VALUE 1593.
       10  MQIACH-ACTIVE-CHL-MAX   PIC S9(9) BINARY VALUE 1594.
       10  MQIACH-ACTIVE-CHL-PAUSED   PIC S9(9) BINARY VALUE 1595.
       10  MQIACH-ACTIVE-CHL-STARTED   PIC S9(9) BINARY VALUE 1596.
       10  MQIACH-ACTIVE-CHL-STOPPED   PIC S9(9) BINARY VALUE 1597.
       10  MQIACH-ACTIVE-CHL-RETRY   PIC S9(9) BINARY VALUE 1598.
       10  MQIACH-LISTENER-STATUS   PIC S9(9) BINARY VALUE 1599.
       10  MQIACH-SHARED-CHL-RESTART   PIC S9(9) BINARY VALUE 1600.
       10  MQIACH-LISTENER-CONTROL   PIC S9(9) BINARY VALUE 1601.
       10  MQIACH-BACKLOG   PIC S9(9) BINARY VALUE 1602.
       10  MQIACH-XMITQ-TIME-INDICATOR   PIC S9(9) BINARY VALUE 1604.
       10  MQIACH-NETWORK-TIME-INDICATOR   PIC S9(9) BINARY VALUE 1605.
       10  MQIACH-EXIT-TIME-INDICATOR   PIC S9(9) BINARY VALUE 1606.
       10  MQIACH-BATCH-SIZE-INDICATOR   PIC S9(9) BINARY VALUE 1607.
       10  MQIACH-XMITQ-MSGS-AVAILABLE   PIC S9(9) BINARY VALUE 1608.
       10  MQIACH-CHANNEL-SUBSTATE   PIC S9(9) BINARY VALUE 1609.
       10  MQIACH-SSL-KEY-RESETS   PIC S9(9) BINARY VALUE 1610.
       10  MQIACH-COMPRESSION-RATE   PIC S9(9) BINARY VALUE 1611.
       10  MQIACH-COMPRESSION-TIME   PIC S9(9) BINARY VALUE 1612.
       10  MQIACH-MAX-XMIT-SIZE   PIC S9(9) BINARY VALUE 1613.
       10  MQIACH-DEF-CHANNEL-DISP   PIC S9(9) BINARY VALUE 1614.
       10  MQIACH-SHARING-CONVERSATIONS   PIC S9(9) BINARY VALUE 1615.
       10  MQIACH-MAX-SHARING-CONVS   PIC S9(9) BINARY VALUE 1616.
       10  MQIACH-CURRENT-SHARING-CONVS   PIC S9(9) BINARY VALUE 1617.
       10  MQIACH-MAX-INSTANCES   PIC S9(9) BINARY VALUE 1618.
       10  MQIACH-MAX-INSTS-PER-CLIENT   PIC S9(9) BINARY VALUE 1619.
       10  MQIACH-CLIENT-CHANNEL-WEIGHT   PIC S9(9) BINARY VALUE 1620.
       10  MQIACH-CONNECTION-AFFINITY   PIC S9(9) BINARY VALUE 1621.
       10  MQIACH-AUTH-INFO-TYPES   PIC S9(9) BINARY VALUE 1622.
       10  MQIACH-RESET-REQUESTED   PIC S9(9) BINARY VALUE 1623.
       10  MQIACH-BATCH-DATA-LIMIT   PIC S9(9) BINARY VALUE 1624.
       10  MQIACH-MSG-HISTORY   PIC S9(9) BINARY VALUE 1625.
       10  MQIACH-MULTICAST-PROPERTIES   PIC S9(9) BINARY VALUE 1626.
       10  MQIACH-NEW-SUBSCRIBER-HISTORY   PIC S9(9) BINARY VALUE 1627.
       10  MQIACH-MC-HB-INTERVAL   PIC S9(9) BINARY VALUE 1628.
       10  MQIACH-USE-CLIENT-ID   PIC S9(9) BINARY VALUE 1629.
       10  MQIACH-MQTT-KEEP-ALIVE   PIC S9(9) BINARY VALUE 1630.
       10  MQIACH-IN-DOUBT-IN   PIC S9(9) BINARY VALUE 1631.
       10  MQIACH-IN-DOUBT-OUT   PIC S9(9) BINARY VALUE 1632.
       10  MQIACH-MSGS-SENT   PIC S9(9) BINARY VALUE 1633.
       10  MQIACH-MSGS-RECEIVED   PIC S9(9) BINARY VALUE 1634.
       10  MQIACH-MSGS-RCVD   PIC S9(9) BINARY VALUE 1634.
       10  MQIACH-PENDING-OUT   PIC S9(9) BINARY VALUE 1635.
       10  MQIACH-AVAILABLE-CIPHERSPECS   PIC S9(9) BINARY VALUE 1636.
       10  MQIACH-MATCH   PIC S9(9) BINARY VALUE 1637.
       10  MQIACH-USER-SOURCE   PIC S9(9) BINARY VALUE 1638.
       10  MQIACH-WARNING   PIC S9(9) BINARY VALUE 1639.
       10  MQIACH-DEF-RECONNECT   PIC S9(9) BINARY VALUE 1640.
       10  MQIACH-CHANNEL-SUMMARY-ATTRS   PIC S9(9) BINARY VALUE 1642.
       10  MQIACH-PROTOCOL   PIC S9(9) BINARY VALUE 1643.
       10  MQIACH-AMQP-KEEP-ALIVE   PIC S9(9) BINARY VALUE 1644.
       10  MQIACH-SECURITY-PROTOCOL   PIC S9(9) BINARY VALUE 1645.
       10  MQIACH-SPL-PROTECTION   PIC S9(9) BINARY VALUE 1646.
       10  MQIACH-LAST-USED   PIC S9(9) BINARY VALUE 1646.

      ******************************************************************
      **  Values Related to Character Parameter Structures         
      ******************************************************************
      ** Character Monitoring Parameter Types
       10  MQCAMO-FIRST   PIC S9(9) BINARY VALUE 2701.
       10  MQCAMO-CLOSE-DATE   PIC S9(9) BINARY VALUE 2701.
       10  MQCAMO-CLOSE-TIME   PIC S9(9) BINARY VALUE 2702.
       10  MQCAMO-CONN-DATE   PIC S9(9) BINARY VALUE 2703.
       10  MQCAMO-CONN-TIME   PIC S9(9) BINARY VALUE 2704.
       10  MQCAMO-DISC-DATE   PIC S9(9) BINARY VALUE 2705.
       10  MQCAMO-DISC-TIME   PIC S9(9) BINARY VALUE 2706.
       10  MQCAMO-END-DATE   PIC S9(9) BINARY VALUE 2707.
       10  MQCAMO-END-TIME   PIC S9(9) BINARY VALUE 2708.
       10  MQCAMO-OPEN-DATE   PIC S9(9) BINARY VALUE 2709.
       10  MQCAMO-OPEN-TIME   PIC S9(9) BINARY VALUE 2710.
       10  MQCAMO-START-DATE   PIC S9(9) BINARY VALUE 2711.
       10  MQCAMO-START-TIME   PIC S9(9) BINARY VALUE 2712.
       10  MQCAMO-MONITOR-CLASS   PIC S9(9) BINARY VALUE 2713.
       10  MQCAMO-MONITOR-TYPE   PIC S9(9) BINARY VALUE 2714.
       10  MQCAMO-MONITOR-DESC   PIC S9(9) BINARY VALUE 2715.
       10  MQCAMO-LAST-USED   PIC S9(9) BINARY VALUE 2715.

      ** Character Parameter Types
       10  MQCACF-FIRST   PIC S9(9) BINARY VALUE 3001.
       10  MQCACF-FROM-Q-NAME   PIC S9(9) BINARY VALUE 3001.
       10  MQCACF-TO-Q-NAME   PIC S9(9) BINARY VALUE 3002.
       10  MQCACF-FROM-PROCESS-NAME   PIC S9(9) BINARY VALUE 3003.
       10  MQCACF-TO-PROCESS-NAME   PIC S9(9) BINARY VALUE 3004.
       10  MQCACF-FROM-NAMELIST-NAME   PIC S9(9) BINARY VALUE 3005.
       10  MQCACF-TO-NAMELIST-NAME   PIC S9(9) BINARY VALUE 3006.
       10  MQCACF-FROM-CHANNEL-NAME   PIC S9(9) BINARY VALUE 3007.
       10  MQCACF-TO-CHANNEL-NAME   PIC S9(9) BINARY VALUE 3008.
       10  MQCACF-FROM-AUTH-INFO-NAME   PIC S9(9) BINARY VALUE 3009.
       10  MQCACF-TO-AUTH-INFO-NAME   PIC S9(9) BINARY VALUE 3010.
       10  MQCACF-Q-NAMES   PIC S9(9) BINARY VALUE 3011.
       10  MQCACF-PROCESS-NAMES   PIC S9(9) BINARY VALUE 3012.
       10  MQCACF-NAMELIST-NAMES   PIC S9(9) BINARY VALUE 3013.
       10  MQCACF-ESCAPE-TEXT   PIC S9(9) BINARY VALUE 3014.
       10  MQCACF-LOCAL-Q-NAMES   PIC S9(9) BINARY VALUE 3015.
       10  MQCACF-MODEL-Q-NAMES   PIC S9(9) BINARY VALUE 3016.
       10  MQCACF-ALIAS-Q-NAMES   PIC S9(9) BINARY VALUE 3017.
       10  MQCACF-REMOTE-Q-NAMES   PIC S9(9) BINARY VALUE 3018.
       10  MQCACF-SENDER-CHANNEL-NAMES   PIC S9(9) BINARY VALUE 3019.
       10  MQCACF-SERVER-CHANNEL-NAMES   PIC S9(9) BINARY VALUE 3020.
       10  MQCACF-REQUESTER-CHANNEL-NAMES   PIC S9(9) BINARY VALUE 3021.
       10  MQCACF-RECEIVER-CHANNEL-NAMES   PIC S9(9) BINARY VALUE 3022.
       10  MQCACF-OBJECT-Q-MGR-NAME   PIC S9(9) BINARY VALUE 3023.
       10  MQCACF-APPL-NAME   PIC S9(9) BINARY VALUE 3024.
       10  MQCACF-USER-IDENTIFIER   PIC S9(9) BINARY VALUE 3025.
       10  MQCACF-AUX-ERROR-DATA-STR-1   PIC S9(9) BINARY VALUE 3026.
       10  MQCACF-AUX-ERROR-DATA-STR-2   PIC S9(9) BINARY VALUE 3027.
       10  MQCACF-AUX-ERROR-DATA-STR-3   PIC S9(9) BINARY VALUE 3028.
       10  MQCACF-BRIDGE-NAME   PIC S9(9) BINARY VALUE 3029.
       10  MQCACF-STREAM-NAME   PIC S9(9) BINARY VALUE 3030.
       10  MQCACF-TOPIC   PIC S9(9) BINARY VALUE 3031.
       10  MQCACF-PARENT-Q-MGR-NAME   PIC S9(9) BINARY VALUE 3032.
       10  MQCACF-CORREL-ID   PIC S9(9) BINARY VALUE 3033.
       10  MQCACF-PUBLISH-TIMESTAMP   PIC S9(9) BINARY VALUE 3034.
       10  MQCACF-STRING-DATA   PIC S9(9) BINARY VALUE 3035.
       10  MQCACF-SUPPORTED-STREAM-NAME   PIC S9(9) BINARY VALUE 3036.
       10  MQCACF-REG-TOPIC   PIC S9(9) BINARY VALUE 3037.
       10  MQCACF-REG-TIME   PIC S9(9) BINARY VALUE 3038.
       10  MQCACF-REG-USER-ID   PIC S9(9) BINARY VALUE 3039.
       10  MQCACF-CHILD-Q-MGR-NAME   PIC S9(9) BINARY VALUE 3040.
       10  MQCACF-REG-STREAM-NAME   PIC S9(9) BINARY VALUE 3041.
       10  MQCACF-REG-Q-MGR-NAME   PIC S9(9) BINARY VALUE 3042.
       10  MQCACF-REG-Q-NAME   PIC S9(9) BINARY VALUE 3043.
       10  MQCACF-REG-CORREL-ID   PIC S9(9) BINARY VALUE 3044.
       10  MQCACF-EVENT-USER-ID   PIC S9(9) BINARY VALUE 3045.
       10  MQCACF-OBJECT-NAME   PIC S9(9) BINARY VALUE 3046.
       10  MQCACF-EVENT-Q-MGR   PIC S9(9) BINARY VALUE 3047.
       10  MQCACF-AUTH-INFO-NAMES   PIC S9(9) BINARY VALUE 3048.
       10  MQCACF-EVENT-APPL-IDENTITY   PIC S9(9) BINARY VALUE 3049.
       10  MQCACF-EVENT-APPL-NAME   PIC S9(9) BINARY VALUE 3050.
       10  MQCACF-EVENT-APPL-ORIGIN   PIC S9(9) BINARY VALUE 3051.
       10  MQCACF-SUBSCRIPTION-NAME   PIC S9(9) BINARY VALUE 3052.
       10  MQCACF-REG-SUB-NAME   PIC S9(9) BINARY VALUE 3053.
       10  MQCACF-SUBSCRIPTION-IDENTITY   PIC S9(9) BINARY VALUE 3054.
       10  MQCACF-REG-SUB-IDENTITY   PIC S9(9) BINARY VALUE 3055.
       10  MQCACF-SUBSCRIPTION-USER-DATA   PIC S9(9) BINARY VALUE 3056.
       10  MQCACF-REG-SUB-USER-DATA   PIC S9(9) BINARY VALUE 3057.
       10  MQCACF-APPL-TAG   PIC S9(9) BINARY VALUE 3058.
       10  MQCACF-DATA-SET-NAME   PIC S9(9) BINARY VALUE 3059.
       10  MQCACF-UOW-START-DATE   PIC S9(9) BINARY VALUE 3060.
       10  MQCACF-UOW-START-TIME   PIC S9(9) BINARY VALUE 3061.
       10  MQCACF-UOW-LOG-START-DATE   PIC S9(9) BINARY VALUE 3062.
       10  MQCACF-UOW-LOG-START-TIME   PIC S9(9) BINARY VALUE 3063.
       10  MQCACF-UOW-LOG-EXTENT-NAME   PIC S9(9) BINARY VALUE 3064.
       10  MQCACF-PRINCIPAL-ENTITY-NAMES   PIC S9(9) BINARY VALUE 3065.
       10  MQCACF-GROUP-ENTITY-NAMES   PIC S9(9) BINARY VALUE 3066.
       10  MQCACF-AUTH-PROFILE-NAME   PIC S9(9) BINARY VALUE 3067.
       10  MQCACF-ENTITY-NAME   PIC S9(9) BINARY VALUE 3068.
       10  MQCACF-SERVICE-COMPONENT   PIC S9(9) BINARY VALUE 3069.
       10  MQCACF-RESPONSE-Q-MGR-NAME   PIC S9(9) BINARY VALUE 3070.
       10  MQCACF-CURRENT-LOG-EXTENT-NAME   PIC S9(9) BINARY VALUE 3071.
       10  MQCACF-RESTART-LOG-EXTENT-NAME   PIC S9(9) BINARY VALUE 3072.
       10  MQCACF-MEDIA-LOG-EXTENT-NAME   PIC S9(9) BINARY VALUE 3073.
       10  MQCACF-LOG-PATH   PIC S9(9) BINARY VALUE 3074.
       10  MQCACF-COMMAND-MQSC   PIC S9(9) BINARY VALUE 3075.
       10  MQCACF-Q-MGR-CPF   PIC S9(9) BINARY VALUE 3076.
       10  MQCACF-USAGE-LOG-RBA   PIC S9(9) BINARY VALUE 3078.
       10  MQCACF-USAGE-LOG-LRSN   PIC S9(9) BINARY VALUE 3079.
       10  MQCACF-COMMAND-SCOPE   PIC S9(9) BINARY VALUE 3080.
       10  MQCACF-ASID   PIC S9(9) BINARY VALUE 3081.
       10  MQCACF-PSB-NAME   PIC S9(9) BINARY VALUE 3082.
       10  MQCACF-PST-ID   PIC S9(9) BINARY VALUE 3083.
       10  MQCACF-TASK-NUMBER   PIC S9(9) BINARY VALUE 3084.
       10  MQCACF-TRANSACTION-ID   PIC S9(9) BINARY VALUE 3085.
       10  MQCACF-Q-MGR-UOW-ID   PIC S9(9) BINARY VALUE 3086.
       10  MQCACF-ORIGIN-NAME   PIC S9(9) BINARY VALUE 3088.
       10  MQCACF-ENV-INFO   PIC S9(9) BINARY VALUE 3089.
       10  MQCACF-SECURITY-PROFILE   PIC S9(9) BINARY VALUE 3090.
       10  MQCACF-CONFIGURATION-DATE   PIC S9(9) BINARY VALUE 3091.
       10  MQCACF-CONFIGURATION-TIME   PIC S9(9) BINARY VALUE 3092.
       10  MQCACF-FROM-CF-STRUC-NAME   PIC S9(9) BINARY VALUE 3093.
       10  MQCACF-TO-CF-STRUC-NAME   PIC S9(9) BINARY VALUE 3094.
       10  MQCACF-CF-STRUC-NAMES   PIC S9(9) BINARY VALUE 3095.
       10  MQCACF-FAIL-DATE   PIC S9(9) BINARY VALUE 3096.
       10  MQCACF-FAIL-TIME   PIC S9(9) BINARY VALUE 3097.
       10  MQCACF-BACKUP-DATE   PIC S9(9) BINARY VALUE 3098.
       10  MQCACF-BACKUP-TIME   PIC S9(9) BINARY VALUE 3099.
       10  MQCACF-SYSTEM-NAME   PIC S9(9) BINARY VALUE 3100.
       10  MQCACF-CF-STRUC-BACKUP-START   PIC S9(9) BINARY VALUE 3101.
       10  MQCACF-CF-STRUC-BACKUP-END   PIC S9(9) BINARY VALUE 3102.
       10  MQCACF-CF-STRUC-LOG-Q-MGRS   PIC S9(9) BINARY VALUE 3103.
       10  MQCACF-FROM-STORAGE-CLASS   PIC S9(9) BINARY VALUE 3104.
       10  MQCACF-TO-STORAGE-CLASS   PIC S9(9) BINARY VALUE 3105.
       10  MQCACF-STORAGE-CLASS-NAMES   PIC S9(9) BINARY VALUE 3106.
       10  MQCACF-DSG-NAME   PIC S9(9) BINARY VALUE 3108.
       10  MQCACF-DB2-NAME   PIC S9(9) BINARY VALUE 3109.
       10  MQCACF-SYSP-CMD-USER-ID   PIC S9(9) BINARY VALUE 3110.
       10  MQCACF-SYSP-OTMA-GROUP   PIC S9(9) BINARY VALUE 3111.
       10  MQCACF-SYSP-OTMA-MEMBER   PIC S9(9) BINARY VALUE 3112.
       10  MQCACF-SYSP-OTMA-DRU-EXIT   PIC S9(9) BINARY VALUE 3113.
       10  MQCACF-SYSP-OTMA-TPIPE-PFX   PIC S9(9) BINARY VALUE 3114.
       10  MQCACF-SYSP-ARCHIVE-PFX1   PIC S9(9) BINARY VALUE 3115.
       10  MQCACF-SYSP-ARCHIVE-UNIT1   PIC S9(9) BINARY VALUE 3116.
       10  MQCACF-SYSP-LOG-CORREL-ID   PIC S9(9) BINARY VALUE 3117.
       10  MQCACF-SYSP-UNIT-VOLSER   PIC S9(9) BINARY VALUE 3118.
       10  MQCACF-SYSP-Q-MGR-TIME   PIC S9(9) BINARY VALUE 3119.
       10  MQCACF-SYSP-Q-MGR-DATE   PIC S9(9) BINARY VALUE 3120.
       10  MQCACF-SYSP-Q-MGR-RBA   PIC S9(9) BINARY VALUE 3121.
       10  MQCACF-SYSP-LOG-RBA   PIC S9(9) BINARY VALUE 3122.
       10  MQCACF-SYSP-SERVICE   PIC S9(9) BINARY VALUE 3123.
       10  MQCACF-FROM-LISTENER-NAME   PIC S9(9) BINARY VALUE 3124.
       10  MQCACF-TO-LISTENER-NAME   PIC S9(9) BINARY VALUE 3125.
       10  MQCACF-FROM-SERVICE-NAME   PIC S9(9) BINARY VALUE 3126.
       10  MQCACF-TO-SERVICE-NAME   PIC S9(9) BINARY VALUE 3127.
       10  MQCACF-LAST-PUT-DATE   PIC S9(9) BINARY VALUE 3128.
       10  MQCACF-LAST-PUT-TIME   PIC S9(9) BINARY VALUE 3129.
       10  MQCACF-LAST-GET-DATE   PIC S9(9) BINARY VALUE 3130.
       10  MQCACF-LAST-GET-TIME   PIC S9(9) BINARY VALUE 3131.
       10  MQCACF-OPERATION-DATE   PIC S9(9) BINARY VALUE 3132.
       10  MQCACF-OPERATION-TIME   PIC S9(9) BINARY VALUE 3133.
       10  MQCACF-ACTIVITY-DESC   PIC S9(9) BINARY VALUE 3134.
       10  MQCACF-APPL-IDENTITY-DATA   PIC S9(9) BINARY VALUE 3135.
       10  MQCACF-APPL-ORIGIN-DATA   PIC S9(9) BINARY VALUE 3136.
       10  MQCACF-PUT-DATE   PIC S9(9) BINARY VALUE 3137.
       10  MQCACF-PUT-TIME   PIC S9(9) BINARY VALUE 3138.
       10  MQCACF-REPLY-TO-Q   PIC S9(9) BINARY VALUE 3139.
       10  MQCACF-REPLY-TO-Q-MGR   PIC S9(9) BINARY VALUE 3140.
       10  MQCACF-RESOLVED-Q-NAME   PIC S9(9) BINARY VALUE 3141.
       10  MQCACF-STRUC-ID   PIC S9(9) BINARY VALUE 3142.
       10  MQCACF-VALUE-NAME   PIC S9(9) BINARY VALUE 3143.
       10  MQCACF-SERVICE-START-DATE   PIC S9(9) BINARY VALUE 3144.
       10  MQCACF-SERVICE-START-TIME   PIC S9(9) BINARY VALUE 3145.
       10  MQCACF-SYSP-OFFLINE-RBA   PIC S9(9) BINARY VALUE 3146.
       10  MQCACF-SYSP-ARCHIVE-PFX2   PIC S9(9) BINARY VALUE 3147.
       10  MQCACF-SYSP-ARCHIVE-UNIT2   PIC S9(9) BINARY VALUE 3148.
       10  MQCACF-TO-TOPIC-NAME   PIC S9(9) BINARY VALUE 3149.
       10  MQCACF-FROM-TOPIC-NAME   PIC S9(9) BINARY VALUE 3150.
       10  MQCACF-TOPIC-NAMES   PIC S9(9) BINARY VALUE 3151.
       10  MQCACF-SUB-NAME   PIC S9(9) BINARY VALUE 3152.
       10  MQCACF-DESTINATION-Q-MGR   PIC S9(9) BINARY VALUE 3153.
       10  MQCACF-DESTINATION   PIC S9(9) BINARY VALUE 3154.
       10  MQCACF-SUB-USER-ID   PIC S9(9) BINARY VALUE 3156.
       10  MQCACF-SUB-USER-DATA   PIC S9(9) BINARY VALUE 3159.
       10  MQCACF-SUB-SELECTOR   PIC S9(9) BINARY VALUE 3160.
       10  MQCACF-LAST-PUB-DATE   PIC S9(9) BINARY VALUE 3161.
       10  MQCACF-LAST-PUB-TIME   PIC S9(9) BINARY VALUE 3162.
       10  MQCACF-FROM-SUB-NAME   PIC S9(9) BINARY VALUE 3163.
       10  MQCACF-TO-SUB-NAME   PIC S9(9) BINARY VALUE 3164.
       10  MQCACF-LAST-MSG-TIME   PIC S9(9) BINARY VALUE 3167.
       10  MQCACF-LAST-MSG-DATE   PIC S9(9) BINARY VALUE 3168.
       10  MQCACF-SUBSCRIPTION-POINT   PIC S9(9) BINARY VALUE 3169.
       10  MQCACF-FILTER   PIC S9(9) BINARY VALUE 3170.
       10  MQCACF-NONE   PIC S9(9) BINARY VALUE 3171.
       10  MQCACF-ADMIN-TOPIC-NAMES   PIC S9(9) BINARY VALUE 3172.
       10  MQCACF-ROUTING-FINGER-PRINT   PIC S9(9) BINARY VALUE 3173.
       10  MQCACF-APPL-DESC   PIC S9(9) BINARY VALUE 3174.
       10  MQCACF-Q-MGR-START-DATE   PIC S9(9) BINARY VALUE 3175.
       10  MQCACF-Q-MGR-START-TIME   PIC S9(9) BINARY VALUE 3176.
       10  MQCACF-FROM-COMM-INFO-NAME   PIC S9(9) BINARY VALUE 3177.
       10  MQCACF-TO-COMM-INFO-NAME   PIC S9(9) BINARY VALUE 3178.
       10  MQCACF-CF-OFFLOAD-SIZE1   PIC S9(9) BINARY VALUE 3179.
       10  MQCACF-CF-OFFLOAD-SIZE2   PIC S9(9) BINARY VALUE 3180.
       10  MQCACF-CF-OFFLOAD-SIZE3   PIC S9(9) BINARY VALUE 3181.
       10  MQCACF-CF-SMDS-GENERIC-NAME   PIC S9(9) BINARY VALUE 3182.
       10  MQCACF-CF-SMDS   PIC S9(9) BINARY VALUE 3183.
       10  MQCACF-RECOVERY-DATE   PIC S9(9) BINARY VALUE 3184.
       10  MQCACF-RECOVERY-TIME   PIC S9(9) BINARY VALUE 3185.
       10  MQCACF-CF-SMDSCONN   PIC S9(9) BINARY VALUE 3186.
       10  MQCACF-CF-STRUC-NAME   PIC S9(9) BINARY VALUE 3187.
       10  MQCACF-ALTERNATE-USERID   PIC S9(9) BINARY VALUE 3188.
       10  MQCACF-CHAR-ATTRS   PIC S9(9) BINARY VALUE 3189.
       10  MQCACF-DYNAMIC-Q-NAME   PIC S9(9) BINARY VALUE 3190.
       10  MQCACF-HOST-NAME   PIC S9(9) BINARY VALUE 3191.
       10  MQCACF-MQCB-NAME   PIC S9(9) BINARY VALUE 3192.
       10  MQCACF-OBJECT-STRING   PIC S9(9) BINARY VALUE 3193.
       10  MQCACF-RESOLVED-LOCAL-Q-MGR   PIC S9(9) BINARY VALUE 3194.
       10  MQCACF-RESOLVED-LOCAL-Q-NAME   PIC S9(9) BINARY VALUE 3195.
       10  MQCACF-RESOLVED-OBJECT-STRING   PIC S9(9) BINARY VALUE 3196.
       10  MQCACF-RESOLVED-Q-MGR   PIC S9(9) BINARY VALUE 3197.
       10  MQCACF-SELECTION-STRING   PIC S9(9) BINARY VALUE 3198.
       10  MQCACF-XA-INFO   PIC S9(9) BINARY VALUE 3199.
       10  MQCACF-APPL-FUNCTION   PIC S9(9) BINARY VALUE 3200.
       10  MQCACF-XQH-REMOTE-Q-NAME   PIC S9(9) BINARY VALUE 3201.
       10  MQCACF-XQH-REMOTE-Q-MGR   PIC S9(9) BINARY VALUE 3202.
       10  MQCACF-XQH-PUT-TIME   PIC S9(9) BINARY VALUE 3203.
       10  MQCACF-XQH-PUT-DATE   PIC S9(9) BINARY VALUE 3204.
       10  MQCACF-EXCL-OPERATOR-MESSAGES   PIC S9(9) BINARY VALUE 3205.
       10  MQCACF-CSP-USER-IDENTIFIER   PIC S9(9) BINARY VALUE 3206.
       10  MQCACF-AMQP-CLIENT-ID   PIC S9(9) BINARY VALUE 3207.
       10  MQCACF-ARCHIVE-LOG-EXTENT-NAME   PIC S9(9) BINARY VALUE 3208.
       10  MQCACF-APPL-IMMOVABLE-DATE   PIC S9(9) BINARY VALUE 3209.
       10  MQCACF-APPL-IMMOVABLE-TIME   PIC S9(9) BINARY VALUE 3210.
       10  MQCACF-NHA-INSTANCE-NAME   PIC S9(9) BINARY VALUE 3211.
       10  MQCACF-LAST-USED   PIC S9(9) BINARY VALUE 3211.

      ** Character Channel Parameter Types
       10  MQCACH-FIRST   PIC S9(9) BINARY VALUE 3501.
       10  MQCACH-CHANNEL-NAME   PIC S9(9) BINARY VALUE 3501.
       10  MQCACH-DESC   PIC S9(9) BINARY VALUE 3502.
       10  MQCACH-MODE-NAME   PIC S9(9) BINARY VALUE 3503.
       10  MQCACH-TP-NAME   PIC S9(9) BINARY VALUE 3504.
       10  MQCACH-XMIT-Q-NAME   PIC S9(9) BINARY VALUE 3505.
       10  MQCACH-CONNECTION-NAME   PIC S9(9) BINARY VALUE 3506.
       10  MQCACH-MCA-NAME   PIC S9(9) BINARY VALUE 3507.
       10  MQCACH-SEC-EXIT-NAME   PIC S9(9) BINARY VALUE 3508.
       10  MQCACH-MSG-EXIT-NAME   PIC S9(9) BINARY VALUE 3509.
       10  MQCACH-SEND-EXIT-NAME   PIC S9(9) BINARY VALUE 3510.
       10  MQCACH-RCV-EXIT-NAME   PIC S9(9) BINARY VALUE 3511.
       10  MQCACH-CHANNEL-NAMES   PIC S9(9) BINARY VALUE 3512.
       10  MQCACH-SEC-EXIT-USER-DATA   PIC S9(9) BINARY VALUE 3513.
       10  MQCACH-MSG-EXIT-USER-DATA   PIC S9(9) BINARY VALUE 3514.
       10  MQCACH-SEND-EXIT-USER-DATA   PIC S9(9) BINARY VALUE 3515.
       10  MQCACH-RCV-EXIT-USER-DATA   PIC S9(9) BINARY VALUE 3516.
       10  MQCACH-USER-ID   PIC S9(9) BINARY VALUE 3517.
       10  MQCACH-PASSWORD   PIC S9(9) BINARY VALUE 3518.
       10  MQCACH-LOCAL-ADDRESS   PIC S9(9) BINARY VALUE 3520.
       10  MQCACH-LOCAL-NAME   PIC S9(9) BINARY VALUE 3521.
       10  MQCACH-LAST-MSG-TIME   PIC S9(9) BINARY VALUE 3524.
       10  MQCACH-LAST-MSG-DATE   PIC S9(9) BINARY VALUE 3525.
       10  MQCACH-MCA-USER-ID   PIC S9(9) BINARY VALUE 3527.
       10  MQCACH-CHANNEL-START-TIME   PIC S9(9) BINARY VALUE 3528.
       10  MQCACH-CHANNEL-START-DATE   PIC S9(9) BINARY VALUE 3529.
       10  MQCACH-MCA-JOB-NAME   PIC S9(9) BINARY VALUE 3530.
       10  MQCACH-LAST-LUWID   PIC S9(9) BINARY VALUE 3531.
       10  MQCACH-CURRENT-LUWID   PIC S9(9) BINARY VALUE 3532.
       10  MQCACH-FORMAT-NAME   PIC S9(9) BINARY VALUE 3533.
       10  MQCACH-MR-EXIT-NAME   PIC S9(9) BINARY VALUE 3534.
       10  MQCACH-MR-EXIT-USER-DATA   PIC S9(9) BINARY VALUE 3535.
       10  MQCACH-SSL-CIPHER-SPEC   PIC S9(9) BINARY VALUE 3544.
       10  MQCACH-SSL-PEER-NAME   PIC S9(9) BINARY VALUE 3545.
       10  MQCACH-SSL-HANDSHAKE-STAGE   PIC S9(9) BINARY VALUE 3546.
       10  MQCACH-SSL-SHORT-PEER-NAME   PIC S9(9) BINARY VALUE 3547.
       10  MQCACH-REMOTE-APPL-TAG   PIC S9(9) BINARY VALUE 3548.
       10  MQCACH-SSL-CERT-USER-ID   PIC S9(9) BINARY VALUE 3549.
       10  MQCACH-SSL-CERT-ISSUER-NAME   PIC S9(9) BINARY VALUE 3550.
       10  MQCACH-LU-NAME   PIC S9(9) BINARY VALUE 3551.
       10  MQCACH-IP-ADDRESS   PIC S9(9) BINARY VALUE 3552.
       10  MQCACH-TCP-NAME   PIC S9(9) BINARY VALUE 3553.
       10  MQCACH-LISTENER-NAME   PIC S9(9) BINARY VALUE 3554.
       10  MQCACH-LISTENER-DESC   PIC S9(9) BINARY VALUE 3555.
       10  MQCACH-LISTENER-START-DATE   PIC S9(9) BINARY VALUE 3556.
       10  MQCACH-LISTENER-START-TIME   PIC S9(9) BINARY VALUE 3557.
       10  MQCACH-SSL-KEY-RESET-DATE   PIC S9(9) BINARY VALUE 3558.
       10  MQCACH-SSL-KEY-RESET-TIME   PIC S9(9) BINARY VALUE 3559.
       10  MQCACH-REMOTE-VERSION   PIC S9(9) BINARY VALUE 3560.
       10  MQCACH-REMOTE-PRODUCT   PIC S9(9) BINARY VALUE 3561.
       10  MQCACH-GROUP-ADDRESS   PIC S9(9) BINARY VALUE 3562.
       10  MQCACH-JAAS-CONFIG   PIC S9(9) BINARY VALUE 3563.
       10  MQCACH-CLIENT-ID   PIC S9(9) BINARY VALUE 3564.
       10  MQCACH-SSL-KEY-PASSPHRASE   PIC S9(9) BINARY VALUE 3565.
       10  MQCACH-CONNECTION-NAME-LIST   PIC S9(9) BINARY VALUE 3566.
       10  MQCACH-CLIENT-USER-ID   PIC S9(9) BINARY VALUE 3567.
       10  MQCACH-MCA-USER-ID-LIST   PIC S9(9) BINARY VALUE 3568.
       10  MQCACH-SSL-CIPHER-SUITE   PIC S9(9) BINARY VALUE 3569.
       10  MQCACH-WEBCONTENT-PATH   PIC S9(9) BINARY VALUE 3570.
       10  MQCACH-TOPIC-ROOT   PIC S9(9) BINARY VALUE 3571.
       10  MQCACH-TEMPORARY-MODEL-Q   PIC S9(9) BINARY VALUE 3572.
       10  MQCACH-TEMPORARY-Q-PREFIX   PIC S9(9) BINARY VALUE 3573.
       10  MQCACH-LAST-USED   PIC S9(9) BINARY VALUE 3573.

      ******************************************************************
      **  Values Related to Group Parameter Structures             
      ******************************************************************
      ** Group Parameter Types
       10  MQGACF-FIRST   PIC S9(9) BINARY VALUE 8001.
       10  MQGACF-COMMAND-CONTEXT   PIC S9(9) BINARY VALUE 8001.
       10  MQGACF-COMMAND-DATA   PIC S9(9) BINARY VALUE 8002.
       10  MQGACF-TRACE-ROUTE   PIC S9(9) BINARY VALUE 8003.
       10  MQGACF-OPERATION   PIC S9(9) BINARY VALUE 8004.
       10  MQGACF-ACTIVITY   PIC S9(9) BINARY VALUE 8005.
       10  MQGACF-EMBEDDED-MQMD   PIC S9(9) BINARY VALUE 8006.
       10  MQGACF-MESSAGE   PIC S9(9) BINARY VALUE 8007.
       10  MQGACF-MQMD   PIC S9(9) BINARY VALUE 8008.
       10  MQGACF-VALUE-NAMING   PIC S9(9) BINARY VALUE 8009.
       10  MQGACF-Q-ACCOUNTING-DATA   PIC S9(9) BINARY VALUE 8010.
       10  MQGACF-Q-STATISTICS-DATA   PIC S9(9) BINARY VALUE 8011.
       10  MQGACF-CHL-STATISTICS-DATA   PIC S9(9) BINARY VALUE 8012.
       10  MQGACF-ACTIVITY-TRACE   PIC S9(9) BINARY VALUE 8013.
       10  MQGACF-APP-DIST-LIST   PIC S9(9) BINARY VALUE 8014.
       10  MQGACF-MONITOR-CLASS   PIC S9(9) BINARY VALUE 8015.
       10  MQGACF-MONITOR-TYPE   PIC S9(9) BINARY VALUE 8016.
       10  MQGACF-MONITOR-ELEMENT   PIC S9(9) BINARY VALUE 8017.
       10  MQGACF-APPL-STATUS   PIC S9(9) BINARY VALUE 8018.
       10  MQGACF-CHANGED-APPLS   PIC S9(9) BINARY VALUE 8019.
       10  MQGACF-ALL-APPLS   PIC S9(9) BINARY VALUE 8020.
       10  MQGACF-APPL-BALANCE   PIC S9(9) BINARY VALUE 8021.
       10  MQGACF-LAST-USED   PIC S9(9) BINARY VALUE 8021.

      ******************************************************************
      **  Parameter Values                                         
      ******************************************************************
      ** Action Options
       10  MQACT-FORCE-REMOVE   PIC S9(9) BINARY VALUE 1.
       10  MQACT-ADVANCE-LOG   PIC S9(9) BINARY VALUE 2.
       10  MQACT-COLLECT-STATISTICS   PIC S9(9) BINARY VALUE 3.
       10  MQACT-PUBSUB   PIC S9(9) BINARY VALUE 4.
       10  MQACT-ADD   PIC S9(9) BINARY VALUE 5.
       10  MQACT-REPLACE   PIC S9(9) BINARY VALUE 6.
       10  MQACT-REMOVE   PIC S9(9) BINARY VALUE 7.
       10  MQACT-REMOVEALL   PIC S9(9) BINARY VALUE 8.
       10  MQACT-FAIL   PIC S9(9) BINARY VALUE 9.
       10  MQACT-REDUCE-LOG   PIC S9(9) BINARY VALUE 10.
       10  MQACT-ARCHIVE-LOG   PIC S9(9) BINARY VALUE 11.

      ** State Options
       10  MQIS-NO   PIC S9(9) BINARY VALUE 0.
       10  MQIS-YES   PIC S9(9) BINARY VALUE 1.

      ** Movable Options
       10  MQAPPL-IMMOVABLE   PIC S9(9) BINARY VALUE 0.
       10  MQAPPL-MOVABLE   PIC S9(9) BINARY VALUE 1.

      ** Active Options
       10  MQACTIVE-NO   PIC S9(9) BINARY VALUE 0.
       10  MQACTIVE-YES   PIC S9(9) BINARY VALUE 1.

      ** Balance Options
       10  MQBALANCED-NO   PIC S9(9) BINARY VALUE 0.
       10  MQBALANCED-YES   PIC S9(9) BINARY VALUE 1.
       10  MQBALANCED-NOT-APPLICABLE   PIC S9(9) BINARY VALUE 2.
       10  MQBALANCED-UNKNOWN   PIC S9(9) BINARY VALUE 3.

      ** Balance State
       10  MQBALSTATE-NOT-APPLICABLE   PIC S9(9) BINARY VALUE 0.
       10  MQBALSTATE-LOW   PIC S9(9) BINARY VALUE 1.
       10  MQBALSTATE-OK   PIC S9(9) BINARY VALUE 2.
       10  MQBALSTATE-HIGH   PIC S9(9) BINARY VALUE 3.
       10  MQBALSTATE-UNKNOWN   PIC S9(9) BINARY VALUE 4.

      ** Immovable Reasons
       10  MQIMMREASON-NONE   PIC S9(9) BINARY VALUE 0.
       10  MQIMMREASON-NOT-CLIENT   PIC S9(9) BINARY VALUE 1.
       10  MQIMMREASON-NOT-RECONNECTABLE   PIC S9(9) BINARY VALUE 2.
       10  MQIMMREASON-MOVING   PIC S9(9) BINARY VALUE 3.
       10  MQIMMREASON-APPLNAME-CHANGED   PIC S9(9) BINARY VALUE 4.
       10  MQIMMREASON-IN-TRANSACTION   PIC S9(9) BINARY VALUE 5.
       10  MQIMMREASON-AWAITS-REPLY   PIC S9(9) BINARY VALUE 6.
       10  MQIMMREASON-NO-REDIRECT   PIC S9(9) BINARY VALUE 7.

      ** Asynchronous State Values
       10  MQAS-NONE   PIC S9(9) BINARY VALUE 0.
       10  MQAS-STARTED   PIC S9(9) BINARY VALUE 1.
       10  MQAS-START-WAIT   PIC S9(9) BINARY VALUE 2.
       10  MQAS-STOPPED   PIC S9(9) BINARY VALUE 3.
       10  MQAS-SUSPENDED   PIC S9(9) BINARY VALUE 4.
       10  MQAS-SUSPENDED-TEMPORARY   PIC S9(9) BINARY VALUE 5.
       10  MQAS-ACTIVE   PIC S9(9) BINARY VALUE 6.
       10  MQAS-INACTIVE   PIC S9(9) BINARY VALUE 7.

      ** Authority Values
       10  MQAUTH-NONE   PIC S9(9) BINARY VALUE 0.
       10  MQAUTH-ALT-USER-AUTHORITY   PIC S9(9) BINARY VALUE 1.
       10  MQAUTH-BROWSE   PIC S9(9) BINARY VALUE 2.
       10  MQAUTH-CHANGE   PIC S9(9) BINARY VALUE 3.
       10  MQAUTH-CLEAR   PIC S9(9) BINARY VALUE 4.
       10  MQAUTH-CONNECT   PIC S9(9) BINARY VALUE 5.
       10  MQAUTH-CREATE   PIC S9(9) BINARY VALUE 6.
       10  MQAUTH-DELETE   PIC S9(9) BINARY VALUE 7.
       10  MQAUTH-DISPLAY   PIC S9(9) BINARY VALUE 8.
       10  MQAUTH-INPUT   PIC S9(9) BINARY VALUE 9.
       10  MQAUTH-INQUIRE   PIC S9(9) BINARY VALUE 10.
       10  MQAUTH-OUTPUT   PIC S9(9) BINARY VALUE 11.
       10  MQAUTH-PASS-ALL-CONTEXT   PIC S9(9) BINARY VALUE 12.
       10  MQAUTH-PASS-IDENTITY-CONTEXT   PIC S9(9) BINARY VALUE 13.
       10  MQAUTH-SET   PIC S9(9) BINARY VALUE 14.
       10  MQAUTH-SET-ALL-CONTEXT   PIC S9(9) BINARY VALUE 15.
       10  MQAUTH-SET-IDENTITY-CONTEXT   PIC S9(9) BINARY VALUE 16.
       10  MQAUTH-CONTROL   PIC S9(9) BINARY VALUE 17.
       10  MQAUTH-CONTROL-EXTENDED   PIC S9(9) BINARY VALUE 18.
       10  MQAUTH-PUBLISH   PIC S9(9) BINARY VALUE 19.
       10  MQAUTH-SUBSCRIBE   PIC S9(9) BINARY VALUE 20.
       10  MQAUTH-RESUME   PIC S9(9) BINARY VALUE 21.
       10  MQAUTH-SYSTEM   PIC S9(9) BINARY VALUE 22.
       10  MQAUTH-ALL   PIC S9(9) BINARY VALUE -1.
       10  MQAUTH-ALL-ADMIN   PIC S9(9) BINARY VALUE -2.
       10  MQAUTH-ALL-MQI   PIC S9(9) BINARY VALUE -3.

      ** Authority Options
       10  MQAUTHOPT-ENTITY-EXPLICIT   PIC S9(9) BINARY VALUE 1.
       10  MQAUTHOPT-ENTITY-SET   PIC S9(9) BINARY VALUE 2.
       10  MQAUTHOPT-NAME-EXPLICIT   PIC S9(9) BINARY VALUE 16.
       10  MQAUTHOPT-NAME-ALL-MATCHING   PIC S9(9) BINARY VALUE 32.
       10  MQAUTHOPT-NAME-AS-WILDCARD   PIC S9(9) BINARY VALUE 64.
       10  MQAUTHOPT-CUMULATIVE   PIC S9(9) BINARY VALUE 256.
       10  MQAUTHOPT-EXCLUDE-TEMP   PIC S9(9) BINARY VALUE 512.

      ** Bridge Types
       10  MQBT-OTMA   PIC S9(9) BINARY VALUE 1.

      ** Refresh Repository Options
       10  MQCFO-REFRESH-REPOSITORY-YES   PIC S9(9) BINARY VALUE 1.
       10  MQCFO-REFRESH-REPOSITORY-NO   PIC S9(9) BINARY VALUE 0.

      ** Remove Queues Options
       10  MQCFO-REMOVE-QUEUES-YES   PIC S9(9) BINARY VALUE 1.
       10  MQCFO-REMOVE-QUEUES-NO   PIC S9(9) BINARY VALUE 0.

      ** CHLAUTH Type
       10  MQCAUT-ALL   PIC S9(9) BINARY VALUE 0.
       10  MQCAUT-BLOCKUSER   PIC S9(9) BINARY VALUE 1.
       10  MQCAUT-BLOCKADDR   PIC S9(9) BINARY VALUE 2.
       10  MQCAUT-SSLPEERMAP   PIC S9(9) BINARY VALUE 3.
       10  MQCAUT-ADDRESSMAP   PIC S9(9) BINARY VALUE 4.
       10  MQCAUT-USERMAP   PIC S9(9) BINARY VALUE 5.
       10  MQCAUT-QMGRMAP   PIC S9(9) BINARY VALUE 6.

      ** CF Status
       10  MQCFSTATUS-NOT-FOUND   PIC S9(9) BINARY VALUE 0.
       10  MQCFSTATUS-ACTIVE   PIC S9(9) BINARY VALUE 1.
       10  MQCFSTATUS-IN-RECOVER   PIC S9(9) BINARY VALUE 2.
       10  MQCFSTATUS-IN-BACKUP   PIC S9(9) BINARY VALUE 3.
       10  MQCFSTATUS-FAILED   PIC S9(9) BINARY VALUE 4.
       10  MQCFSTATUS-NONE   PIC S9(9) BINARY VALUE 5.
       10  MQCFSTATUS-UNKNOWN   PIC S9(9) BINARY VALUE 6.
       10  MQCFSTATUS-RECOVERED   PIC S9(9) BINARY VALUE 7.
       10  MQCFSTATUS-EMPTY   PIC S9(9) BINARY VALUE 8.
       10  MQCFSTATUS-NEW   PIC S9(9) BINARY VALUE 9.
       10  MQCFSTATUS-ADMIN-INCOMPLETE   PIC S9(9) BINARY VALUE 20.
       10  MQCFSTATUS-NEVER-USED   PIC S9(9) BINARY VALUE 21.
       10  MQCFSTATUS-NO-BACKUP   PIC S9(9) BINARY VALUE 22.
       10  MQCFSTATUS-NOT-FAILED   PIC S9(9) BINARY VALUE 23.
       10  MQCFSTATUS-NOT-RECOVERABLE   PIC S9(9) BINARY VALUE 24.
       10  MQCFSTATUS-XES-ERROR   PIC S9(9) BINARY VALUE 25.

      ** CF Types
       10  MQCFTYPE-APPL   PIC S9(9) BINARY VALUE 0.
       10  MQCFTYPE-ADMIN   PIC S9(9) BINARY VALUE 1.

      ** Indoubt Status
       10  MQCHIDS-NOT-INDOUBT   PIC S9(9) BINARY VALUE 0.
       10  MQCHIDS-INDOUBT   PIC S9(9) BINARY VALUE 1.

      ** Channel Dispositions
       10  MQCHLD-ALL   PIC S9(9) BINARY VALUE -1.
       10  MQCHLD-DEFAULT   PIC S9(9) BINARY VALUE 1.
       10  MQCHLD-SHARED   PIC S9(9) BINARY VALUE 2.
       10  MQCHLD-PRIVATE   PIC S9(9) BINARY VALUE 4.
       10  MQCHLD-FIXSHARED   PIC S9(9) BINARY VALUE 5.

      ** Use ClientID
       10  MQUCI-YES   PIC S9(9) BINARY VALUE 1.
       10  MQUCI-NO   PIC S9(9) BINARY VALUE 0.

      ** Channel Status
       10  MQCHS-INACTIVE   PIC S9(9) BINARY VALUE 0.
       10  MQCHS-BINDING   PIC S9(9) BINARY VALUE 1.
       10  MQCHS-STARTING   PIC S9(9) BINARY VALUE 2.
       10  MQCHS-RUNNING   PIC S9(9) BINARY VALUE 3.
       10  MQCHS-STOPPING   PIC S9(9) BINARY VALUE 4.
       10  MQCHS-RETRYING   PIC S9(9) BINARY VALUE 5.
       10  MQCHS-STOPPED   PIC S9(9) BINARY VALUE 6.
       10  MQCHS-REQUESTING   PIC S9(9) BINARY VALUE 7.
       10  MQCHS-PAUSED   PIC S9(9) BINARY VALUE 8.
       10  MQCHS-DISCONNECTED   PIC S9(9) BINARY VALUE 9.
       10  MQCHS-INITIALIZING   PIC S9(9) BINARY VALUE 13.
       10  MQCHS-SWITCHING   PIC S9(9) BINARY VALUE 14.

      ** Channel Substates
       10  MQCHSSTATE-OTHER   PIC S9(9) BINARY VALUE 0.
       10  MQCHSSTATE-END-OF-BATCH   PIC S9(9) BINARY VALUE 100.
       10  MQCHSSTATE-SENDING   PIC S9(9) BINARY VALUE 200.
       10  MQCHSSTATE-RECEIVING   PIC S9(9) BINARY VALUE 300.
       10  MQCHSSTATE-SERIALIZING   PIC S9(9) BINARY VALUE 400.
       10  MQCHSSTATE-RESYNCHING   PIC S9(9) BINARY VALUE 500.
       10  MQCHSSTATE-HEARTBEATING   PIC S9(9) BINARY VALUE 600.
       10  MQCHSSTATE-IN-SCYEXIT   PIC S9(9) BINARY VALUE 700.
       10  MQCHSSTATE-IN-RCVEXIT   PIC S9(9) BINARY VALUE 800.
       10  MQCHSSTATE-IN-SENDEXIT   PIC S9(9) BINARY VALUE 900.
       10  MQCHSSTATE-IN-MSGEXIT   PIC S9(9) BINARY VALUE 1000.
       10  MQCHSSTATE-IN-MREXIT   PIC S9(9) BINARY VALUE 1100.
       10  MQCHSSTATE-IN-CHADEXIT   PIC S9(9) BINARY VALUE 1200.
       10  MQCHSSTATE-NET-CONNECTING   PIC S9(9) BINARY VALUE 1250.
       10  MQCHSSTATE-SSL-HANDSHAKING   PIC S9(9) BINARY VALUE 1300.
       10  MQCHSSTATE-NAME-SERVER   PIC S9(9) BINARY VALUE 1400.
       10  MQCHSSTATE-IN-MQPUT   PIC S9(9) BINARY VALUE 1500.
       10  MQCHSSTATE-IN-MQGET   PIC S9(9) BINARY VALUE 1600.
       10  MQCHSSTATE-IN-MQI-CALL   PIC S9(9) BINARY VALUE 1700.
       10  MQCHSSTATE-COMPRESSING   PIC S9(9) BINARY VALUE 1800.

      ** Channel Shared Restart Options
       10  MQCHSH-RESTART-NO   PIC S9(9) BINARY VALUE 0.
       10  MQCHSH-RESTART-YES   PIC S9(9) BINARY VALUE 1.

      ** Channel Stop Options
       10  MQCHSR-STOP-NOT-REQUESTED   PIC S9(9) BINARY VALUE 0.
       10  MQCHSR-STOP-REQUESTED   PIC S9(9) BINARY VALUE 1.

      ** Channel reset requested
       10  MQCHRR-RESET-NOT-REQUESTED   PIC S9(9) BINARY VALUE 0.

      ** Channel Table Types
       10  MQCHTAB-Q-MGR   PIC S9(9) BINARY VALUE 1.
       10  MQCHTAB-CLNTCONN   PIC S9(9) BINARY VALUE 2.

      ** Clear Topic String Scope
       10  MQCLRS-LOCAL   PIC S9(9) BINARY VALUE 1.
       10  MQCLRS-GLOBAL   PIC S9(9) BINARY VALUE 2.

      ** Clear Topic String Type
       10  MQCLRT-RETAINED   PIC S9(9) BINARY VALUE 1.

      ** Command Information Values
       10  MQCMDI-CMDSCOPE-ACCEPTED   PIC S9(9) BINARY VALUE 1.
       10  MQCMDI-CMDSCOPE-GENERATED   PIC S9(9) BINARY VALUE 2.
       10  MQCMDI-CMDSCOPE-COMPLETED   PIC S9(9) BINARY VALUE 3.
       10  MQCMDI-QSG-DISP-COMPLETED   PIC S9(9) BINARY VALUE 4.
       10  MQCMDI-COMMAND-ACCEPTED   PIC S9(9) BINARY VALUE 5.
       10  MQCMDI-CLUSTER-REQUEST-QUEUED   PIC S9(9) BINARY VALUE 6.
       10  MQCMDI-CHANNEL-INIT-STARTED   PIC S9(9) BINARY VALUE 7.
       10  MQCMDI-RECOVER-STARTED   PIC S9(9) BINARY VALUE 11.
       10  MQCMDI-BACKUP-STARTED   PIC S9(9) BINARY VALUE 12.
       10  MQCMDI-RECOVER-COMPLETED   PIC S9(9) BINARY VALUE 13.
       10  MQCMDI-SEC-TIMER-ZERO   PIC S9(9) BINARY VALUE 14.
       10  MQCMDI-REFRESH-CONFIGURATION   PIC S9(9) BINARY VALUE 16.
       10  MQCMDI-SEC-SIGNOFF-ERROR   PIC S9(9) BINARY VALUE 17.
       10  MQCMDI-IMS-BRIDGE-SUSPENDED   PIC S9(9) BINARY VALUE 18.
       10  MQCMDI-DB2-SUSPENDED   PIC S9(9) BINARY VALUE 19.
       10  MQCMDI-DB2-OBSOLETE-MSGS   PIC S9(9) BINARY VALUE 20.
       10  MQCMDI-SEC-UPPERCASE   PIC S9(9) BINARY VALUE 21.
       10  MQCMDI-SEC-MIXEDCASE   PIC S9(9) BINARY VALUE 22.

      ** Disconnect Types
       10  MQDISCONNECT-NORMAL   PIC S9(9) BINARY VALUE 0.
       10  MQDISCONNECT-IMPLICIT   PIC S9(9) BINARY VALUE 1.
       10  MQDISCONNECT-Q-MGR   PIC S9(9) BINARY VALUE 2.

      ** Escape Types
       10  MQET-MQSC   PIC S9(9) BINARY VALUE 1.

      ** Event Origins
       10  MQEVO-OTHER   PIC S9(9) BINARY VALUE 0.
       10  MQEVO-CONSOLE   PIC S9(9) BINARY VALUE 1.
       10  MQEVO-INIT   PIC S9(9) BINARY VALUE 2.
       10  MQEVO-MSG   PIC S9(9) BINARY VALUE 3.
       10  MQEVO-MQSET   PIC S9(9) BINARY VALUE 4.
       10  MQEVO-INTERNAL   PIC S9(9) BINARY VALUE 5.
       10  MQEVO-MQSUB   PIC S9(9) BINARY VALUE 6.
       10  MQEVO-CTLMSG   PIC S9(9) BINARY VALUE 7.
       10  MQEVO-REST   PIC S9(9) BINARY VALUE 8.

      ** Event Recording
       10  MQEVR-DISABLED   PIC S9(9) BINARY VALUE 0.
       10  MQEVR-ENABLED   PIC S9(9) BINARY VALUE 1.
       10  MQEVR-EXCEPTION   PIC S9(9) BINARY VALUE 2.
       10  MQEVR-NO-DISPLAY   PIC S9(9) BINARY VALUE 3.
       10  MQEVR-API-ONLY   PIC S9(9) BINARY VALUE 4.
       10  MQEVR-ADMIN-ONLY   PIC S9(9) BINARY VALUE 5.
       10  MQEVR-USER-ONLY   PIC S9(9) BINARY VALUE 6.

      ** Force Options
       10  MQFC-YES   PIC S9(9) BINARY VALUE 1.
       10  MQFC-NO   PIC S9(9) BINARY VALUE 0.

      ** Handle States
       10  MQHSTATE-INACTIVE   PIC S9(9) BINARY VALUE 0.
       10  MQHSTATE-ACTIVE   PIC S9(9) BINARY VALUE 1.

      ** Inbound Dispositions
       10  MQINBD-Q-MGR   PIC S9(9) BINARY VALUE 0.
       10  MQINBD-GROUP   PIC S9(9) BINARY VALUE 3.

      ** Indoubt Options
       10  MQIDO-COMMIT   PIC S9(9) BINARY VALUE 1.
       10  MQIDO-BACKOUT   PIC S9(9) BINARY VALUE 2.

      ** Match Types
       10  MQMATCH-GENERIC   PIC S9(9) BINARY VALUE 0.
       10  MQMATCH-RUNCHECK   PIC S9(9) BINARY VALUE 1.
       10  MQMATCH-EXACT   PIC S9(9) BINARY VALUE 2.
       10  MQMATCH-ALL   PIC S9(9) BINARY VALUE 3.

      ** Message Channel Agent Status
       10  MQMCAS-STOPPED   PIC S9(9) BINARY VALUE 0.
       10  MQMCAS-RUNNING   PIC S9(9) BINARY VALUE 3.

      ** Mode Options
       10  MQMODE-FORCE   PIC S9(9) BINARY VALUE 0.
       10  MQMODE-QUIESCE   PIC S9(9) BINARY VALUE 1.
       10  MQMODE-TERMINATE   PIC S9(9) BINARY VALUE 2.

      ** Message Level Protection
       10  MQMLP-TOLERATE-UNPROTECTED-NO   PIC S9(9) BINARY VALUE 0.
       10  MQMLP-TOLERATE-UNPROTECTED-YES   PIC S9(9) BINARY VALUE 1.
       10  MQMLP-ENCRYPTION-ALG-NONE   PIC S9(9) BINARY VALUE 0.
       10  MQMLP-ENCRYPTION-ALG-RC2   PIC S9(9) BINARY VALUE 1.
       10  MQMLP-ENCRYPTION-ALG-DES   PIC S9(9) BINARY VALUE 2.
       10  MQMLP-ENCRYPTION-ALG-3DES   PIC S9(9) BINARY VALUE 3.
       10  MQMLP-ENCRYPTION-ALG-AES128   PIC S9(9) BINARY VALUE 4.
       10  MQMLP-ENCRYPTION-ALG-AES256   PIC S9(9) BINARY VALUE 5.
       10  MQMLP-SIGN-ALG-NONE   PIC S9(9) BINARY VALUE 0.
       10  MQMLP-SIGN-ALG-MD5   PIC S9(9) BINARY VALUE 1.
       10  MQMLP-SIGN-ALG-SHA1   PIC S9(9) BINARY VALUE 2.
       10  MQMLP-SIGN-ALG-SHA224   PIC S9(9) BINARY VALUE 3.
       10  MQMLP-SIGN-ALG-SHA256   PIC S9(9) BINARY VALUE 4.
       10  MQMLP-SIGN-ALG-SHA384   PIC S9(9) BINARY VALUE 5.
       10  MQMLP-SIGN-ALG-SHA512   PIC S9(9) BINARY VALUE 6.

      ** Purge Options
       10  MQPO-YES   PIC S9(9) BINARY VALUE 1.
       10  MQPO-NO   PIC S9(9) BINARY VALUE 0.

      ** Pub/Sub Status Counts
       10  MQPSCT-NONE   PIC S9(9) BINARY VALUE -1.

      ** Pub/Sub Status Type
       10  MQPSST-ALL   PIC S9(9) BINARY VALUE 0.
       10  MQPSST-LOCAL   PIC S9(9) BINARY VALUE 1.
       10  MQPSST-PARENT   PIC S9(9) BINARY VALUE 2.
       10  MQPSST-CHILD   PIC S9(9) BINARY VALUE 3.

      ** Pub/Sub Status
       10  MQPS-STATUS-INACTIVE   PIC S9(9) BINARY VALUE 0.
       10  MQPS-STATUS-STARTING   PIC S9(9) BINARY VALUE 1.
       10  MQPS-STATUS-STOPPING   PIC S9(9) BINARY VALUE 2.
       10  MQPS-STATUS-ACTIVE   PIC S9(9) BINARY VALUE 3.
       10  MQPS-STATUS-COMPAT   PIC S9(9) BINARY VALUE 4.
       10  MQPS-STATUS-ERROR   PIC S9(9) BINARY VALUE 5.
       10  MQPS-STATUS-REFUSED   PIC S9(9) BINARY VALUE 6.

      ** Queue Manager Definition Types
       10  MQQMDT-EXPLICIT-CLUSTER-SENDER   PIC S9(9) BINARY VALUE 1.
       10  MQQMDT-AUTO-CLUSTER-SENDER   PIC S9(9) BINARY VALUE 2.
       10  MQQMDT-AUTO-EXP-CLUSTER-SENDER   PIC S9(9) BINARY VALUE 4.
       10  MQQMDT-CLUSTER-RECEIVER   PIC S9(9) BINARY VALUE 3.

      ** Queue Manager Facility
       10  MQQMFAC-IMS-BRIDGE   PIC S9(9) BINARY VALUE 1.
       10  MQQMFAC-DB2   PIC S9(9) BINARY VALUE 2.

      ** Queue Manager Status
       10  MQQMSTA-STARTING   PIC S9(9) BINARY VALUE 1.
       10  MQQMSTA-RUNNING   PIC S9(9) BINARY VALUE 2.
       10  MQQMSTA-QUIESCING   PIC S9(9) BINARY VALUE 3.
       10  MQQMSTA-STANDBY   PIC S9(9) BINARY VALUE 4.

      ** Queue Manager Types
       10  MQQMT-NORMAL   PIC S9(9) BINARY VALUE 0.
       10  MQQMT-REPOSITORY   PIC S9(9) BINARY VALUE 1.

      ** Quiesce Options
       10  MQQO-YES   PIC S9(9) BINARY VALUE 1.
       10  MQQO-NO   PIC S9(9) BINARY VALUE 0.

      ** Queue Service-Interval Events
       10  MQQSIE-NONE   PIC S9(9) BINARY VALUE 0.
       10  MQQSIE-HIGH   PIC S9(9) BINARY VALUE 1.
       10  MQQSIE-OK   PIC S9(9) BINARY VALUE 2.

      ** Queue Status Open Types
       10  MQQSOT-ALL   PIC S9(9) BINARY VALUE 1.
       10  MQQSOT-INPUT   PIC S9(9) BINARY VALUE 2.
       10  MQQSOT-OUTPUT   PIC S9(9) BINARY VALUE 3.

      ** QSG Status
       10  MQQSGS-UNKNOWN   PIC S9(9) BINARY VALUE 0.
       10  MQQSGS-CREATED   PIC S9(9) BINARY VALUE 1.
       10  MQQSGS-ACTIVE   PIC S9(9) BINARY VALUE 2.
       10  MQQSGS-INACTIVE   PIC S9(9) BINARY VALUE 3.
       10  MQQSGS-FAILED   PIC S9(9) BINARY VALUE 4.
       10  MQQSGS-PENDING   PIC S9(9) BINARY VALUE 5.

      ** Queue Status Open Options for SET, BROWSE, INPUT
       10  MQQSO-NO   PIC S9(9) BINARY VALUE 0.
       10  MQQSO-YES   PIC S9(9) BINARY VALUE 1.
       10  MQQSO-SHARED   PIC S9(9) BINARY VALUE 1.
       10  MQQSO-EXCLUSIVE   PIC S9(9) BINARY VALUE 2.

      ** Queue Status Uncommitted Messages
       10  MQQSUM-YES   PIC S9(9) BINARY VALUE 1.
       10  MQQSUM-NO   PIC S9(9) BINARY VALUE 0.

      ** Remove Authority Record Options
       10  MQRAR-YES   PIC S9(9) BINARY VALUE 1.
       10  MQRAR-NO   PIC S9(9) BINARY VALUE 0.

      ** Replace Options
       10  MQRP-YES   PIC S9(9) BINARY VALUE 1.
       10  MQRP-NO   PIC S9(9) BINARY VALUE 0.

      ** Reason Qualifiers
       10  MQRQ-CONN-NOT-AUTHORIZED   PIC S9(9) BINARY VALUE 1.
       10  MQRQ-OPEN-NOT-AUTHORIZED   PIC S9(9) BINARY VALUE 2.
       10  MQRQ-CLOSE-NOT-AUTHORIZED   PIC S9(9) BINARY VALUE 3.
       10  MQRQ-CMD-NOT-AUTHORIZED   PIC S9(9) BINARY VALUE 4.
       10  MQRQ-Q-MGR-STOPPING   PIC S9(9) BINARY VALUE 5.
       10  MQRQ-Q-MGR-QUIESCING   PIC S9(9) BINARY VALUE 6.
       10  MQRQ-CHANNEL-STOPPED-OK   PIC S9(9) BINARY VALUE 7.
       10  MQRQ-CHANNEL-STOPPED-ERROR   PIC S9(9) BINARY VALUE 8.
       10  MQRQ-CHANNEL-STOPPED-RETRY   PIC S9(9) BINARY VALUE 9.
       10  MQRQ-CHANNEL-STOPPED-DISABLED   PIC S9(9) BINARY VALUE 10.
       10  MQRQ-BRIDGE-STOPPED-OK   PIC S9(9) BINARY VALUE 11.
       10  MQRQ-BRIDGE-STOPPED-ERROR   PIC S9(9) BINARY VALUE 12.
       10  MQRQ-SSL-HANDSHAKE-ERROR   PIC S9(9) BINARY VALUE 13.
       10  MQRQ-SSL-CIPHER-SPEC-ERROR   PIC S9(9) BINARY VALUE 14.
       10  MQRQ-SSL-CLIENT-AUTH-ERROR   PIC S9(9) BINARY VALUE 15.
       10  MQRQ-SSL-PEER-NAME-ERROR   PIC S9(9) BINARY VALUE 16.
       10  MQRQ-SUB-NOT-AUTHORIZED   PIC S9(9) BINARY VALUE 17.
       10  MQRQ-SUB-DEST-NOT-AUTHORIZED   PIC S9(9) BINARY VALUE 18.
       10  MQRQ-SSL-UNKNOWN-REVOCATION   PIC S9(9) BINARY VALUE 19.
       10  MQRQ-SYS-CONN-NOT-AUTHORIZED   PIC S9(9) BINARY VALUE 20.
       10  MQRQ-CHANNEL-BLOCKED-ADDRESS   PIC S9(9) BINARY VALUE 21.
       10  MQRQ-CHANNEL-BLOCKED-USERID   PIC S9(9) BINARY VALUE 22.
       10  MQRQ-CHANNEL-BLOCKED-NOACCESS   PIC S9(9) BINARY VALUE 23.
       10  MQRQ-MAX-ACTIVE-CHANNELS   PIC S9(9) BINARY VALUE 24.
       10  MQRQ-MAX-CHANNELS   PIC S9(9) BINARY VALUE 25.
       10  MQRQ-SVRCONN-INST-LIMIT   PIC S9(9) BINARY VALUE 26.
       10  MQRQ-CLIENT-INST-LIMIT   PIC S9(9) BINARY VALUE 27.
       10  MQRQ-CAF-NOT-INSTALLED   PIC S9(9) BINARY VALUE 28.
       10  MQRQ-CSP-NOT-AUTHORIZED   PIC S9(9) BINARY VALUE 29.
       10  MQRQ-FAILOVER-PERMITTED   PIC S9(9) BINARY VALUE 30.
       10  MQRQ-FAILOVER-NOT-PERMITTED   PIC S9(9) BINARY VALUE 31.
       10  MQRQ-STANDBY-ACTIVATED   PIC S9(9) BINARY VALUE 32.
       10  MQRQ-REPLICA-ACTIVATED   PIC S9(9) BINARY VALUE 33.

      ** Refresh Types
       10  MQRT-CONFIGURATION   PIC S9(9) BINARY VALUE 1.
       10  MQRT-EXPIRY   PIC S9(9) BINARY VALUE 2.
       10  MQRT-NSPROC   PIC S9(9) BINARY VALUE 3.
       10  MQRT-PROXYSUB   PIC S9(9) BINARY VALUE 4.
       10  MQRT-SUB-CONFIGURATION   PIC S9(9) BINARY VALUE 5.

      ** Queue Definition Scope
       10  MQSCO-Q-MGR   PIC S9(9) BINARY VALUE 1.
       10  MQSCO-CELL   PIC S9(9) BINARY VALUE 2.

      ** Security Items
       10  MQSECITEM-ALL   PIC S9(9) BINARY VALUE 0.
       10  MQSECITEM-MQADMIN   PIC S9(9) BINARY VALUE 1.
       10  MQSECITEM-MQNLIST   PIC S9(9) BINARY VALUE 2.
       10  MQSECITEM-MQPROC   PIC S9(9) BINARY VALUE 3.
       10  MQSECITEM-MQQUEUE   PIC S9(9) BINARY VALUE 4.
       10  MQSECITEM-MQCONN   PIC S9(9) BINARY VALUE 5.
       10  MQSECITEM-MQCMDS   PIC S9(9) BINARY VALUE 6.
       10  MQSECITEM-MXADMIN   PIC S9(9) BINARY VALUE 7.
       10  MQSECITEM-MXNLIST   PIC S9(9) BINARY VALUE 8.
       10  MQSECITEM-MXPROC   PIC S9(9) BINARY VALUE 9.
       10  MQSECITEM-MXQUEUE   PIC S9(9) BINARY VALUE 10.
       10  MQSECITEM-MXTOPIC   PIC S9(9) BINARY VALUE 11.

      ** Security Switches
       10  MQSECSW-PROCESS   PIC S9(9) BINARY VALUE 1.
       10  MQSECSW-NAMELIST   PIC S9(9) BINARY VALUE 2.
       10  MQSECSW-Q   PIC S9(9) BINARY VALUE 3.
       10  MQSECSW-TOPIC   PIC S9(9) BINARY VALUE 4.
       10  MQSECSW-CONTEXT   PIC S9(9) BINARY VALUE 6.
       10  MQSECSW-ALTERNATE-USER   PIC S9(9) BINARY VALUE 7.
       10  MQSECSW-COMMAND   PIC S9(9) BINARY VALUE 8.
       10  MQSECSW-CONNECTION   PIC S9(9) BINARY VALUE 9.
       10  MQSECSW-SUBSYSTEM   PIC S9(9) BINARY VALUE 10.
       10  MQSECSW-COMMAND-RESOURCES   PIC S9(9) BINARY VALUE 11.
       10  MQSECSW-Q-MGR   PIC S9(9) BINARY VALUE 15.
       10  MQSECSW-QSG   PIC S9(9) BINARY VALUE 16.

      ** Security Switch States
       10  MQSECSW-OFF-FOUND   PIC S9(9) BINARY VALUE 21.
       10  MQSECSW-ON-FOUND   PIC S9(9) BINARY VALUE 22.
       10  MQSECSW-OFF-NOT-FOUND   PIC S9(9) BINARY VALUE 23.
       10  MQSECSW-ON-NOT-FOUND   PIC S9(9) BINARY VALUE 24.
       10  MQSECSW-OFF-ERROR   PIC S9(9) BINARY VALUE 25.
       10  MQSECSW-ON-OVERRIDDEN   PIC S9(9) BINARY VALUE 26.

      ** Security Types
       10  MQSECTYPE-AUTHSERV   PIC S9(9) BINARY VALUE 1.
       10  MQSECTYPE-SSL   PIC S9(9) BINARY VALUE 2.
       10  MQSECTYPE-CLASSES   PIC S9(9) BINARY VALUE 3.
       10  MQSECTYPE-CONNAUTH   PIC S9(9) BINARY VALUE 4.

      ** Authentication Validation Types
       10  MQCHK-OPTIONAL   PIC S9(9) BINARY VALUE 0.
       10  MQCHK-NONE   PIC S9(9) BINARY VALUE 1.
       10  MQCHK-REQUIRED-ADMIN   PIC S9(9) BINARY VALUE 2.
       10  MQCHK-REQUIRED   PIC S9(9) BINARY VALUE 3.
       10  MQCHK-AS-Q-MGR   PIC S9(9) BINARY VALUE 4.

      ** Authentication Adoption Context
       10  MQADPCTX-NO   PIC S9(9) BINARY VALUE 0.
       10  MQADPCTX-YES   PIC S9(9) BINARY VALUE 1.

      ** LDAP SSL/TLS Connection State
       10  MQSECCOMM-NO   PIC S9(9) BINARY VALUE 0.
       10  MQSECCOMM-YES   PIC S9(9) BINARY VALUE 1.
       10  MQSECCOMM-ANON   PIC S9(9) BINARY VALUE 2.

      ** LDAP Authorisation Method
       10  MQLDAP-AUTHORMD-OS   PIC S9(9) BINARY VALUE 0.
       10  MQLDAP-AUTHORMD-SEARCHGRP   PIC S9(9) BINARY VALUE 1.
       10  MQLDAP-AUTHORMD-SEARCHUSR   PIC S9(9) BINARY VALUE 2.
       10  MQLDAP-AUTHORMD-SRCHGRPSN   PIC S9(9) BINARY VALUE 3.

      ** LDAP Nested Group Policy
       10  MQLDAP-NESTGRP-NO   PIC S9(9) BINARY VALUE 0.
       10  MQLDAP-NESTGRP-YES   PIC S9(9) BINARY VALUE 1.

      ** Authentication Method
       10  MQAUTHENTICATE-OS   PIC S9(9) BINARY VALUE 0.
       10  MQAUTHENTICATE-PAM   PIC S9(9) BINARY VALUE 1.

      ** QMgr LDAP Connection Status
       10  MQLDAPC-INACTIVE   PIC S9(9) BINARY VALUE 0.
       10  MQLDAPC-CONNECTED   PIC S9(9) BINARY VALUE 1.
       10  MQLDAPC-ERROR   PIC S9(9) BINARY VALUE 2.

      ** Selector types
       10  MQSELTYPE-NONE   PIC S9(9) BINARY VALUE 0.
       10  MQSELTYPE-STANDARD   PIC S9(9) BINARY VALUE 1.
       10  MQSELTYPE-EXTENDED   PIC S9(9) BINARY VALUE 2.

      ** CHLAUTH QMGR State
       10  MQCHLA-DISABLED   PIC S9(9) BINARY VALUE 0.
       10  MQCHLA-ENABLED   PIC S9(9) BINARY VALUE 1.

      ** REVDNS QMGR State
       10  MQRDNS-ENABLED   PIC S9(9) BINARY VALUE 0.
       10  MQRDNS-DISABLED   PIC S9(9) BINARY VALUE 1.

      ** CLROUTE Topic State
       10  MQCLROUTE-DIRECT   PIC S9(9) BINARY VALUE 0.
       10  MQCLROUTE-TOPIC-HOST   PIC S9(9) BINARY VALUE 1.
       10  MQCLROUTE-NONE   PIC S9(9) BINARY VALUE 2.

      ** CLSTATE Clustered Topic Definition State
       10  MQCLST-ACTIVE   PIC S9(9) BINARY VALUE 0.
       10  MQCLST-PENDING   PIC S9(9) BINARY VALUE 1.
       10  MQCLST-INVALID   PIC S9(9) BINARY VALUE 2.
       10  MQCLST-ERROR   PIC S9(9) BINARY VALUE 3.

      ** Transmission queue types
       10  MQCLXQ-SCTQ   PIC S9(9) BINARY VALUE 0.
       10  MQCLXQ-CHANNEL   PIC S9(9) BINARY VALUE 1.

      ** Suspend Status
       10  MQSUS-YES   PIC S9(9) BINARY VALUE 1.
       10  MQSUS-NO   PIC S9(9) BINARY VALUE 0.

      ** Syncpoint values for Pub/Sub migration
       10  MQSYNCPOINT-YES   PIC S9(9) BINARY VALUE 0.
       10  MQSYNCPOINT-IFPER   PIC S9(9) BINARY VALUE 1.

      ** System Parameter Values
       10  MQSYSP-NO   PIC S9(9) BINARY VALUE 0.
       10  MQSYSP-YES   PIC S9(9) BINARY VALUE 1.
       10  MQSYSP-EXTENDED   PIC S9(9) BINARY VALUE 2.
       10  MQSYSP-TYPE-INITIAL   PIC S9(9) BINARY VALUE 10.
       10  MQSYSP-TYPE-SET   PIC S9(9) BINARY VALUE 11.
       10  MQSYSP-TYPE-LOG-COPY   PIC S9(9) BINARY VALUE 12.
       10  MQSYSP-TYPE-LOG-STATUS   PIC S9(9) BINARY VALUE 13.
       10  MQSYSP-TYPE-ARCHIVE-TAPE   PIC S9(9) BINARY VALUE 14.
       10  MQSYSP-ALLOC-BLK   PIC S9(9) BINARY VALUE 20.
       10  MQSYSP-ALLOC-TRK   PIC S9(9) BINARY VALUE 21.
       10  MQSYSP-ALLOC-CYL   PIC S9(9) BINARY VALUE 22.
       10  MQSYSP-STATUS-BUSY   PIC S9(9) BINARY VALUE 30.
       10  MQSYSP-STATUS-PREMOUNT   PIC S9(9) BINARY VALUE 31.
       10  MQSYSP-STATUS-AVAILABLE   PIC S9(9) BINARY VALUE 32.
       10  MQSYSP-STATUS-UNKNOWN   PIC S9(9) BINARY VALUE 33.
       10  MQSYSP-STATUS-ALLOC-ARCHIVE   PIC S9(9) BINARY VALUE 34.
       10  MQSYSP-STATUS-COPYING-BSDS   PIC S9(9) BINARY VALUE 35.
       10  MQSYSP-STATUS-COPYING-LOG   PIC S9(9) BINARY VALUE 36.

      ** Export Type
       10  MQEXT-ALL   PIC S9(9) BINARY VALUE 0.
       10  MQEXT-OBJECT   PIC S9(9) BINARY VALUE 1.
       10  MQEXT-AUTHORITY   PIC S9(9) BINARY VALUE 2.

      ** Export Attrs
       10  MQEXTATTRS-ALL   PIC S9(9) BINARY VALUE 0.
       10  MQEXTATTRS-NONDEF   PIC S9(9) BINARY VALUE 1.

      ** System Objects
       10  MQSYSOBJ-YES   PIC S9(9) BINARY VALUE 0.
       10  MQSYSOBJ-NO   PIC S9(9) BINARY VALUE 1.

      ** Subscription Types
       10  MQSUBTYPE-API   PIC S9(9) BINARY VALUE 1.
       10  MQSUBTYPE-ADMIN   PIC S9(9) BINARY VALUE 2.
       10  MQSUBTYPE-PROXY   PIC S9(9) BINARY VALUE 3.
       10  MQSUBTYPE-ALL   PIC S9(9) BINARY VALUE -1.
       10  MQSUBTYPE-USER   PIC S9(9) BINARY VALUE -2.

      ** Display Subscription Types
       10  MQDOPT-RESOLVED   PIC S9(9) BINARY VALUE 0.
       10  MQDOPT-DEFINED   PIC S9(9) BINARY VALUE 1.

      ** Time units
       10  MQTIME-UNIT-MINS   PIC S9(9) BINARY VALUE 0.
       10  MQTIME-UNIT-SECS   PIC S9(9) BINARY VALUE 1.

      ** User ID Support
       10  MQUIDSUPP-NO   PIC S9(9) BINARY VALUE 0.
       10  MQUIDSUPP-YES   PIC S9(9) BINARY VALUE 1.

      ** Undelivered values for Pub/Sub migration
       10  MQUNDELIVERED-NORMAL   PIC S9(9) BINARY VALUE 0.
       10  MQUNDELIVERED-SAFE   PIC S9(9) BINARY VALUE 1.
       10  MQUNDELIVERED-DISCARD   PIC S9(9) BINARY VALUE 2.
       10  MQUNDELIVERED-KEEP   PIC S9(9) BINARY VALUE 3.

      ** UOW States
       10  MQUOWST-NONE   PIC S9(9) BINARY VALUE 0.
       10  MQUOWST-ACTIVE   PIC S9(9) BINARY VALUE 1.
       10  MQUOWST-PREPARED   PIC S9(9) BINARY VALUE 2.
       10  MQUOWST-UNRESOLVED   PIC S9(9) BINARY VALUE 3.

      ** UOW Types
       10  MQUOWT-Q-MGR   PIC S9(9) BINARY VALUE 0.
       10  MQUOWT-CICS   PIC S9(9) BINARY VALUE 1.
       10  MQUOWT-RRS   PIC S9(9) BINARY VALUE 2.
       10  MQUOWT-IMS   PIC S9(9) BINARY VALUE 3.
       10  MQUOWT-XA   PIC S9(9) BINARY VALUE 4.

      ** Page Set Usage Values
       10  MQUSAGE-PS-AVAILABLE   PIC S9(9) BINARY VALUE 0.
       10  MQUSAGE-PS-DEFINED   PIC S9(9) BINARY VALUE 1.
       10  MQUSAGE-PS-OFFLINE   PIC S9(9) BINARY VALUE 2.
       10  MQUSAGE-PS-NOT-DEFINED   PIC S9(9) BINARY VALUE 3.
       10  MQUSAGE-PS-SUSPENDED   PIC S9(9) BINARY VALUE 4.

      ** Expand Usage Values
       10  MQUSAGE-EXPAND-USER   PIC S9(9) BINARY VALUE 1.
       10  MQUSAGE-EXPAND-SYSTEM   PIC S9(9) BINARY VALUE 2.
       10  MQUSAGE-EXPAND-NONE   PIC S9(9) BINARY VALUE 3.

      ** Data Set Usage Values
       10  MQUSAGE-DS-OLDEST-ACTIVE-UOW   PIC S9(9) BINARY VALUE 10.
       10  MQUSAGE-DS-OLDEST-PS-RECOVERY   PIC S9(9) BINARY VALUE 11.
       10  MQUSAGE-DS-OLDEST-CF-RECOVERY   PIC S9(9) BINARY VALUE 12.

      ** Multicast Properties Options
       10  MQMCP-REPLY   PIC S9(9) BINARY VALUE 2.
       10  MQMCP-USER   PIC S9(9) BINARY VALUE 1.
       10  MQMCP-NONE   PIC S9(9) BINARY VALUE 0.
       10  MQMCP-ALL   PIC S9(9) BINARY VALUE -1.
       10  MQMCP-COMPAT   PIC S9(9) BINARY VALUE -2.

      ** Multicast New Subscriber History Options
       10  MQNSH-NONE   PIC S9(9) BINARY VALUE 0.
       10  MQNSH-ALL   PIC S9(9) BINARY VALUE -1.

      ** Reduce Log Options
       10  MQLR-ONE   PIC S9(9) BINARY VALUE 1.
       10  MQLR-AUTO   PIC S9(9) BINARY VALUE -1.
       10  MQLR-MAX   PIC S9(9) BINARY VALUE -2.

      ******************************************************************
      **  Values Related to Trace-route and Activity Operations    
      ******************************************************************
      ** Activity Operations
       10  MQOPER-SYSTEM-FIRST   PIC S9(9) BINARY VALUE 0.
       10  MQOPER-UNKNOWN   PIC S9(9) BINARY VALUE 0.
       10  MQOPER-BROWSE   PIC S9(9) BINARY VALUE 1.
       10  MQOPER-DISCARD   PIC S9(9) BINARY VALUE 2.
       10  MQOPER-GET   PIC S9(9) BINARY VALUE 3.
       10  MQOPER-PUT   PIC S9(9) BINARY VALUE 4.
       10  MQOPER-PUT-REPLY   PIC S9(9) BINARY VALUE 5.
       10  MQOPER-PUT-REPORT   PIC S9(9) BINARY VALUE 6.
       10  MQOPER-RECEIVE   PIC S9(9) BINARY VALUE 7.
       10  MQOPER-SEND   PIC S9(9) BINARY VALUE 8.
       10  MQOPER-TRANSFORM   PIC S9(9) BINARY VALUE 9.
       10  MQOPER-PUBLISH   PIC S9(9) BINARY VALUE 10.
       10  MQOPER-EXCLUDED-PUBLISH   PIC S9(9) BINARY VALUE 11.
       10  MQOPER-DISCARDED-PUBLISH   PIC S9(9) BINARY VALUE 12.
       10  MQOPER-SYSTEM-LAST   PIC S9(9) BINARY VALUE 65535.
       10  MQOPER-APPL-FIRST   PIC S9(9) BINARY VALUE 65536.
       10  MQOPER-APPL-LAST   PIC S9(9) BINARY VALUE 999999999.

      ** Trace-route Max Activities (MQIACF_MAX_ACTIVITIES)
       10  MQROUTE-UNLIMITED-ACTIVITIES   PIC S9(9) BINARY VALUE 0.

      ** Trace-route Detail (MQIACF_ROUTE_DETAIL)
       10  MQROUTE-DETAIL-LOW   PIC S9(9) BINARY VALUE 2.
       10  MQROUTE-DETAIL-MEDIUM   PIC S9(9) BINARY VALUE 8.
       10  MQROUTE-DETAIL-HIGH   PIC S9(9) BINARY VALUE 32.

      ** Trace-route Forwarding (MQIACF_ROUTE_FORWARDING)
       10  MQROUTE-FORWARD-ALL   PIC S9(9) BINARY VALUE 256.
       10  MQROUTE-FORWARD-IF-SUPPORTED   PIC S9(9) BINARY VALUE 512.
       10  MQROUTE-FORWARD-REJ-UNSUP-MASK   PIC S9(9) BINARY
           VALUE -65536.

      ** Trace-route Delivery (MQIACF_ROUTE_DELIVERY)
       10  MQROUTE-DELIVER-YES   PIC S9(9) BINARY VALUE 4096.
       10  MQROUTE-DELIVER-NO   PIC S9(9) BINARY VALUE 8192.
       10  MQROUTE-DELIVER-REJ-UNSUP-MASK   PIC S9(9) BINARY
           VALUE -65536.

      ** Trace-route Accumulation (MQIACF_ROUTE_ACCUMULATION)
       10  MQROUTE-ACCUMULATE-NONE   PIC S9(9) BINARY VALUE 65539.
       10  MQROUTE-ACCUMULATE-IN-MSG   PIC S9(9) BINARY VALUE 65540.
       10  MQROUTE-ACCUMULATE-AND-REPLY   PIC S9(9) BINARY VALUE 65541.

      ******************************************************************
      **  Values Related to Publish/Subscribe                      
      ******************************************************************
      ** Delete Options
       10  MQDELO-NONE   PIC S9(9) BINARY VALUE 0.
       10  MQDELO-LOCAL   PIC S9(9) BINARY VALUE 4.

      ** Publication Options
       10  MQPUBO-NONE   PIC S9(9) BINARY VALUE 0.
       10  MQPUBO-CORREL-ID-AS-IDENTITY   PIC S9(9) BINARY VALUE 1.
       10  MQPUBO-RETAIN-PUBLICATION   PIC S9(9) BINARY VALUE 2.
       10  MQPUBO-OTHER-SUBSCRIBERS-ONLY   PIC S9(9) BINARY VALUE 4.
       10  MQPUBO-NO-REGISTRATION   PIC S9(9) BINARY VALUE 8.
       10  MQPUBO-IS-RETAINED-PUBLICATION   PIC S9(9) BINARY VALUE 16.

      ** Registration Options
       10  MQREGO-NONE   PIC S9(9) BINARY VALUE 0.
       10  MQREGO-CORREL-ID-AS-IDENTITY   PIC S9(9) BINARY VALUE 1.
       10  MQREGO-ANONYMOUS   PIC S9(9) BINARY VALUE 2.
       10  MQREGO-LOCAL   PIC S9(9) BINARY VALUE 4.
       10  MQREGO-DIRECT-REQUESTS   PIC S9(9) BINARY VALUE 8.
       10  MQREGO-NEW-PUBLICATIONS-ONLY   PIC S9(9) BINARY VALUE 16.
       10  MQREGO-PUBLISH-ON-REQUEST-ONLY   PIC S9(9) BINARY VALUE 32.
       10  MQREGO-DEREGISTER-ALL   PIC S9(9) BINARY VALUE 64.
       10  MQREGO-INCLUDE-STREAM-NAME   PIC S9(9) BINARY VALUE 128.
       10  MQREGO-INFORM-IF-RETAINED   PIC S9(9) BINARY VALUE 256.
       10  MQREGO-DUPLICATES-OK   PIC S9(9) BINARY VALUE 512.
       10  MQREGO-NON-PERSISTENT   PIC S9(9) BINARY VALUE 1024.
       10  MQREGO-PERSISTENT   PIC S9(9) BINARY VALUE 2048.
       10  MQREGO-PERSISTENT-AS-PUBLISH   PIC S9(9) BINARY VALUE 4096.
       10  MQREGO-PERSISTENT-AS-Q   PIC S9(9) BINARY VALUE 8192.
       10  MQREGO-ADD-NAME   PIC S9(9) BINARY VALUE 16384.
       10  MQREGO-NO-ALTERATION   PIC S9(9) BINARY VALUE 32768.
       10  MQREGO-FULL-RESPONSE   PIC S9(9) BINARY VALUE 65536.
       10  MQREGO-JOIN-SHARED   PIC S9(9) BINARY VALUE 131072.
       10  MQREGO-JOIN-EXCLUSIVE   PIC S9(9) BINARY VALUE 262144.
       10  MQREGO-LEAVE-ONLY   PIC S9(9) BINARY VALUE 524288.
       10  MQREGO-VARIABLE-USER-ID   PIC S9(9) BINARY VALUE 1048576.
       10  MQREGO-LOCKED   PIC S9(9) BINARY VALUE 2097152.

      ** User Attribute Selectors
       10  MQUA-FIRST   PIC S9(9) BINARY VALUE 65536.
       10  MQUA-LAST   PIC S9(9) BINARY VALUE 999999999.

      ** Grouped Units of Recovery
       10  MQGUR-DISABLED   PIC S9(9) BINARY VALUE 0.
       10  MQGUR-ENABLED   PIC S9(9) BINARY VALUE 1.

      ** Measured usage by API
       10  MQMULC-STANDARD   PIC S9(9) BINARY VALUE 0.
       10  MQMULC-REFINED   PIC S9(9) BINARY VALUE 1.

      ** Multi-instance Queue Managers
       10  MQSTDBY-NOT-PERMITTED   PIC S9(9) BINARY VALUE 0.
       10  MQSTDBY-PERMITTED   PIC S9(9) BINARY VALUE 1.



      ******************************************************************
      **  End of CMQCFV                                               **
      ******************************************************************
